# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'ExtenderWanExtension',
    'ExtenderprofileCellular',
    'ExtenderprofileCellularControllerReport',
    'ExtenderprofileCellularDataplan',
    'ExtenderprofileCellularModem1',
    'ExtenderprofileCellularModem1AutoSwitch',
    'ExtenderprofileCellularModem2',
    'ExtenderprofileCellularModem2AutoSwitch',
    'ExtenderprofileCellularSmsNotification',
    'ExtenderprofileCellularSmsNotificationAlert',
    'ExtenderprofileCellularSmsNotificationReceiver',
    'ExtenderprofileLanExtension',
    'ExtenderprofileLanExtensionBackhaul',
    'FortigateprofileLanExtension',
]

@pulumi.output_type
class ExtenderWanExtension(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "modem1Extension":
            suggest = "modem1_extension"
        elif key == "modem2Extension":
            suggest = "modem2_extension"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ExtenderWanExtension. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ExtenderWanExtension.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ExtenderWanExtension.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 modem1_extension: Optional[str] = None,
                 modem2_extension: Optional[str] = None):
        """
        :param str modem1_extension: FortiExtender interface name.
        :param str modem2_extension: FortiExtender interface name.
        """
        if modem1_extension is not None:
            pulumi.set(__self__, "modem1_extension", modem1_extension)
        if modem2_extension is not None:
            pulumi.set(__self__, "modem2_extension", modem2_extension)

    @property
    @pulumi.getter(name="modem1Extension")
    def modem1_extension(self) -> Optional[str]:
        """
        FortiExtender interface name.
        """
        return pulumi.get(self, "modem1_extension")

    @property
    @pulumi.getter(name="modem2Extension")
    def modem2_extension(self) -> Optional[str]:
        """
        FortiExtender interface name.
        """
        return pulumi.get(self, "modem2_extension")


@pulumi.output_type
class ExtenderprofileCellular(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "controllerReport":
            suggest = "controller_report"
        elif key == "smsNotification":
            suggest = "sms_notification"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ExtenderprofileCellular. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ExtenderprofileCellular.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ExtenderprofileCellular.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 controller_report: Optional['outputs.ExtenderprofileCellularControllerReport'] = None,
                 dataplans: Optional[Sequence['outputs.ExtenderprofileCellularDataplan']] = None,
                 modem1: Optional['outputs.ExtenderprofileCellularModem1'] = None,
                 modem2: Optional['outputs.ExtenderprofileCellularModem2'] = None,
                 sms_notification: Optional['outputs.ExtenderprofileCellularSmsNotification'] = None):
        """
        :param 'ExtenderprofileCellularControllerReportArgs' controller_report: FortiExtender controller report configuration. The structure of `controller_report` block is documented below.
        :param Sequence['ExtenderprofileCellularDataplanArgs'] dataplans: Dataplan names. The structure of `dataplan` block is documented below.
        :param 'ExtenderprofileCellularModem1Args' modem1: Configuration options for modem 1. The structure of `modem1` block is documented below.
        :param 'ExtenderprofileCellularModem2Args' modem2: Configuration options for modem 2. The structure of `modem2` block is documented below.
        :param 'ExtenderprofileCellularSmsNotificationArgs' sms_notification: FortiExtender cellular SMS notification configuration. The structure of `sms_notification` block is documented below.
        """
        if controller_report is not None:
            pulumi.set(__self__, "controller_report", controller_report)
        if dataplans is not None:
            pulumi.set(__self__, "dataplans", dataplans)
        if modem1 is not None:
            pulumi.set(__self__, "modem1", modem1)
        if modem2 is not None:
            pulumi.set(__self__, "modem2", modem2)
        if sms_notification is not None:
            pulumi.set(__self__, "sms_notification", sms_notification)

    @property
    @pulumi.getter(name="controllerReport")
    def controller_report(self) -> Optional['outputs.ExtenderprofileCellularControllerReport']:
        """
        FortiExtender controller report configuration. The structure of `controller_report` block is documented below.
        """
        return pulumi.get(self, "controller_report")

    @property
    @pulumi.getter
    def dataplans(self) -> Optional[Sequence['outputs.ExtenderprofileCellularDataplan']]:
        """
        Dataplan names. The structure of `dataplan` block is documented below.
        """
        return pulumi.get(self, "dataplans")

    @property
    @pulumi.getter
    def modem1(self) -> Optional['outputs.ExtenderprofileCellularModem1']:
        """
        Configuration options for modem 1. The structure of `modem1` block is documented below.
        """
        return pulumi.get(self, "modem1")

    @property
    @pulumi.getter
    def modem2(self) -> Optional['outputs.ExtenderprofileCellularModem2']:
        """
        Configuration options for modem 2. The structure of `modem2` block is documented below.
        """
        return pulumi.get(self, "modem2")

    @property
    @pulumi.getter(name="smsNotification")
    def sms_notification(self) -> Optional['outputs.ExtenderprofileCellularSmsNotification']:
        """
        FortiExtender cellular SMS notification configuration. The structure of `sms_notification` block is documented below.
        """
        return pulumi.get(self, "sms_notification")


@pulumi.output_type
class ExtenderprofileCellularControllerReport(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "signalThreshold":
            suggest = "signal_threshold"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ExtenderprofileCellularControllerReport. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ExtenderprofileCellularControllerReport.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ExtenderprofileCellularControllerReport.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 interval: Optional[int] = None,
                 signal_threshold: Optional[int] = None,
                 status: Optional[str] = None):
        """
        :param int interval: Controller report interval.
        :param int signal_threshold: Controller report signal threshold.
        :param str status: FortiExtender controller report status. Valid values: `disable`, `enable`.
        """
        if interval is not None:
            pulumi.set(__self__, "interval", interval)
        if signal_threshold is not None:
            pulumi.set(__self__, "signal_threshold", signal_threshold)
        if status is not None:
            pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter
    def interval(self) -> Optional[int]:
        """
        Controller report interval.
        """
        return pulumi.get(self, "interval")

    @property
    @pulumi.getter(name="signalThreshold")
    def signal_threshold(self) -> Optional[int]:
        """
        Controller report signal threshold.
        """
        return pulumi.get(self, "signal_threshold")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        FortiExtender controller report status. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "status")


@pulumi.output_type
class ExtenderprofileCellularDataplan(dict):
    def __init__(__self__, *,
                 name: Optional[str] = None):
        """
        :param str name: Dataplan name.
        """
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Dataplan name.
        """
        return pulumi.get(self, "name")


@pulumi.output_type
class ExtenderprofileCellularModem1(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "autoSwitch":
            suggest = "auto_switch"
        elif key == "connStatus":
            suggest = "conn_status"
        elif key == "defaultSim":
            suggest = "default_sim"
        elif key == "preferredCarrier":
            suggest = "preferred_carrier"
        elif key == "redundantIntf":
            suggest = "redundant_intf"
        elif key == "redundantMode":
            suggest = "redundant_mode"
        elif key == "sim1Pin":
            suggest = "sim1_pin"
        elif key == "sim1PinCode":
            suggest = "sim1_pin_code"
        elif key == "sim2Pin":
            suggest = "sim2_pin"
        elif key == "sim2PinCode":
            suggest = "sim2_pin_code"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ExtenderprofileCellularModem1. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ExtenderprofileCellularModem1.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ExtenderprofileCellularModem1.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 auto_switch: Optional['outputs.ExtenderprofileCellularModem1AutoSwitch'] = None,
                 conn_status: Optional[int] = None,
                 default_sim: Optional[str] = None,
                 gps: Optional[str] = None,
                 preferred_carrier: Optional[str] = None,
                 redundant_intf: Optional[str] = None,
                 redundant_mode: Optional[str] = None,
                 sim1_pin: Optional[str] = None,
                 sim1_pin_code: Optional[str] = None,
                 sim2_pin: Optional[str] = None,
                 sim2_pin_code: Optional[str] = None):
        """
        :param 'ExtenderprofileCellularModem1AutoSwitchArgs' auto_switch: FortiExtender auto switch configuration. The structure of `auto_switch` block is documented below.
        :param int conn_status: Connection status.
        :param str default_sim: Default SIM selection. Valid values: `sim1`, `sim2`, `carrier`, `cost`.
        :param str gps: FortiExtender GPS enable/disable. Valid values: `disable`, `enable`.
        :param str preferred_carrier: Preferred carrier.
        :param str redundant_intf: Redundant interface.
        :param str redundant_mode: FortiExtender mode. Valid values: `disable`, `enable`.
        :param str sim1_pin: SIM #1 PIN status. Valid values: `disable`, `enable`.
        :param str sim1_pin_code: SIM #1 PIN password.
        :param str sim2_pin: SIM #2 PIN status. Valid values: `disable`, `enable`.
        :param str sim2_pin_code: SIM #2 PIN password.
        """
        if auto_switch is not None:
            pulumi.set(__self__, "auto_switch", auto_switch)
        if conn_status is not None:
            pulumi.set(__self__, "conn_status", conn_status)
        if default_sim is not None:
            pulumi.set(__self__, "default_sim", default_sim)
        if gps is not None:
            pulumi.set(__self__, "gps", gps)
        if preferred_carrier is not None:
            pulumi.set(__self__, "preferred_carrier", preferred_carrier)
        if redundant_intf is not None:
            pulumi.set(__self__, "redundant_intf", redundant_intf)
        if redundant_mode is not None:
            pulumi.set(__self__, "redundant_mode", redundant_mode)
        if sim1_pin is not None:
            pulumi.set(__self__, "sim1_pin", sim1_pin)
        if sim1_pin_code is not None:
            pulumi.set(__self__, "sim1_pin_code", sim1_pin_code)
        if sim2_pin is not None:
            pulumi.set(__self__, "sim2_pin", sim2_pin)
        if sim2_pin_code is not None:
            pulumi.set(__self__, "sim2_pin_code", sim2_pin_code)

    @property
    @pulumi.getter(name="autoSwitch")
    def auto_switch(self) -> Optional['outputs.ExtenderprofileCellularModem1AutoSwitch']:
        """
        FortiExtender auto switch configuration. The structure of `auto_switch` block is documented below.
        """
        return pulumi.get(self, "auto_switch")

    @property
    @pulumi.getter(name="connStatus")
    def conn_status(self) -> Optional[int]:
        """
        Connection status.
        """
        return pulumi.get(self, "conn_status")

    @property
    @pulumi.getter(name="defaultSim")
    def default_sim(self) -> Optional[str]:
        """
        Default SIM selection. Valid values: `sim1`, `sim2`, `carrier`, `cost`.
        """
        return pulumi.get(self, "default_sim")

    @property
    @pulumi.getter
    def gps(self) -> Optional[str]:
        """
        FortiExtender GPS enable/disable. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "gps")

    @property
    @pulumi.getter(name="preferredCarrier")
    def preferred_carrier(self) -> Optional[str]:
        """
        Preferred carrier.
        """
        return pulumi.get(self, "preferred_carrier")

    @property
    @pulumi.getter(name="redundantIntf")
    def redundant_intf(self) -> Optional[str]:
        """
        Redundant interface.
        """
        return pulumi.get(self, "redundant_intf")

    @property
    @pulumi.getter(name="redundantMode")
    def redundant_mode(self) -> Optional[str]:
        """
        FortiExtender mode. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "redundant_mode")

    @property
    @pulumi.getter(name="sim1Pin")
    def sim1_pin(self) -> Optional[str]:
        """
        SIM #1 PIN status. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "sim1_pin")

    @property
    @pulumi.getter(name="sim1PinCode")
    def sim1_pin_code(self) -> Optional[str]:
        """
        SIM #1 PIN password.
        """
        return pulumi.get(self, "sim1_pin_code")

    @property
    @pulumi.getter(name="sim2Pin")
    def sim2_pin(self) -> Optional[str]:
        """
        SIM #2 PIN status. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "sim2_pin")

    @property
    @pulumi.getter(name="sim2PinCode")
    def sim2_pin_code(self) -> Optional[str]:
        """
        SIM #2 PIN password.
        """
        return pulumi.get(self, "sim2_pin_code")


@pulumi.output_type
class ExtenderprofileCellularModem1AutoSwitch(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "disconnectPeriod":
            suggest = "disconnect_period"
        elif key == "disconnectThreshold":
            suggest = "disconnect_threshold"
        elif key == "switchBack":
            suggest = "switch_back"
        elif key == "switchBackTime":
            suggest = "switch_back_time"
        elif key == "switchBackTimer":
            suggest = "switch_back_timer"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ExtenderprofileCellularModem1AutoSwitch. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ExtenderprofileCellularModem1AutoSwitch.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ExtenderprofileCellularModem1AutoSwitch.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 dataplan: Optional[str] = None,
                 disconnect: Optional[str] = None,
                 disconnect_period: Optional[int] = None,
                 disconnect_threshold: Optional[int] = None,
                 signal: Optional[str] = None,
                 switch_back: Optional[str] = None,
                 switch_back_time: Optional[str] = None,
                 switch_back_timer: Optional[int] = None):
        """
        :param str dataplan: Automatically switch based on data usage. Valid values: `disable`, `enable`.
        :param str disconnect: Auto switch by disconnect. Valid values: `disable`, `enable`.
        :param int disconnect_period: Automatically switch based on disconnect period.
        :param int disconnect_threshold: Automatically switch based on disconnect threshold.
        :param str signal: Automatically switch based on signal strength. Valid values: `disable`, `enable`.
        :param str switch_back: Auto switch with switch back multi-options. Valid values: `time`, `timer`.
        :param str switch_back_time: Automatically switch over to preferred SIM/carrier at a specified time in UTC (HH:MM).
        :param int switch_back_timer: Automatically switch over to preferred SIM/carrier after the given time (3600 - 2147483647 sec).
        """
        if dataplan is not None:
            pulumi.set(__self__, "dataplan", dataplan)
        if disconnect is not None:
            pulumi.set(__self__, "disconnect", disconnect)
        if disconnect_period is not None:
            pulumi.set(__self__, "disconnect_period", disconnect_period)
        if disconnect_threshold is not None:
            pulumi.set(__self__, "disconnect_threshold", disconnect_threshold)
        if signal is not None:
            pulumi.set(__self__, "signal", signal)
        if switch_back is not None:
            pulumi.set(__self__, "switch_back", switch_back)
        if switch_back_time is not None:
            pulumi.set(__self__, "switch_back_time", switch_back_time)
        if switch_back_timer is not None:
            pulumi.set(__self__, "switch_back_timer", switch_back_timer)

    @property
    @pulumi.getter
    def dataplan(self) -> Optional[str]:
        """
        Automatically switch based on data usage. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "dataplan")

    @property
    @pulumi.getter
    def disconnect(self) -> Optional[str]:
        """
        Auto switch by disconnect. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "disconnect")

    @property
    @pulumi.getter(name="disconnectPeriod")
    def disconnect_period(self) -> Optional[int]:
        """
        Automatically switch based on disconnect period.
        """
        return pulumi.get(self, "disconnect_period")

    @property
    @pulumi.getter(name="disconnectThreshold")
    def disconnect_threshold(self) -> Optional[int]:
        """
        Automatically switch based on disconnect threshold.
        """
        return pulumi.get(self, "disconnect_threshold")

    @property
    @pulumi.getter
    def signal(self) -> Optional[str]:
        """
        Automatically switch based on signal strength. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "signal")

    @property
    @pulumi.getter(name="switchBack")
    def switch_back(self) -> Optional[str]:
        """
        Auto switch with switch back multi-options. Valid values: `time`, `timer`.
        """
        return pulumi.get(self, "switch_back")

    @property
    @pulumi.getter(name="switchBackTime")
    def switch_back_time(self) -> Optional[str]:
        """
        Automatically switch over to preferred SIM/carrier at a specified time in UTC (HH:MM).
        """
        return pulumi.get(self, "switch_back_time")

    @property
    @pulumi.getter(name="switchBackTimer")
    def switch_back_timer(self) -> Optional[int]:
        """
        Automatically switch over to preferred SIM/carrier after the given time (3600 - 2147483647 sec).
        """
        return pulumi.get(self, "switch_back_timer")


@pulumi.output_type
class ExtenderprofileCellularModem2(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "autoSwitch":
            suggest = "auto_switch"
        elif key == "connStatus":
            suggest = "conn_status"
        elif key == "defaultSim":
            suggest = "default_sim"
        elif key == "preferredCarrier":
            suggest = "preferred_carrier"
        elif key == "redundantIntf":
            suggest = "redundant_intf"
        elif key == "redundantMode":
            suggest = "redundant_mode"
        elif key == "sim1Pin":
            suggest = "sim1_pin"
        elif key == "sim1PinCode":
            suggest = "sim1_pin_code"
        elif key == "sim2Pin":
            suggest = "sim2_pin"
        elif key == "sim2PinCode":
            suggest = "sim2_pin_code"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ExtenderprofileCellularModem2. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ExtenderprofileCellularModem2.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ExtenderprofileCellularModem2.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 auto_switch: Optional['outputs.ExtenderprofileCellularModem2AutoSwitch'] = None,
                 conn_status: Optional[int] = None,
                 default_sim: Optional[str] = None,
                 gps: Optional[str] = None,
                 preferred_carrier: Optional[str] = None,
                 redundant_intf: Optional[str] = None,
                 redundant_mode: Optional[str] = None,
                 sim1_pin: Optional[str] = None,
                 sim1_pin_code: Optional[str] = None,
                 sim2_pin: Optional[str] = None,
                 sim2_pin_code: Optional[str] = None):
        """
        :param 'ExtenderprofileCellularModem2AutoSwitchArgs' auto_switch: FortiExtender auto switch configuration. The structure of `auto_switch` block is documented below.
        :param int conn_status: Connection status.
        :param str default_sim: Default SIM selection. Valid values: `sim1`, `sim2`, `carrier`, `cost`.
        :param str gps: FortiExtender GPS enable/disable. Valid values: `disable`, `enable`.
        :param str preferred_carrier: Preferred carrier.
        :param str redundant_intf: Redundant interface.
        :param str redundant_mode: FortiExtender mode. Valid values: `disable`, `enable`.
        :param str sim1_pin: SIM #1 PIN status. Valid values: `disable`, `enable`.
        :param str sim1_pin_code: SIM #1 PIN password.
        :param str sim2_pin: SIM #2 PIN status. Valid values: `disable`, `enable`.
        :param str sim2_pin_code: SIM #2 PIN password.
        """
        if auto_switch is not None:
            pulumi.set(__self__, "auto_switch", auto_switch)
        if conn_status is not None:
            pulumi.set(__self__, "conn_status", conn_status)
        if default_sim is not None:
            pulumi.set(__self__, "default_sim", default_sim)
        if gps is not None:
            pulumi.set(__self__, "gps", gps)
        if preferred_carrier is not None:
            pulumi.set(__self__, "preferred_carrier", preferred_carrier)
        if redundant_intf is not None:
            pulumi.set(__self__, "redundant_intf", redundant_intf)
        if redundant_mode is not None:
            pulumi.set(__self__, "redundant_mode", redundant_mode)
        if sim1_pin is not None:
            pulumi.set(__self__, "sim1_pin", sim1_pin)
        if sim1_pin_code is not None:
            pulumi.set(__self__, "sim1_pin_code", sim1_pin_code)
        if sim2_pin is not None:
            pulumi.set(__self__, "sim2_pin", sim2_pin)
        if sim2_pin_code is not None:
            pulumi.set(__self__, "sim2_pin_code", sim2_pin_code)

    @property
    @pulumi.getter(name="autoSwitch")
    def auto_switch(self) -> Optional['outputs.ExtenderprofileCellularModem2AutoSwitch']:
        """
        FortiExtender auto switch configuration. The structure of `auto_switch` block is documented below.
        """
        return pulumi.get(self, "auto_switch")

    @property
    @pulumi.getter(name="connStatus")
    def conn_status(self) -> Optional[int]:
        """
        Connection status.
        """
        return pulumi.get(self, "conn_status")

    @property
    @pulumi.getter(name="defaultSim")
    def default_sim(self) -> Optional[str]:
        """
        Default SIM selection. Valid values: `sim1`, `sim2`, `carrier`, `cost`.
        """
        return pulumi.get(self, "default_sim")

    @property
    @pulumi.getter
    def gps(self) -> Optional[str]:
        """
        FortiExtender GPS enable/disable. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "gps")

    @property
    @pulumi.getter(name="preferredCarrier")
    def preferred_carrier(self) -> Optional[str]:
        """
        Preferred carrier.
        """
        return pulumi.get(self, "preferred_carrier")

    @property
    @pulumi.getter(name="redundantIntf")
    def redundant_intf(self) -> Optional[str]:
        """
        Redundant interface.
        """
        return pulumi.get(self, "redundant_intf")

    @property
    @pulumi.getter(name="redundantMode")
    def redundant_mode(self) -> Optional[str]:
        """
        FortiExtender mode. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "redundant_mode")

    @property
    @pulumi.getter(name="sim1Pin")
    def sim1_pin(self) -> Optional[str]:
        """
        SIM #1 PIN status. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "sim1_pin")

    @property
    @pulumi.getter(name="sim1PinCode")
    def sim1_pin_code(self) -> Optional[str]:
        """
        SIM #1 PIN password.
        """
        return pulumi.get(self, "sim1_pin_code")

    @property
    @pulumi.getter(name="sim2Pin")
    def sim2_pin(self) -> Optional[str]:
        """
        SIM #2 PIN status. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "sim2_pin")

    @property
    @pulumi.getter(name="sim2PinCode")
    def sim2_pin_code(self) -> Optional[str]:
        """
        SIM #2 PIN password.
        """
        return pulumi.get(self, "sim2_pin_code")


@pulumi.output_type
class ExtenderprofileCellularModem2AutoSwitch(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "disconnectPeriod":
            suggest = "disconnect_period"
        elif key == "disconnectThreshold":
            suggest = "disconnect_threshold"
        elif key == "switchBack":
            suggest = "switch_back"
        elif key == "switchBackTime":
            suggest = "switch_back_time"
        elif key == "switchBackTimer":
            suggest = "switch_back_timer"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ExtenderprofileCellularModem2AutoSwitch. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ExtenderprofileCellularModem2AutoSwitch.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ExtenderprofileCellularModem2AutoSwitch.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 dataplan: Optional[str] = None,
                 disconnect: Optional[str] = None,
                 disconnect_period: Optional[int] = None,
                 disconnect_threshold: Optional[int] = None,
                 signal: Optional[str] = None,
                 switch_back: Optional[str] = None,
                 switch_back_time: Optional[str] = None,
                 switch_back_timer: Optional[int] = None):
        """
        :param str dataplan: Automatically switch based on data usage. Valid values: `disable`, `enable`.
        :param str disconnect: Auto switch by disconnect. Valid values: `disable`, `enable`.
        :param int disconnect_period: Automatically switch based on disconnect period.
        :param int disconnect_threshold: Automatically switch based on disconnect threshold.
        :param str signal: Automatically switch based on signal strength. Valid values: `disable`, `enable`.
        :param str switch_back: Auto switch with switch back multi-options. Valid values: `time`, `timer`.
        :param str switch_back_time: Automatically switch over to preferred SIM/carrier at a specified time in UTC (HH:MM).
        :param int switch_back_timer: Automatically switch over to preferred SIM/carrier after the given time (3600 - 2147483647 sec).
        """
        if dataplan is not None:
            pulumi.set(__self__, "dataplan", dataplan)
        if disconnect is not None:
            pulumi.set(__self__, "disconnect", disconnect)
        if disconnect_period is not None:
            pulumi.set(__self__, "disconnect_period", disconnect_period)
        if disconnect_threshold is not None:
            pulumi.set(__self__, "disconnect_threshold", disconnect_threshold)
        if signal is not None:
            pulumi.set(__self__, "signal", signal)
        if switch_back is not None:
            pulumi.set(__self__, "switch_back", switch_back)
        if switch_back_time is not None:
            pulumi.set(__self__, "switch_back_time", switch_back_time)
        if switch_back_timer is not None:
            pulumi.set(__self__, "switch_back_timer", switch_back_timer)

    @property
    @pulumi.getter
    def dataplan(self) -> Optional[str]:
        """
        Automatically switch based on data usage. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "dataplan")

    @property
    @pulumi.getter
    def disconnect(self) -> Optional[str]:
        """
        Auto switch by disconnect. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "disconnect")

    @property
    @pulumi.getter(name="disconnectPeriod")
    def disconnect_period(self) -> Optional[int]:
        """
        Automatically switch based on disconnect period.
        """
        return pulumi.get(self, "disconnect_period")

    @property
    @pulumi.getter(name="disconnectThreshold")
    def disconnect_threshold(self) -> Optional[int]:
        """
        Automatically switch based on disconnect threshold.
        """
        return pulumi.get(self, "disconnect_threshold")

    @property
    @pulumi.getter
    def signal(self) -> Optional[str]:
        """
        Automatically switch based on signal strength. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "signal")

    @property
    @pulumi.getter(name="switchBack")
    def switch_back(self) -> Optional[str]:
        """
        Auto switch with switch back multi-options. Valid values: `time`, `timer`.
        """
        return pulumi.get(self, "switch_back")

    @property
    @pulumi.getter(name="switchBackTime")
    def switch_back_time(self) -> Optional[str]:
        """
        Automatically switch over to preferred SIM/carrier at a specified time in UTC (HH:MM).
        """
        return pulumi.get(self, "switch_back_time")

    @property
    @pulumi.getter(name="switchBackTimer")
    def switch_back_timer(self) -> Optional[int]:
        """
        Automatically switch over to preferred SIM/carrier after the given time (3600 - 2147483647 sec).
        """
        return pulumi.get(self, "switch_back_timer")


@pulumi.output_type
class ExtenderprofileCellularSmsNotification(dict):
    def __init__(__self__, *,
                 alert: Optional['outputs.ExtenderprofileCellularSmsNotificationAlert'] = None,
                 receivers: Optional[Sequence['outputs.ExtenderprofileCellularSmsNotificationReceiver']] = None,
                 status: Optional[str] = None):
        """
        :param 'ExtenderprofileCellularSmsNotificationAlertArgs' alert: SMS alert list. The structure of `alert` block is documented below.
        :param Sequence['ExtenderprofileCellularSmsNotificationReceiverArgs'] receivers: SMS notification receiver list. The structure of `receiver` block is documented below.
        :param str status: FortiExtender SMS notification status. Valid values: `disable`, `enable`.
        """
        if alert is not None:
            pulumi.set(__self__, "alert", alert)
        if receivers is not None:
            pulumi.set(__self__, "receivers", receivers)
        if status is not None:
            pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter
    def alert(self) -> Optional['outputs.ExtenderprofileCellularSmsNotificationAlert']:
        """
        SMS alert list. The structure of `alert` block is documented below.
        """
        return pulumi.get(self, "alert")

    @property
    @pulumi.getter
    def receivers(self) -> Optional[Sequence['outputs.ExtenderprofileCellularSmsNotificationReceiver']]:
        """
        SMS notification receiver list. The structure of `receiver` block is documented below.
        """
        return pulumi.get(self, "receivers")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        FortiExtender SMS notification status. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "status")


@pulumi.output_type
class ExtenderprofileCellularSmsNotificationAlert(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "dataExhausted":
            suggest = "data_exhausted"
        elif key == "fgtBackupModeSwitch":
            suggest = "fgt_backup_mode_switch"
        elif key == "lowSignalStrength":
            suggest = "low_signal_strength"
        elif key == "modeSwitch":
            suggest = "mode_switch"
        elif key == "osImageFallback":
            suggest = "os_image_fallback"
        elif key == "sessionDisconnect":
            suggest = "session_disconnect"
        elif key == "systemReboot":
            suggest = "system_reboot"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ExtenderprofileCellularSmsNotificationAlert. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ExtenderprofileCellularSmsNotificationAlert.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ExtenderprofileCellularSmsNotificationAlert.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 data_exhausted: Optional[str] = None,
                 fgt_backup_mode_switch: Optional[str] = None,
                 low_signal_strength: Optional[str] = None,
                 mode_switch: Optional[str] = None,
                 os_image_fallback: Optional[str] = None,
                 session_disconnect: Optional[str] = None,
                 system_reboot: Optional[str] = None):
        """
        :param str data_exhausted: Display string when data exhausted.
        :param str fgt_backup_mode_switch: Display string when FortiGate backup mode switched.
        :param str low_signal_strength: Display string when signal strength is low.
        :param str mode_switch: Display string when mode is switched.
        :param str os_image_fallback: Display string when falling back to a previous OS image.
        :param str session_disconnect: Display string when session disconnected.
        :param str system_reboot: Display string when system rebooted.
        """
        if data_exhausted is not None:
            pulumi.set(__self__, "data_exhausted", data_exhausted)
        if fgt_backup_mode_switch is not None:
            pulumi.set(__self__, "fgt_backup_mode_switch", fgt_backup_mode_switch)
        if low_signal_strength is not None:
            pulumi.set(__self__, "low_signal_strength", low_signal_strength)
        if mode_switch is not None:
            pulumi.set(__self__, "mode_switch", mode_switch)
        if os_image_fallback is not None:
            pulumi.set(__self__, "os_image_fallback", os_image_fallback)
        if session_disconnect is not None:
            pulumi.set(__self__, "session_disconnect", session_disconnect)
        if system_reboot is not None:
            pulumi.set(__self__, "system_reboot", system_reboot)

    @property
    @pulumi.getter(name="dataExhausted")
    def data_exhausted(self) -> Optional[str]:
        """
        Display string when data exhausted.
        """
        return pulumi.get(self, "data_exhausted")

    @property
    @pulumi.getter(name="fgtBackupModeSwitch")
    def fgt_backup_mode_switch(self) -> Optional[str]:
        """
        Display string when FortiGate backup mode switched.
        """
        return pulumi.get(self, "fgt_backup_mode_switch")

    @property
    @pulumi.getter(name="lowSignalStrength")
    def low_signal_strength(self) -> Optional[str]:
        """
        Display string when signal strength is low.
        """
        return pulumi.get(self, "low_signal_strength")

    @property
    @pulumi.getter(name="modeSwitch")
    def mode_switch(self) -> Optional[str]:
        """
        Display string when mode is switched.
        """
        return pulumi.get(self, "mode_switch")

    @property
    @pulumi.getter(name="osImageFallback")
    def os_image_fallback(self) -> Optional[str]:
        """
        Display string when falling back to a previous OS image.
        """
        return pulumi.get(self, "os_image_fallback")

    @property
    @pulumi.getter(name="sessionDisconnect")
    def session_disconnect(self) -> Optional[str]:
        """
        Display string when session disconnected.
        """
        return pulumi.get(self, "session_disconnect")

    @property
    @pulumi.getter(name="systemReboot")
    def system_reboot(self) -> Optional[str]:
        """
        Display string when system rebooted.
        """
        return pulumi.get(self, "system_reboot")


@pulumi.output_type
class ExtenderprofileCellularSmsNotificationReceiver(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "phoneNumber":
            suggest = "phone_number"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ExtenderprofileCellularSmsNotificationReceiver. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ExtenderprofileCellularSmsNotificationReceiver.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ExtenderprofileCellularSmsNotificationReceiver.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 alert: Optional[str] = None,
                 name: Optional[str] = None,
                 phone_number: Optional[str] = None,
                 status: Optional[str] = None):
        """
        :param str alert: Alert multi-options. Valid values: `system-reboot`, `data-exhausted`, `session-disconnect`, `low-signal-strength`, `mode-switch`, `os-image-fallback`, `fgt-backup-mode-switch`.
               
               The `modem1` block supports:
        :param str name: FortiExtender SMS notification receiver name.
        :param str phone_number: Receiver phone number. Format: [+][country code][area code][local phone number]. For example, +16501234567.
        :param str status: SMS notification receiver status. Valid values: `disable`, `enable`.
        """
        if alert is not None:
            pulumi.set(__self__, "alert", alert)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if phone_number is not None:
            pulumi.set(__self__, "phone_number", phone_number)
        if status is not None:
            pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter
    def alert(self) -> Optional[str]:
        """
        Alert multi-options. Valid values: `system-reboot`, `data-exhausted`, `session-disconnect`, `low-signal-strength`, `mode-switch`, `os-image-fallback`, `fgt-backup-mode-switch`.

        The `modem1` block supports:
        """
        return pulumi.get(self, "alert")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        FortiExtender SMS notification receiver name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="phoneNumber")
    def phone_number(self) -> Optional[str]:
        """
        Receiver phone number. Format: [+][country code][area code][local phone number]. For example, +16501234567.
        """
        return pulumi.get(self, "phone_number")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        SMS notification receiver status. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "status")


@pulumi.output_type
class ExtenderprofileLanExtension(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "backhaulInterface":
            suggest = "backhaul_interface"
        elif key == "backhaulIp":
            suggest = "backhaul_ip"
        elif key == "ipsecTunnel":
            suggest = "ipsec_tunnel"
        elif key == "linkLoadbalance":
            suggest = "link_loadbalance"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ExtenderprofileLanExtension. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ExtenderprofileLanExtension.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ExtenderprofileLanExtension.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 backhaul_interface: Optional[str] = None,
                 backhaul_ip: Optional[str] = None,
                 backhauls: Optional[Sequence['outputs.ExtenderprofileLanExtensionBackhaul']] = None,
                 ipsec_tunnel: Optional[str] = None,
                 link_loadbalance: Optional[str] = None):
        """
        :param str backhaul_interface: IPsec phase1 interface.
        :param str backhaul_ip: IPsec phase1 IPv4/FQDN. Used to specify the external IP/FQDN when the FortiGate unit is behind a NAT device.
        :param Sequence['ExtenderprofileLanExtensionBackhaulArgs'] backhauls: LAN extension backhaul tunnel configuration. The structure of `backhaul` block is documented below.
        :param str ipsec_tunnel: IPsec tunnel name.
        :param str link_loadbalance: LAN extension link load balance strategy. Valid values: `activebackup`, `loadbalance`.
        """
        if backhaul_interface is not None:
            pulumi.set(__self__, "backhaul_interface", backhaul_interface)
        if backhaul_ip is not None:
            pulumi.set(__self__, "backhaul_ip", backhaul_ip)
        if backhauls is not None:
            pulumi.set(__self__, "backhauls", backhauls)
        if ipsec_tunnel is not None:
            pulumi.set(__self__, "ipsec_tunnel", ipsec_tunnel)
        if link_loadbalance is not None:
            pulumi.set(__self__, "link_loadbalance", link_loadbalance)

    @property
    @pulumi.getter(name="backhaulInterface")
    def backhaul_interface(self) -> Optional[str]:
        """
        IPsec phase1 interface.
        """
        return pulumi.get(self, "backhaul_interface")

    @property
    @pulumi.getter(name="backhaulIp")
    def backhaul_ip(self) -> Optional[str]:
        """
        IPsec phase1 IPv4/FQDN. Used to specify the external IP/FQDN when the FortiGate unit is behind a NAT device.
        """
        return pulumi.get(self, "backhaul_ip")

    @property
    @pulumi.getter
    def backhauls(self) -> Optional[Sequence['outputs.ExtenderprofileLanExtensionBackhaul']]:
        """
        LAN extension backhaul tunnel configuration. The structure of `backhaul` block is documented below.
        """
        return pulumi.get(self, "backhauls")

    @property
    @pulumi.getter(name="ipsecTunnel")
    def ipsec_tunnel(self) -> Optional[str]:
        """
        IPsec tunnel name.
        """
        return pulumi.get(self, "ipsec_tunnel")

    @property
    @pulumi.getter(name="linkLoadbalance")
    def link_loadbalance(self) -> Optional[str]:
        """
        LAN extension link load balance strategy. Valid values: `activebackup`, `loadbalance`.
        """
        return pulumi.get(self, "link_loadbalance")


@pulumi.output_type
class ExtenderprofileLanExtensionBackhaul(dict):
    def __init__(__self__, *,
                 name: Optional[str] = None,
                 port: Optional[str] = None,
                 role: Optional[str] = None,
                 weight: Optional[int] = None):
        """
        :param str name: FortiExtender LAN extension backhaul name.
        :param str port: FortiExtender uplink port. Valid values: `wan`, `lte1`, `lte2`, `port1`, `port2`, `port3`, `port4`, `port5`, `sfp`.
        :param str role: FortiExtender uplink port. Valid values: `primary`, `secondary`.
        :param int weight: WRR weight parameter.
        """
        if name is not None:
            pulumi.set(__self__, "name", name)
        if port is not None:
            pulumi.set(__self__, "port", port)
        if role is not None:
            pulumi.set(__self__, "role", role)
        if weight is not None:
            pulumi.set(__self__, "weight", weight)

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        FortiExtender LAN extension backhaul name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def port(self) -> Optional[str]:
        """
        FortiExtender uplink port. Valid values: `wan`, `lte1`, `lte2`, `port1`, `port2`, `port3`, `port4`, `port5`, `sfp`.
        """
        return pulumi.get(self, "port")

    @property
    @pulumi.getter
    def role(self) -> Optional[str]:
        """
        FortiExtender uplink port. Valid values: `primary`, `secondary`.
        """
        return pulumi.get(self, "role")

    @property
    @pulumi.getter
    def weight(self) -> Optional[int]:
        """
        WRR weight parameter.
        """
        return pulumi.get(self, "weight")


@pulumi.output_type
class FortigateprofileLanExtension(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "backhaulInterface":
            suggest = "backhaul_interface"
        elif key == "backhaulIp":
            suggest = "backhaul_ip"
        elif key == "ipsecTunnel":
            suggest = "ipsec_tunnel"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in FortigateprofileLanExtension. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        FortigateprofileLanExtension.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        FortigateprofileLanExtension.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 backhaul_interface: Optional[str] = None,
                 backhaul_ip: Optional[str] = None,
                 ipsec_tunnel: Optional[str] = None):
        """
        :param str backhaul_interface: IPsec phase1 interface.
        :param str backhaul_ip: IPsec phase1 IPv4/FQDN. Used to specify the external IP/FQDN when the FortiGate unit is behind a NAT device.
        :param str ipsec_tunnel: IPsec tunnel name.
        """
        if backhaul_interface is not None:
            pulumi.set(__self__, "backhaul_interface", backhaul_interface)
        if backhaul_ip is not None:
            pulumi.set(__self__, "backhaul_ip", backhaul_ip)
        if ipsec_tunnel is not None:
            pulumi.set(__self__, "ipsec_tunnel", ipsec_tunnel)

    @property
    @pulumi.getter(name="backhaulInterface")
    def backhaul_interface(self) -> Optional[str]:
        """
        IPsec phase1 interface.
        """
        return pulumi.get(self, "backhaul_interface")

    @property
    @pulumi.getter(name="backhaulIp")
    def backhaul_ip(self) -> Optional[str]:
        """
        IPsec phase1 IPv4/FQDN. Used to specify the external IP/FQDN when the FortiGate unit is behind a NAT device.
        """
        return pulumi.get(self, "backhaul_ip")

    @property
    @pulumi.getter(name="ipsecTunnel")
    def ipsec_tunnel(self) -> Optional[str]:
        """
        IPsec tunnel name.
        """
        return pulumi.get(self, "ipsec_tunnel")


