# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities
from . import outputs

__all__ = [
    'BlockallowlistEntry',
    'BwlEntry',
    'BwordEntry',
    'DnsblEntry',
    'IptrustEntry',
    'MheaderEntry',
    'ProfileFileFilter',
    'ProfileFileFilterEntry',
    'ProfileFileFilterEntryFileType',
    'ProfileGmail',
    'ProfileImap',
    'ProfileMapi',
    'ProfileMsnHotmail',
    'ProfileOtherWebmails',
    'ProfilePop3',
    'ProfileSmtp',
    'ProfileYahooMail',
]

@pulumi.output_type
class BlockallowlistEntry(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "addrType":
            suggest = "addr_type"
        elif key == "emailPattern":
            suggest = "email_pattern"
        elif key == "ip4Subnet":
            suggest = "ip4_subnet"
        elif key == "ip6Subnet":
            suggest = "ip6_subnet"
        elif key == "patternType":
            suggest = "pattern_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in BlockallowlistEntry. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        BlockallowlistEntry.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        BlockallowlistEntry.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 action: Optional[str] = None,
                 addr_type: Optional[str] = None,
                 email_pattern: Optional[str] = None,
                 id: Optional[int] = None,
                 ip4_subnet: Optional[str] = None,
                 ip6_subnet: Optional[str] = None,
                 pattern: Optional[str] = None,
                 pattern_type: Optional[str] = None,
                 status: Optional[str] = None,
                 type: Optional[str] = None):
        """
        :param str action: Reject, mark as spam or good email. Valid values: `reject`, `spam`, `clear`.
        :param str addr_type: IP address type. Valid values: `ipv4`, `ipv6`.
        :param str email_pattern: Email address pattern.
        :param int id: Entry ID.
        :param str ip4_subnet: IPv4 network address/subnet mask bits.
        :param str ip6_subnet: IPv6 network address/subnet mask bits.
        :param str pattern: Pattern to match.
        :param str pattern_type: Wildcard pattern or regular expression. Valid values: `wildcard`, `regexp`.
        :param str status: Enable/disable status. Valid values: `enable`, `disable`.
        :param str type: Entry type.
        """
        if action is not None:
            pulumi.set(__self__, "action", action)
        if addr_type is not None:
            pulumi.set(__self__, "addr_type", addr_type)
        if email_pattern is not None:
            pulumi.set(__self__, "email_pattern", email_pattern)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if ip4_subnet is not None:
            pulumi.set(__self__, "ip4_subnet", ip4_subnet)
        if ip6_subnet is not None:
            pulumi.set(__self__, "ip6_subnet", ip6_subnet)
        if pattern is not None:
            pulumi.set(__self__, "pattern", pattern)
        if pattern_type is not None:
            pulumi.set(__self__, "pattern_type", pattern_type)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def action(self) -> Optional[str]:
        """
        Reject, mark as spam or good email. Valid values: `reject`, `spam`, `clear`.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter(name="addrType")
    def addr_type(self) -> Optional[str]:
        """
        IP address type. Valid values: `ipv4`, `ipv6`.
        """
        return pulumi.get(self, "addr_type")

    @property
    @pulumi.getter(name="emailPattern")
    def email_pattern(self) -> Optional[str]:
        """
        Email address pattern.
        """
        return pulumi.get(self, "email_pattern")

    @property
    @pulumi.getter
    def id(self) -> Optional[int]:
        """
        Entry ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="ip4Subnet")
    def ip4_subnet(self) -> Optional[str]:
        """
        IPv4 network address/subnet mask bits.
        """
        return pulumi.get(self, "ip4_subnet")

    @property
    @pulumi.getter(name="ip6Subnet")
    def ip6_subnet(self) -> Optional[str]:
        """
        IPv6 network address/subnet mask bits.
        """
        return pulumi.get(self, "ip6_subnet")

    @property
    @pulumi.getter
    def pattern(self) -> Optional[str]:
        """
        Pattern to match.
        """
        return pulumi.get(self, "pattern")

    @property
    @pulumi.getter(name="patternType")
    def pattern_type(self) -> Optional[str]:
        """
        Wildcard pattern or regular expression. Valid values: `wildcard`, `regexp`.
        """
        return pulumi.get(self, "pattern_type")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        Enable/disable status. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        """
        Entry type.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class BwlEntry(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "addrType":
            suggest = "addr_type"
        elif key == "emailPattern":
            suggest = "email_pattern"
        elif key == "ip4Subnet":
            suggest = "ip4_subnet"
        elif key == "ip6Subnet":
            suggest = "ip6_subnet"
        elif key == "patternType":
            suggest = "pattern_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in BwlEntry. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        BwlEntry.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        BwlEntry.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 action: Optional[str] = None,
                 addr_type: Optional[str] = None,
                 email_pattern: Optional[str] = None,
                 id: Optional[int] = None,
                 ip4_subnet: Optional[str] = None,
                 ip6_subnet: Optional[str] = None,
                 pattern_type: Optional[str] = None,
                 status: Optional[str] = None,
                 type: Optional[str] = None):
        """
        :param str action: Reject, mark as spam or good email. Valid values: `reject`, `spam`, `clear`.
        :param str addr_type: IP address type. Valid values: `ipv4`, `ipv6`.
        :param str email_pattern: Email address pattern.
        :param int id: Entry ID.
        :param str ip4_subnet: IPv4 network address/subnet mask bits.
        :param str ip6_subnet: IPv6 network address/subnet mask bits.
        :param str pattern_type: Wildcard pattern or regular expression. Valid values: `wildcard`, `regexp`.
        :param str status: Enable/disable status. Valid values: `enable`, `disable`.
        :param str type: Entry type. Valid values: `ip`, `email`.
        """
        if action is not None:
            pulumi.set(__self__, "action", action)
        if addr_type is not None:
            pulumi.set(__self__, "addr_type", addr_type)
        if email_pattern is not None:
            pulumi.set(__self__, "email_pattern", email_pattern)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if ip4_subnet is not None:
            pulumi.set(__self__, "ip4_subnet", ip4_subnet)
        if ip6_subnet is not None:
            pulumi.set(__self__, "ip6_subnet", ip6_subnet)
        if pattern_type is not None:
            pulumi.set(__self__, "pattern_type", pattern_type)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter
    def action(self) -> Optional[str]:
        """
        Reject, mark as spam or good email. Valid values: `reject`, `spam`, `clear`.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter(name="addrType")
    def addr_type(self) -> Optional[str]:
        """
        IP address type. Valid values: `ipv4`, `ipv6`.
        """
        return pulumi.get(self, "addr_type")

    @property
    @pulumi.getter(name="emailPattern")
    def email_pattern(self) -> Optional[str]:
        """
        Email address pattern.
        """
        return pulumi.get(self, "email_pattern")

    @property
    @pulumi.getter
    def id(self) -> Optional[int]:
        """
        Entry ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="ip4Subnet")
    def ip4_subnet(self) -> Optional[str]:
        """
        IPv4 network address/subnet mask bits.
        """
        return pulumi.get(self, "ip4_subnet")

    @property
    @pulumi.getter(name="ip6Subnet")
    def ip6_subnet(self) -> Optional[str]:
        """
        IPv6 network address/subnet mask bits.
        """
        return pulumi.get(self, "ip6_subnet")

    @property
    @pulumi.getter(name="patternType")
    def pattern_type(self) -> Optional[str]:
        """
        Wildcard pattern or regular expression. Valid values: `wildcard`, `regexp`.
        """
        return pulumi.get(self, "pattern_type")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        Enable/disable status. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def type(self) -> Optional[str]:
        """
        Entry type. Valid values: `ip`, `email`.
        """
        return pulumi.get(self, "type")


@pulumi.output_type
class BwordEntry(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "patternType":
            suggest = "pattern_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in BwordEntry. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        BwordEntry.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        BwordEntry.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 action: Optional[str] = None,
                 id: Optional[int] = None,
                 language: Optional[str] = None,
                 pattern: Optional[str] = None,
                 pattern_type: Optional[str] = None,
                 score: Optional[int] = None,
                 status: Optional[str] = None,
                 where: Optional[str] = None):
        """
        :param str action: Mark spam or good. Valid values: `spam`, `clear`.
        :param int id: Banned word entry ID.
        :param str language: Language for the banned word. Valid values: `western`, `simch`, `trach`, `japanese`, `korean`, `french`, `thai`, `spanish`.
        :param str pattern: Pattern for the banned word.
        :param str pattern_type: Wildcard pattern or regular expression. Valid values: `wildcard`, `regexp`.
        :param int score: Score value.
        :param str status: Enable/disable status. Valid values: `enable`, `disable`.
        :param str where: Component of the email to be scanned. Valid values: `subject`, `body`, `all`.
        """
        if action is not None:
            pulumi.set(__self__, "action", action)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if language is not None:
            pulumi.set(__self__, "language", language)
        if pattern is not None:
            pulumi.set(__self__, "pattern", pattern)
        if pattern_type is not None:
            pulumi.set(__self__, "pattern_type", pattern_type)
        if score is not None:
            pulumi.set(__self__, "score", score)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if where is not None:
            pulumi.set(__self__, "where", where)

    @property
    @pulumi.getter
    def action(self) -> Optional[str]:
        """
        Mark spam or good. Valid values: `spam`, `clear`.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter
    def id(self) -> Optional[int]:
        """
        Banned word entry ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def language(self) -> Optional[str]:
        """
        Language for the banned word. Valid values: `western`, `simch`, `trach`, `japanese`, `korean`, `french`, `thai`, `spanish`.
        """
        return pulumi.get(self, "language")

    @property
    @pulumi.getter
    def pattern(self) -> Optional[str]:
        """
        Pattern for the banned word.
        """
        return pulumi.get(self, "pattern")

    @property
    @pulumi.getter(name="patternType")
    def pattern_type(self) -> Optional[str]:
        """
        Wildcard pattern or regular expression. Valid values: `wildcard`, `regexp`.
        """
        return pulumi.get(self, "pattern_type")

    @property
    @pulumi.getter
    def score(self) -> Optional[int]:
        """
        Score value.
        """
        return pulumi.get(self, "score")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        Enable/disable status. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def where(self) -> Optional[str]:
        """
        Component of the email to be scanned. Valid values: `subject`, `body`, `all`.
        """
        return pulumi.get(self, "where")


@pulumi.output_type
class DnsblEntry(dict):
    def __init__(__self__, *,
                 action: Optional[str] = None,
                 id: Optional[int] = None,
                 server: Optional[str] = None,
                 status: Optional[str] = None):
        """
        :param str action: Reject connection or mark as spam email. Valid values: `reject`, `spam`.
        :param int id: DNSBL/ORBL entry ID.
        :param str server: DNSBL or ORBL server name.
        :param str status: Enable/disable status. Valid values: `enable`, `disable`.
        """
        if action is not None:
            pulumi.set(__self__, "action", action)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if server is not None:
            pulumi.set(__self__, "server", server)
        if status is not None:
            pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter
    def action(self) -> Optional[str]:
        """
        Reject connection or mark as spam email. Valid values: `reject`, `spam`.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter
    def id(self) -> Optional[int]:
        """
        DNSBL/ORBL entry ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def server(self) -> Optional[str]:
        """
        DNSBL or ORBL server name.
        """
        return pulumi.get(self, "server")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        Enable/disable status. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "status")


@pulumi.output_type
class IptrustEntry(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "addrType":
            suggest = "addr_type"
        elif key == "ip4Subnet":
            suggest = "ip4_subnet"
        elif key == "ip6Subnet":
            suggest = "ip6_subnet"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in IptrustEntry. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        IptrustEntry.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        IptrustEntry.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 addr_type: Optional[str] = None,
                 id: Optional[int] = None,
                 ip4_subnet: Optional[str] = None,
                 ip6_subnet: Optional[str] = None,
                 status: Optional[str] = None):
        """
        :param str addr_type: Type of address. Valid values: `ipv4`, `ipv6`.
        :param int id: Trusted IP entry ID.
        :param str ip4_subnet: IPv4 network address or network address/subnet mask bits.
        :param str ip6_subnet: IPv6 network address/subnet mask bits.
        :param str status: Enable/disable status. Valid values: `enable`, `disable`.
        """
        if addr_type is not None:
            pulumi.set(__self__, "addr_type", addr_type)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if ip4_subnet is not None:
            pulumi.set(__self__, "ip4_subnet", ip4_subnet)
        if ip6_subnet is not None:
            pulumi.set(__self__, "ip6_subnet", ip6_subnet)
        if status is not None:
            pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter(name="addrType")
    def addr_type(self) -> Optional[str]:
        """
        Type of address. Valid values: `ipv4`, `ipv6`.
        """
        return pulumi.get(self, "addr_type")

    @property
    @pulumi.getter
    def id(self) -> Optional[int]:
        """
        Trusted IP entry ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="ip4Subnet")
    def ip4_subnet(self) -> Optional[str]:
        """
        IPv4 network address or network address/subnet mask bits.
        """
        return pulumi.get(self, "ip4_subnet")

    @property
    @pulumi.getter(name="ip6Subnet")
    def ip6_subnet(self) -> Optional[str]:
        """
        IPv6 network address/subnet mask bits.
        """
        return pulumi.get(self, "ip6_subnet")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        Enable/disable status. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "status")


@pulumi.output_type
class MheaderEntry(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "patternType":
            suggest = "pattern_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in MheaderEntry. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        MheaderEntry.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        MheaderEntry.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 action: Optional[str] = None,
                 fieldbody: Optional[str] = None,
                 fieldname: Optional[str] = None,
                 id: Optional[int] = None,
                 pattern_type: Optional[str] = None,
                 status: Optional[str] = None):
        """
        :param str action: Mark spam or good. Valid values: `spam`, `clear`.
        :param str fieldbody: Pattern for the header field body.
        :param str fieldname: Pattern for header field name.
        :param int id: Mime header entry ID.
        :param str pattern_type: Wildcard pattern or regular expression. Valid values: `wildcard`, `regexp`.
        :param str status: Enable/disable status. Valid values: `enable`, `disable`.
        """
        if action is not None:
            pulumi.set(__self__, "action", action)
        if fieldbody is not None:
            pulumi.set(__self__, "fieldbody", fieldbody)
        if fieldname is not None:
            pulumi.set(__self__, "fieldname", fieldname)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if pattern_type is not None:
            pulumi.set(__self__, "pattern_type", pattern_type)
        if status is not None:
            pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter
    def action(self) -> Optional[str]:
        """
        Mark spam or good. Valid values: `spam`, `clear`.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter
    def fieldbody(self) -> Optional[str]:
        """
        Pattern for the header field body.
        """
        return pulumi.get(self, "fieldbody")

    @property
    @pulumi.getter
    def fieldname(self) -> Optional[str]:
        """
        Pattern for header field name.
        """
        return pulumi.get(self, "fieldname")

    @property
    @pulumi.getter
    def id(self) -> Optional[int]:
        """
        Mime header entry ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="patternType")
    def pattern_type(self) -> Optional[str]:
        """
        Wildcard pattern or regular expression. Valid values: `wildcard`, `regexp`.
        """
        return pulumi.get(self, "pattern_type")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        Enable/disable status. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "status")


@pulumi.output_type
class ProfileFileFilter(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "scanArchiveContents":
            suggest = "scan_archive_contents"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ProfileFileFilter. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ProfileFileFilter.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ProfileFileFilter.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 entries: Optional[Sequence['outputs.ProfileFileFilterEntry']] = None,
                 log: Optional[str] = None,
                 scan_archive_contents: Optional[str] = None,
                 status: Optional[str] = None):
        """
        :param Sequence['ProfileFileFilterEntryArgs'] entries: File filter entries. The structure of `entries` block is documented below.
        :param str log: Enable/disable file filter logging. Valid values: `enable`, `disable`.
        :param str scan_archive_contents: Enable/disable file filter archive contents scan. Valid values: `enable`, `disable`.
        :param str status: Enable/disable file filter. Valid values: `enable`, `disable`.
        """
        if entries is not None:
            pulumi.set(__self__, "entries", entries)
        if log is not None:
            pulumi.set(__self__, "log", log)
        if scan_archive_contents is not None:
            pulumi.set(__self__, "scan_archive_contents", scan_archive_contents)
        if status is not None:
            pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter
    def entries(self) -> Optional[Sequence['outputs.ProfileFileFilterEntry']]:
        """
        File filter entries. The structure of `entries` block is documented below.
        """
        return pulumi.get(self, "entries")

    @property
    @pulumi.getter
    def log(self) -> Optional[str]:
        """
        Enable/disable file filter logging. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "log")

    @property
    @pulumi.getter(name="scanArchiveContents")
    def scan_archive_contents(self) -> Optional[str]:
        """
        Enable/disable file filter archive contents scan. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "scan_archive_contents")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        Enable/disable file filter. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "status")


@pulumi.output_type
class ProfileFileFilterEntry(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "fileTypes":
            suggest = "file_types"
        elif key == "passwordProtected":
            suggest = "password_protected"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ProfileFileFilterEntry. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ProfileFileFilterEntry.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ProfileFileFilterEntry.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 action: Optional[str] = None,
                 comment: Optional[str] = None,
                 file_types: Optional[Sequence['outputs.ProfileFileFilterEntryFileType']] = None,
                 filter: Optional[str] = None,
                 password_protected: Optional[str] = None,
                 protocol: Optional[str] = None):
        """
        :param str action: Action taken for matched file. Valid values: `log`, `block`.
        :param str comment: Comment.
        :param Sequence['ProfileFileFilterEntryFileTypeArgs'] file_types: Select file type. The structure of `file_type` block is documented below.
        :param str filter: Add a file filter.
        :param str password_protected: Match password-protected files. Valid values: `yes`, `any`.
        :param str protocol: Protocols to apply with. Valid values: `smtp`, `imap`, `pop3`.
        """
        if action is not None:
            pulumi.set(__self__, "action", action)
        if comment is not None:
            pulumi.set(__self__, "comment", comment)
        if file_types is not None:
            pulumi.set(__self__, "file_types", file_types)
        if filter is not None:
            pulumi.set(__self__, "filter", filter)
        if password_protected is not None:
            pulumi.set(__self__, "password_protected", password_protected)
        if protocol is not None:
            pulumi.set(__self__, "protocol", protocol)

    @property
    @pulumi.getter
    def action(self) -> Optional[str]:
        """
        Action taken for matched file. Valid values: `log`, `block`.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter
    def comment(self) -> Optional[str]:
        """
        Comment.
        """
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter(name="fileTypes")
    def file_types(self) -> Optional[Sequence['outputs.ProfileFileFilterEntryFileType']]:
        """
        Select file type. The structure of `file_type` block is documented below.
        """
        return pulumi.get(self, "file_types")

    @property
    @pulumi.getter
    def filter(self) -> Optional[str]:
        """
        Add a file filter.
        """
        return pulumi.get(self, "filter")

    @property
    @pulumi.getter(name="passwordProtected")
    def password_protected(self) -> Optional[str]:
        """
        Match password-protected files. Valid values: `yes`, `any`.
        """
        return pulumi.get(self, "password_protected")

    @property
    @pulumi.getter
    def protocol(self) -> Optional[str]:
        """
        Protocols to apply with. Valid values: `smtp`, `imap`, `pop3`.
        """
        return pulumi.get(self, "protocol")


@pulumi.output_type
class ProfileFileFilterEntryFileType(dict):
    def __init__(__self__, *,
                 name: Optional[str] = None):
        """
        :param str name: File type name.
        """
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        File type name.
        """
        return pulumi.get(self, "name")


@pulumi.output_type
class ProfileGmail(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "logAll":
            suggest = "log_all"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ProfileGmail. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ProfileGmail.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ProfileGmail.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 log: Optional[str] = None,
                 log_all: Optional[str] = None):
        """
        :param str log: Enable/disable logging. Valid values: `enable`, `disable`.
        :param str log_all: Enable/disable logging of all email traffic. Valid values: `disable`, `enable`.
        """
        if log is not None:
            pulumi.set(__self__, "log", log)
        if log_all is not None:
            pulumi.set(__self__, "log_all", log_all)

    @property
    @pulumi.getter
    def log(self) -> Optional[str]:
        """
        Enable/disable logging. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "log")

    @property
    @pulumi.getter(name="logAll")
    def log_all(self) -> Optional[str]:
        """
        Enable/disable logging of all email traffic. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "log_all")


@pulumi.output_type
class ProfileImap(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "logAll":
            suggest = "log_all"
        elif key == "tagMsg":
            suggest = "tag_msg"
        elif key == "tagType":
            suggest = "tag_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ProfileImap. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ProfileImap.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ProfileImap.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 action: Optional[str] = None,
                 log: Optional[str] = None,
                 log_all: Optional[str] = None,
                 tag_msg: Optional[str] = None,
                 tag_type: Optional[str] = None):
        """
        :param str action: Action for spam email. Valid values: `pass`, `tag`.
        :param str log: Enable/disable logging. Valid values: `enable`, `disable`.
        :param str log_all: Enable/disable logging of all email traffic. Valid values: `disable`, `enable`.
        :param str tag_msg: Subject text or header added to spam email.
        :param str tag_type: Tag subject or header for spam email. Valid values: `subject`, `header`, `spaminfo`.
        """
        if action is not None:
            pulumi.set(__self__, "action", action)
        if log is not None:
            pulumi.set(__self__, "log", log)
        if log_all is not None:
            pulumi.set(__self__, "log_all", log_all)
        if tag_msg is not None:
            pulumi.set(__self__, "tag_msg", tag_msg)
        if tag_type is not None:
            pulumi.set(__self__, "tag_type", tag_type)

    @property
    @pulumi.getter
    def action(self) -> Optional[str]:
        """
        Action for spam email. Valid values: `pass`, `tag`.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter
    def log(self) -> Optional[str]:
        """
        Enable/disable logging. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "log")

    @property
    @pulumi.getter(name="logAll")
    def log_all(self) -> Optional[str]:
        """
        Enable/disable logging of all email traffic. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "log_all")

    @property
    @pulumi.getter(name="tagMsg")
    def tag_msg(self) -> Optional[str]:
        """
        Subject text or header added to spam email.
        """
        return pulumi.get(self, "tag_msg")

    @property
    @pulumi.getter(name="tagType")
    def tag_type(self) -> Optional[str]:
        """
        Tag subject or header for spam email. Valid values: `subject`, `header`, `spaminfo`.
        """
        return pulumi.get(self, "tag_type")


@pulumi.output_type
class ProfileMapi(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "logAll":
            suggest = "log_all"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ProfileMapi. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ProfileMapi.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ProfileMapi.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 action: Optional[str] = None,
                 log: Optional[str] = None,
                 log_all: Optional[str] = None):
        """
        :param str action: Action for spam email. Valid values: `pass`, `discard`.
        :param str log: Enable/disable logging. Valid values: `enable`, `disable`.
        :param str log_all: Enable/disable logging of all email traffic. Valid values: `disable`, `enable`.
        """
        if action is not None:
            pulumi.set(__self__, "action", action)
        if log is not None:
            pulumi.set(__self__, "log", log)
        if log_all is not None:
            pulumi.set(__self__, "log_all", log_all)

    @property
    @pulumi.getter
    def action(self) -> Optional[str]:
        """
        Action for spam email. Valid values: `pass`, `discard`.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter
    def log(self) -> Optional[str]:
        """
        Enable/disable logging. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "log")

    @property
    @pulumi.getter(name="logAll")
    def log_all(self) -> Optional[str]:
        """
        Enable/disable logging of all email traffic. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "log_all")


@pulumi.output_type
class ProfileMsnHotmail(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "logAll":
            suggest = "log_all"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ProfileMsnHotmail. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ProfileMsnHotmail.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ProfileMsnHotmail.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 log: Optional[str] = None,
                 log_all: Optional[str] = None):
        """
        :param str log: Enable/disable logging. Valid values: `enable`, `disable`.
        :param str log_all: Enable/disable logging of all email traffic. Valid values: `disable`, `enable`.
        """
        if log is not None:
            pulumi.set(__self__, "log", log)
        if log_all is not None:
            pulumi.set(__self__, "log_all", log_all)

    @property
    @pulumi.getter
    def log(self) -> Optional[str]:
        """
        Enable/disable logging. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "log")

    @property
    @pulumi.getter(name="logAll")
    def log_all(self) -> Optional[str]:
        """
        Enable/disable logging of all email traffic. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "log_all")


@pulumi.output_type
class ProfileOtherWebmails(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "logAll":
            suggest = "log_all"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ProfileOtherWebmails. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ProfileOtherWebmails.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ProfileOtherWebmails.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 log_all: Optional[str] = None):
        """
        :param str log_all: Enable/disable logging of all email traffic. Valid values: `disable`, `enable`.
        """
        if log_all is not None:
            pulumi.set(__self__, "log_all", log_all)

    @property
    @pulumi.getter(name="logAll")
    def log_all(self) -> Optional[str]:
        """
        Enable/disable logging of all email traffic. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "log_all")


@pulumi.output_type
class ProfilePop3(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "logAll":
            suggest = "log_all"
        elif key == "tagMsg":
            suggest = "tag_msg"
        elif key == "tagType":
            suggest = "tag_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ProfilePop3. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ProfilePop3.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ProfilePop3.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 action: Optional[str] = None,
                 log: Optional[str] = None,
                 log_all: Optional[str] = None,
                 tag_msg: Optional[str] = None,
                 tag_type: Optional[str] = None):
        """
        :param str action: Action taken for matched file. Valid values: `log`, `block`.
        :param str log: Enable/disable file filter logging. Valid values: `enable`, `disable`.
        :param str log_all: Enable/disable logging of all email traffic. Valid values: `disable`, `enable`.
        :param str tag_msg: Subject text or header added to spam email.
        :param str tag_type: Tag subject or header for spam email. Valid values: `subject`, `header`, `spaminfo`.
        """
        if action is not None:
            pulumi.set(__self__, "action", action)
        if log is not None:
            pulumi.set(__self__, "log", log)
        if log_all is not None:
            pulumi.set(__self__, "log_all", log_all)
        if tag_msg is not None:
            pulumi.set(__self__, "tag_msg", tag_msg)
        if tag_type is not None:
            pulumi.set(__self__, "tag_type", tag_type)

    @property
    @pulumi.getter
    def action(self) -> Optional[str]:
        """
        Action taken for matched file. Valid values: `log`, `block`.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter
    def log(self) -> Optional[str]:
        """
        Enable/disable file filter logging. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "log")

    @property
    @pulumi.getter(name="logAll")
    def log_all(self) -> Optional[str]:
        """
        Enable/disable logging of all email traffic. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "log_all")

    @property
    @pulumi.getter(name="tagMsg")
    def tag_msg(self) -> Optional[str]:
        """
        Subject text or header added to spam email.
        """
        return pulumi.get(self, "tag_msg")

    @property
    @pulumi.getter(name="tagType")
    def tag_type(self) -> Optional[str]:
        """
        Tag subject or header for spam email. Valid values: `subject`, `header`, `spaminfo`.
        """
        return pulumi.get(self, "tag_type")


@pulumi.output_type
class ProfileSmtp(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "localOverride":
            suggest = "local_override"
        elif key == "logAll":
            suggest = "log_all"
        elif key == "tagMsg":
            suggest = "tag_msg"
        elif key == "tagType":
            suggest = "tag_type"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ProfileSmtp. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ProfileSmtp.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ProfileSmtp.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 action: Optional[str] = None,
                 hdrip: Optional[str] = None,
                 local_override: Optional[str] = None,
                 log: Optional[str] = None,
                 log_all: Optional[str] = None,
                 tag_msg: Optional[str] = None,
                 tag_type: Optional[str] = None):
        """
        :param str action: Action for spam email. Valid values: `pass`, `tag`, `discard`.
        :param str hdrip: Enable/disable SMTP email header IP checks for spamfsip, spamrbl and spambwl filters. Valid values: `disable`, `enable`.
        :param str local_override: Enable/disable local filter to override SMTP remote check result. Valid values: `disable`, `enable`.
        :param str log: Enable/disable logging. Valid values: `enable`, `disable`.
        :param str log_all: Enable/disable logging of all email traffic. Valid values: `disable`, `enable`.
        :param str tag_msg: Subject text or header added to spam email.
        :param str tag_type: Tag subject or header for spam email. Valid values: `subject`, `header`, `spaminfo`.
        """
        if action is not None:
            pulumi.set(__self__, "action", action)
        if hdrip is not None:
            pulumi.set(__self__, "hdrip", hdrip)
        if local_override is not None:
            pulumi.set(__self__, "local_override", local_override)
        if log is not None:
            pulumi.set(__self__, "log", log)
        if log_all is not None:
            pulumi.set(__self__, "log_all", log_all)
        if tag_msg is not None:
            pulumi.set(__self__, "tag_msg", tag_msg)
        if tag_type is not None:
            pulumi.set(__self__, "tag_type", tag_type)

    @property
    @pulumi.getter
    def action(self) -> Optional[str]:
        """
        Action for spam email. Valid values: `pass`, `tag`, `discard`.
        """
        return pulumi.get(self, "action")

    @property
    @pulumi.getter
    def hdrip(self) -> Optional[str]:
        """
        Enable/disable SMTP email header IP checks for spamfsip, spamrbl and spambwl filters. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "hdrip")

    @property
    @pulumi.getter(name="localOverride")
    def local_override(self) -> Optional[str]:
        """
        Enable/disable local filter to override SMTP remote check result. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "local_override")

    @property
    @pulumi.getter
    def log(self) -> Optional[str]:
        """
        Enable/disable logging. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "log")

    @property
    @pulumi.getter(name="logAll")
    def log_all(self) -> Optional[str]:
        """
        Enable/disable logging of all email traffic. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "log_all")

    @property
    @pulumi.getter(name="tagMsg")
    def tag_msg(self) -> Optional[str]:
        """
        Subject text or header added to spam email.
        """
        return pulumi.get(self, "tag_msg")

    @property
    @pulumi.getter(name="tagType")
    def tag_type(self) -> Optional[str]:
        """
        Tag subject or header for spam email. Valid values: `subject`, `header`, `spaminfo`.
        """
        return pulumi.get(self, "tag_type")


@pulumi.output_type
class ProfileYahooMail(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "logAll":
            suggest = "log_all"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ProfileYahooMail. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ProfileYahooMail.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ProfileYahooMail.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 log: Optional[str] = None,
                 log_all: Optional[str] = None):
        """
        :param str log: Enable/disable logging. Valid values: `enable`, `disable`.
        :param str log_all: Enable/disable logging of all email traffic. Valid values: `disable`, `enable`.
        """
        if log is not None:
            pulumi.set(__self__, "log", log)
        if log_all is not None:
            pulumi.set(__self__, "log_all", log_all)

    @property
    @pulumi.getter
    def log(self) -> Optional[str]:
        """
        Enable/disable logging. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "log")

    @property
    @pulumi.getter(name="logAll")
    def log_all(self) -> Optional[str]:
        """
        Enable/disable logging of all email traffic. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "log_all")


