# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities

__all__ = ['Ipsurlfiltersetting6Args', 'Ipsurlfiltersetting6']

@pulumi.input_type
class Ipsurlfiltersetting6Args:
    def __init__(__self__, *,
                 device: Optional[pulumi.Input[str]] = None,
                 distance: Optional[pulumi.Input[int]] = None,
                 gateway6: Optional[pulumi.Input[str]] = None,
                 geo_filter: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Ipsurlfiltersetting6 resource.
        :param pulumi.Input[str] device: Interface for this route.
        :param pulumi.Input[int] distance: Administrative distance (1 - 255) for this route.
        :param pulumi.Input[str] gateway6: Gateway IPv6 address for this route.
        :param pulumi.Input[str] geo_filter: Filter based on geographical location. Route will NOT be installed if the resolved IPv6 address belongs to the country in the filter.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        if device is not None:
            pulumi.set(__self__, "device", device)
        if distance is not None:
            pulumi.set(__self__, "distance", distance)
        if gateway6 is not None:
            pulumi.set(__self__, "gateway6", gateway6)
        if geo_filter is not None:
            pulumi.set(__self__, "geo_filter", geo_filter)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        Interface for this route.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter
    def distance(self) -> Optional[pulumi.Input[int]]:
        """
        Administrative distance (1 - 255) for this route.
        """
        return pulumi.get(self, "distance")

    @distance.setter
    def distance(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "distance", value)

    @property
    @pulumi.getter
    def gateway6(self) -> Optional[pulumi.Input[str]]:
        """
        Gateway IPv6 address for this route.
        """
        return pulumi.get(self, "gateway6")

    @gateway6.setter
    def gateway6(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "gateway6", value)

    @property
    @pulumi.getter(name="geoFilter")
    def geo_filter(self) -> Optional[pulumi.Input[str]]:
        """
        Filter based on geographical location. Route will NOT be installed if the resolved IPv6 address belongs to the country in the filter.
        """
        return pulumi.get(self, "geo_filter")

    @geo_filter.setter
    def geo_filter(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "geo_filter", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)


@pulumi.input_type
class _Ipsurlfiltersetting6State:
    def __init__(__self__, *,
                 device: Optional[pulumi.Input[str]] = None,
                 distance: Optional[pulumi.Input[int]] = None,
                 gateway6: Optional[pulumi.Input[str]] = None,
                 geo_filter: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Ipsurlfiltersetting6 resources.
        :param pulumi.Input[str] device: Interface for this route.
        :param pulumi.Input[int] distance: Administrative distance (1 - 255) for this route.
        :param pulumi.Input[str] gateway6: Gateway IPv6 address for this route.
        :param pulumi.Input[str] geo_filter: Filter based on geographical location. Route will NOT be installed if the resolved IPv6 address belongs to the country in the filter.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        if device is not None:
            pulumi.set(__self__, "device", device)
        if distance is not None:
            pulumi.set(__self__, "distance", distance)
        if gateway6 is not None:
            pulumi.set(__self__, "gateway6", gateway6)
        if geo_filter is not None:
            pulumi.set(__self__, "geo_filter", geo_filter)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        Interface for this route.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter
    def distance(self) -> Optional[pulumi.Input[int]]:
        """
        Administrative distance (1 - 255) for this route.
        """
        return pulumi.get(self, "distance")

    @distance.setter
    def distance(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "distance", value)

    @property
    @pulumi.getter
    def gateway6(self) -> Optional[pulumi.Input[str]]:
        """
        Gateway IPv6 address for this route.
        """
        return pulumi.get(self, "gateway6")

    @gateway6.setter
    def gateway6(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "gateway6", value)

    @property
    @pulumi.getter(name="geoFilter")
    def geo_filter(self) -> Optional[pulumi.Input[str]]:
        """
        Filter based on geographical location. Route will NOT be installed if the resolved IPv6 address belongs to the country in the filter.
        """
        return pulumi.get(self, "geo_filter")

    @geo_filter.setter
    def geo_filter(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "geo_filter", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)


class Ipsurlfiltersetting6(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 distance: Optional[pulumi.Input[int]] = None,
                 gateway6: Optional[pulumi.Input[str]] = None,
                 geo_filter: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Configure IPS URL filter settings for IPv6.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_fortios as fortios

        trname = fortios.filter.web.Ipsurlfiltersetting6("trname",
            distance=1,
            gateway6="::")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        Webfilter IpsUrlfilterSetting6 can be imported using any of these accepted formats:

        ```sh
        $ pulumi import fortios:filter/web/ipsurlfiltersetting6:Ipsurlfiltersetting6 labelname WebfilterIpsUrlfilterSetting6
        ```

        If you do not want to import arguments of block:

        $ export "FORTIOS_IMPORT_TABLE"="false"

        ```sh
        $ pulumi import fortios:filter/web/ipsurlfiltersetting6:Ipsurlfiltersetting6 labelname WebfilterIpsUrlfilterSetting6
        ```

        $ unset "FORTIOS_IMPORT_TABLE"

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] device: Interface for this route.
        :param pulumi.Input[int] distance: Administrative distance (1 - 255) for this route.
        :param pulumi.Input[str] gateway6: Gateway IPv6 address for this route.
        :param pulumi.Input[str] geo_filter: Filter based on geographical location. Route will NOT be installed if the resolved IPv6 address belongs to the country in the filter.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[Ipsurlfiltersetting6Args] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Configure IPS URL filter settings for IPv6.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_fortios as fortios

        trname = fortios.filter.web.Ipsurlfiltersetting6("trname",
            distance=1,
            gateway6="::")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        Webfilter IpsUrlfilterSetting6 can be imported using any of these accepted formats:

        ```sh
        $ pulumi import fortios:filter/web/ipsurlfiltersetting6:Ipsurlfiltersetting6 labelname WebfilterIpsUrlfilterSetting6
        ```

        If you do not want to import arguments of block:

        $ export "FORTIOS_IMPORT_TABLE"="false"

        ```sh
        $ pulumi import fortios:filter/web/ipsurlfiltersetting6:Ipsurlfiltersetting6 labelname WebfilterIpsUrlfilterSetting6
        ```

        $ unset "FORTIOS_IMPORT_TABLE"

        :param str resource_name: The name of the resource.
        :param Ipsurlfiltersetting6Args args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(Ipsurlfiltersetting6Args, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 distance: Optional[pulumi.Input[int]] = None,
                 gateway6: Optional[pulumi.Input[str]] = None,
                 geo_filter: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = Ipsurlfiltersetting6Args.__new__(Ipsurlfiltersetting6Args)

            __props__.__dict__["device"] = device
            __props__.__dict__["distance"] = distance
            __props__.__dict__["gateway6"] = gateway6
            __props__.__dict__["geo_filter"] = geo_filter
            __props__.__dict__["vdomparam"] = vdomparam
        super(Ipsurlfiltersetting6, __self__).__init__(
            'fortios:filter/web/ipsurlfiltersetting6:Ipsurlfiltersetting6',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            device: Optional[pulumi.Input[str]] = None,
            distance: Optional[pulumi.Input[int]] = None,
            gateway6: Optional[pulumi.Input[str]] = None,
            geo_filter: Optional[pulumi.Input[str]] = None,
            vdomparam: Optional[pulumi.Input[str]] = None) -> 'Ipsurlfiltersetting6':
        """
        Get an existing Ipsurlfiltersetting6 resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] device: Interface for this route.
        :param pulumi.Input[int] distance: Administrative distance (1 - 255) for this route.
        :param pulumi.Input[str] gateway6: Gateway IPv6 address for this route.
        :param pulumi.Input[str] geo_filter: Filter based on geographical location. Route will NOT be installed if the resolved IPv6 address belongs to the country in the filter.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _Ipsurlfiltersetting6State.__new__(_Ipsurlfiltersetting6State)

        __props__.__dict__["device"] = device
        __props__.__dict__["distance"] = distance
        __props__.__dict__["gateway6"] = gateway6
        __props__.__dict__["geo_filter"] = geo_filter
        __props__.__dict__["vdomparam"] = vdomparam
        return Ipsurlfiltersetting6(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def device(self) -> pulumi.Output[str]:
        """
        Interface for this route.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def distance(self) -> pulumi.Output[int]:
        """
        Administrative distance (1 - 255) for this route.
        """
        return pulumi.get(self, "distance")

    @property
    @pulumi.getter
    def gateway6(self) -> pulumi.Output[str]:
        """
        Gateway IPv6 address for this route.
        """
        return pulumi.get(self, "gateway6")

    @property
    @pulumi.getter(name="geoFilter")
    def geo_filter(self) -> pulumi.Output[Optional[str]]:
        """
        Filter based on geographical location. Route will NOT be installed if the resolved IPv6 address belongs to the country in the filter.
        """
        return pulumi.get(self, "geo_filter")

    @property
    @pulumi.getter
    def vdomparam(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

