# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ObjectIppoolArgs', 'ObjectIppool']

@pulumi.input_type
class ObjectIppoolArgs:
    def __init__(__self__, *,
                 endip: pulumi.Input[str],
                 startip: pulumi.Input[str],
                 type: pulumi.Input[str],
                 arp_reply: Optional[pulumi.Input[str]] = None,
                 comments: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a ObjectIppool resource.
        :param pulumi.Input[str] endip: Final IPv4 address (inclusive) in the range for the address pool (format xxx.xxx.xxx.xxx).
        :param pulumi.Input[str] startip: First IPv4 address (inclusive) in the range for the address pool (format xxx.xxx.xxx.xxx).
        :param pulumi.Input[str] type: IP pool type(Support overload and one-to-one).
        :param pulumi.Input[str] arp_reply: Enable/disable replying to ARP requests when an IP Pool is added to a policy.
        :param pulumi.Input[str] comments: Comment.
        :param pulumi.Input[str] name: IP pool name.
        """
        pulumi.set(__self__, "endip", endip)
        pulumi.set(__self__, "startip", startip)
        pulumi.set(__self__, "type", type)
        if arp_reply is not None:
            pulumi.set(__self__, "arp_reply", arp_reply)
        if comments is not None:
            pulumi.set(__self__, "comments", comments)
        if name is not None:
            pulumi.set(__self__, "name", name)

    @property
    @pulumi.getter
    def endip(self) -> pulumi.Input[str]:
        """
        Final IPv4 address (inclusive) in the range for the address pool (format xxx.xxx.xxx.xxx).
        """
        return pulumi.get(self, "endip")

    @endip.setter
    def endip(self, value: pulumi.Input[str]):
        pulumi.set(self, "endip", value)

    @property
    @pulumi.getter
    def startip(self) -> pulumi.Input[str]:
        """
        First IPv4 address (inclusive) in the range for the address pool (format xxx.xxx.xxx.xxx).
        """
        return pulumi.get(self, "startip")

    @startip.setter
    def startip(self, value: pulumi.Input[str]):
        pulumi.set(self, "startip", value)

    @property
    @pulumi.getter
    def type(self) -> pulumi.Input[str]:
        """
        IP pool type(Support overload and one-to-one).
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: pulumi.Input[str]):
        pulumi.set(self, "type", value)

    @property
    @pulumi.getter(name="arpReply")
    def arp_reply(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable replying to ARP requests when an IP Pool is added to a policy.
        """
        return pulumi.get(self, "arp_reply")

    @arp_reply.setter
    def arp_reply(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "arp_reply", value)

    @property
    @pulumi.getter
    def comments(self) -> Optional[pulumi.Input[str]]:
        """
        Comment.
        """
        return pulumi.get(self, "comments")

    @comments.setter
    def comments(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "comments", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        IP pool name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)


@pulumi.input_type
class _ObjectIppoolState:
    def __init__(__self__, *,
                 arp_reply: Optional[pulumi.Input[str]] = None,
                 comments: Optional[pulumi.Input[str]] = None,
                 endip: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 startip: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ObjectIppool resources.
        :param pulumi.Input[str] arp_reply: Enable/disable replying to ARP requests when an IP Pool is added to a policy.
        :param pulumi.Input[str] comments: Comment.
        :param pulumi.Input[str] endip: Final IPv4 address (inclusive) in the range for the address pool (format xxx.xxx.xxx.xxx).
        :param pulumi.Input[str] name: IP pool name.
        :param pulumi.Input[str] startip: First IPv4 address (inclusive) in the range for the address pool (format xxx.xxx.xxx.xxx).
        :param pulumi.Input[str] type: IP pool type(Support overload and one-to-one).
        """
        if arp_reply is not None:
            pulumi.set(__self__, "arp_reply", arp_reply)
        if comments is not None:
            pulumi.set(__self__, "comments", comments)
        if endip is not None:
            pulumi.set(__self__, "endip", endip)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if startip is not None:
            pulumi.set(__self__, "startip", startip)
        if type is not None:
            pulumi.set(__self__, "type", type)

    @property
    @pulumi.getter(name="arpReply")
    def arp_reply(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable replying to ARP requests when an IP Pool is added to a policy.
        """
        return pulumi.get(self, "arp_reply")

    @arp_reply.setter
    def arp_reply(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "arp_reply", value)

    @property
    @pulumi.getter
    def comments(self) -> Optional[pulumi.Input[str]]:
        """
        Comment.
        """
        return pulumi.get(self, "comments")

    @comments.setter
    def comments(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "comments", value)

    @property
    @pulumi.getter
    def endip(self) -> Optional[pulumi.Input[str]]:
        """
        Final IPv4 address (inclusive) in the range for the address pool (format xxx.xxx.xxx.xxx).
        """
        return pulumi.get(self, "endip")

    @endip.setter
    def endip(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "endip", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        IP pool name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def startip(self) -> Optional[pulumi.Input[str]]:
        """
        First IPv4 address (inclusive) in the range for the address pool (format xxx.xxx.xxx.xxx).
        """
        return pulumi.get(self, "startip")

    @startip.setter
    def startip(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "startip", value)

    @property
    @pulumi.getter
    def type(self) -> Optional[pulumi.Input[str]]:
        """
        IP pool type(Support overload and one-to-one).
        """
        return pulumi.get(self, "type")

    @type.setter
    def type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "type", value)


class ObjectIppool(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 arp_reply: Optional[pulumi.Input[str]] = None,
                 comments: Optional[pulumi.Input[str]] = None,
                 endip: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 startip: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to configure IPv4 IP address pools of FortiOS.

        !> **Warning:** The resource will be deprecated and replaced by new resource `firewall.Ippool`, we recommend that you use the new resource.

        ## Example Usage

        ### Overload Ippool
        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_fortios as fortios

        s1 = fortios.firewall.ObjectIppool("s1",
            arp_reply="enable",
            comments="fdsaf",
            endip="22.0.0.0",
            startip="11.0.0.0",
            type="overload")
        ```
        <!--End PulumiCodeChooser -->

        ### One-To-One Ippool
        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_fortios as fortios

        s2 = fortios.firewall.ObjectIppool("s2",
            arp_reply="enable",
            comments="fdsaf",
            endip="222.0.0.0",
            startip="121.0.0.0",
            type="one-to-one")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] arp_reply: Enable/disable replying to ARP requests when an IP Pool is added to a policy.
        :param pulumi.Input[str] comments: Comment.
        :param pulumi.Input[str] endip: Final IPv4 address (inclusive) in the range for the address pool (format xxx.xxx.xxx.xxx).
        :param pulumi.Input[str] name: IP pool name.
        :param pulumi.Input[str] startip: First IPv4 address (inclusive) in the range for the address pool (format xxx.xxx.xxx.xxx).
        :param pulumi.Input[str] type: IP pool type(Support overload and one-to-one).
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ObjectIppoolArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to configure IPv4 IP address pools of FortiOS.

        !> **Warning:** The resource will be deprecated and replaced by new resource `firewall.Ippool`, we recommend that you use the new resource.

        ## Example Usage

        ### Overload Ippool
        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_fortios as fortios

        s1 = fortios.firewall.ObjectIppool("s1",
            arp_reply="enable",
            comments="fdsaf",
            endip="22.0.0.0",
            startip="11.0.0.0",
            type="overload")
        ```
        <!--End PulumiCodeChooser -->

        ### One-To-One Ippool
        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_fortios as fortios

        s2 = fortios.firewall.ObjectIppool("s2",
            arp_reply="enable",
            comments="fdsaf",
            endip="222.0.0.0",
            startip="121.0.0.0",
            type="one-to-one")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param ObjectIppoolArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ObjectIppoolArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 arp_reply: Optional[pulumi.Input[str]] = None,
                 comments: Optional[pulumi.Input[str]] = None,
                 endip: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 startip: Optional[pulumi.Input[str]] = None,
                 type: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ObjectIppoolArgs.__new__(ObjectIppoolArgs)

            __props__.__dict__["arp_reply"] = arp_reply
            __props__.__dict__["comments"] = comments
            if endip is None and not opts.urn:
                raise TypeError("Missing required property 'endip'")
            __props__.__dict__["endip"] = endip
            __props__.__dict__["name"] = name
            if startip is None and not opts.urn:
                raise TypeError("Missing required property 'startip'")
            __props__.__dict__["startip"] = startip
            if type is None and not opts.urn:
                raise TypeError("Missing required property 'type'")
            __props__.__dict__["type"] = type
        super(ObjectIppool, __self__).__init__(
            'fortios:firewall/objectIppool:ObjectIppool',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            arp_reply: Optional[pulumi.Input[str]] = None,
            comments: Optional[pulumi.Input[str]] = None,
            endip: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            startip: Optional[pulumi.Input[str]] = None,
            type: Optional[pulumi.Input[str]] = None) -> 'ObjectIppool':
        """
        Get an existing ObjectIppool resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] arp_reply: Enable/disable replying to ARP requests when an IP Pool is added to a policy.
        :param pulumi.Input[str] comments: Comment.
        :param pulumi.Input[str] endip: Final IPv4 address (inclusive) in the range for the address pool (format xxx.xxx.xxx.xxx).
        :param pulumi.Input[str] name: IP pool name.
        :param pulumi.Input[str] startip: First IPv4 address (inclusive) in the range for the address pool (format xxx.xxx.xxx.xxx).
        :param pulumi.Input[str] type: IP pool type(Support overload and one-to-one).
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ObjectIppoolState.__new__(_ObjectIppoolState)

        __props__.__dict__["arp_reply"] = arp_reply
        __props__.__dict__["comments"] = comments
        __props__.__dict__["endip"] = endip
        __props__.__dict__["name"] = name
        __props__.__dict__["startip"] = startip
        __props__.__dict__["type"] = type
        return ObjectIppool(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="arpReply")
    def arp_reply(self) -> pulumi.Output[str]:
        """
        Enable/disable replying to ARP requests when an IP Pool is added to a policy.
        """
        return pulumi.get(self, "arp_reply")

    @property
    @pulumi.getter
    def comments(self) -> pulumi.Output[Optional[str]]:
        """
        Comment.
        """
        return pulumi.get(self, "comments")

    @property
    @pulumi.getter
    def endip(self) -> pulumi.Output[str]:
        """
        Final IPv4 address (inclusive) in the range for the address pool (format xxx.xxx.xxx.xxx).
        """
        return pulumi.get(self, "endip")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        IP pool name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def startip(self) -> pulumi.Output[str]:
        """
        First IPv4 address (inclusive) in the range for the address pool (format xxx.xxx.xxx.xxx).
        """
        return pulumi.get(self, "startip")

    @property
    @pulumi.getter
    def type(self) -> pulumi.Output[str]:
        """
        IP pool type(Support overload and one-to-one).
        """
        return pulumi.get(self, "type")

