# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['ObjectServiceArgs', 'ObjectService']

@pulumi.input_type
class ObjectServiceArgs:
    def __init__(__self__, *,
                 category: pulumi.Input[str],
                 protocol: pulumi.Input[str],
                 comment: Optional[pulumi.Input[str]] = None,
                 fqdn: Optional[pulumi.Input[str]] = None,
                 icmpcode: Optional[pulumi.Input[str]] = None,
                 icmptype: Optional[pulumi.Input[str]] = None,
                 iprange: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 protocol_number: Optional[pulumi.Input[str]] = None,
                 sctp_portrange: Optional[pulumi.Input[str]] = None,
                 session_ttl: Optional[pulumi.Input[str]] = None,
                 tcp_portrange: Optional[pulumi.Input[str]] = None,
                 udp_portrange: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a ObjectService resource.
        :param pulumi.Input[str] category: Service category.
        :param pulumi.Input[str] protocol: Protocol type based on IANA numbers.
        :param pulumi.Input[str] comment: Comment.
        :param pulumi.Input[str] fqdn: Fully qualified domain name.
        :param pulumi.Input[str] icmpcode: ICMP code.
        :param pulumi.Input[str] icmptype: ICMP type.
        :param pulumi.Input[str] iprange: Start and end of the IP range associated with service.
        :param pulumi.Input[str] name: Number of minutes before an idle administrator session time out.
        :param pulumi.Input[str] protocol_number: IP protocol number.
        :param pulumi.Input[str] sctp_portrange: Multiple SCTP port ranges.
        :param pulumi.Input[str] session_ttl: Custom tcp session TTL.
        :param pulumi.Input[str] tcp_portrange: Multiple TCP port ranges.
        :param pulumi.Input[str] udp_portrange: Multiple UDP port ranges.
        """
        pulumi.set(__self__, "category", category)
        pulumi.set(__self__, "protocol", protocol)
        if comment is not None:
            pulumi.set(__self__, "comment", comment)
        if fqdn is not None:
            pulumi.set(__self__, "fqdn", fqdn)
        if icmpcode is not None:
            pulumi.set(__self__, "icmpcode", icmpcode)
        if icmptype is not None:
            pulumi.set(__self__, "icmptype", icmptype)
        if iprange is not None:
            pulumi.set(__self__, "iprange", iprange)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if protocol_number is not None:
            pulumi.set(__self__, "protocol_number", protocol_number)
        if sctp_portrange is not None:
            pulumi.set(__self__, "sctp_portrange", sctp_portrange)
        if session_ttl is not None:
            pulumi.set(__self__, "session_ttl", session_ttl)
        if tcp_portrange is not None:
            pulumi.set(__self__, "tcp_portrange", tcp_portrange)
        if udp_portrange is not None:
            pulumi.set(__self__, "udp_portrange", udp_portrange)

    @property
    @pulumi.getter
    def category(self) -> pulumi.Input[str]:
        """
        Service category.
        """
        return pulumi.get(self, "category")

    @category.setter
    def category(self, value: pulumi.Input[str]):
        pulumi.set(self, "category", value)

    @property
    @pulumi.getter
    def protocol(self) -> pulumi.Input[str]:
        """
        Protocol type based on IANA numbers.
        """
        return pulumi.get(self, "protocol")

    @protocol.setter
    def protocol(self, value: pulumi.Input[str]):
        pulumi.set(self, "protocol", value)

    @property
    @pulumi.getter
    def comment(self) -> Optional[pulumi.Input[str]]:
        """
        Comment.
        """
        return pulumi.get(self, "comment")

    @comment.setter
    def comment(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "comment", value)

    @property
    @pulumi.getter
    def fqdn(self) -> Optional[pulumi.Input[str]]:
        """
        Fully qualified domain name.
        """
        return pulumi.get(self, "fqdn")

    @fqdn.setter
    def fqdn(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "fqdn", value)

    @property
    @pulumi.getter
    def icmpcode(self) -> Optional[pulumi.Input[str]]:
        """
        ICMP code.
        """
        return pulumi.get(self, "icmpcode")

    @icmpcode.setter
    def icmpcode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "icmpcode", value)

    @property
    @pulumi.getter
    def icmptype(self) -> Optional[pulumi.Input[str]]:
        """
        ICMP type.
        """
        return pulumi.get(self, "icmptype")

    @icmptype.setter
    def icmptype(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "icmptype", value)

    @property
    @pulumi.getter
    def iprange(self) -> Optional[pulumi.Input[str]]:
        """
        Start and end of the IP range associated with service.
        """
        return pulumi.get(self, "iprange")

    @iprange.setter
    def iprange(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "iprange", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Number of minutes before an idle administrator session time out.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="protocolNumber")
    def protocol_number(self) -> Optional[pulumi.Input[str]]:
        """
        IP protocol number.
        """
        return pulumi.get(self, "protocol_number")

    @protocol_number.setter
    def protocol_number(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "protocol_number", value)

    @property
    @pulumi.getter(name="sctpPortrange")
    def sctp_portrange(self) -> Optional[pulumi.Input[str]]:
        """
        Multiple SCTP port ranges.
        """
        return pulumi.get(self, "sctp_portrange")

    @sctp_portrange.setter
    def sctp_portrange(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "sctp_portrange", value)

    @property
    @pulumi.getter(name="sessionTtl")
    def session_ttl(self) -> Optional[pulumi.Input[str]]:
        """
        Custom tcp session TTL.
        """
        return pulumi.get(self, "session_ttl")

    @session_ttl.setter
    def session_ttl(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "session_ttl", value)

    @property
    @pulumi.getter(name="tcpPortrange")
    def tcp_portrange(self) -> Optional[pulumi.Input[str]]:
        """
        Multiple TCP port ranges.
        """
        return pulumi.get(self, "tcp_portrange")

    @tcp_portrange.setter
    def tcp_portrange(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "tcp_portrange", value)

    @property
    @pulumi.getter(name="udpPortrange")
    def udp_portrange(self) -> Optional[pulumi.Input[str]]:
        """
        Multiple UDP port ranges.
        """
        return pulumi.get(self, "udp_portrange")

    @udp_portrange.setter
    def udp_portrange(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "udp_portrange", value)


@pulumi.input_type
class _ObjectServiceState:
    def __init__(__self__, *,
                 category: Optional[pulumi.Input[str]] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 fqdn: Optional[pulumi.Input[str]] = None,
                 icmpcode: Optional[pulumi.Input[str]] = None,
                 icmptype: Optional[pulumi.Input[str]] = None,
                 iprange: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 protocol: Optional[pulumi.Input[str]] = None,
                 protocol_number: Optional[pulumi.Input[str]] = None,
                 sctp_portrange: Optional[pulumi.Input[str]] = None,
                 session_ttl: Optional[pulumi.Input[str]] = None,
                 tcp_portrange: Optional[pulumi.Input[str]] = None,
                 udp_portrange: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering ObjectService resources.
        :param pulumi.Input[str] category: Service category.
        :param pulumi.Input[str] comment: Comment.
        :param pulumi.Input[str] fqdn: Fully qualified domain name.
        :param pulumi.Input[str] icmpcode: ICMP code.
        :param pulumi.Input[str] icmptype: ICMP type.
        :param pulumi.Input[str] iprange: Start and end of the IP range associated with service.
        :param pulumi.Input[str] name: Number of minutes before an idle administrator session time out.
        :param pulumi.Input[str] protocol: Protocol type based on IANA numbers.
        :param pulumi.Input[str] protocol_number: IP protocol number.
        :param pulumi.Input[str] sctp_portrange: Multiple SCTP port ranges.
        :param pulumi.Input[str] session_ttl: Custom tcp session TTL.
        :param pulumi.Input[str] tcp_portrange: Multiple TCP port ranges.
        :param pulumi.Input[str] udp_portrange: Multiple UDP port ranges.
        """
        if category is not None:
            pulumi.set(__self__, "category", category)
        if comment is not None:
            pulumi.set(__self__, "comment", comment)
        if fqdn is not None:
            pulumi.set(__self__, "fqdn", fqdn)
        if icmpcode is not None:
            pulumi.set(__self__, "icmpcode", icmpcode)
        if icmptype is not None:
            pulumi.set(__self__, "icmptype", icmptype)
        if iprange is not None:
            pulumi.set(__self__, "iprange", iprange)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if protocol is not None:
            pulumi.set(__self__, "protocol", protocol)
        if protocol_number is not None:
            pulumi.set(__self__, "protocol_number", protocol_number)
        if sctp_portrange is not None:
            pulumi.set(__self__, "sctp_portrange", sctp_portrange)
        if session_ttl is not None:
            pulumi.set(__self__, "session_ttl", session_ttl)
        if tcp_portrange is not None:
            pulumi.set(__self__, "tcp_portrange", tcp_portrange)
        if udp_portrange is not None:
            pulumi.set(__self__, "udp_portrange", udp_portrange)

    @property
    @pulumi.getter
    def category(self) -> Optional[pulumi.Input[str]]:
        """
        Service category.
        """
        return pulumi.get(self, "category")

    @category.setter
    def category(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "category", value)

    @property
    @pulumi.getter
    def comment(self) -> Optional[pulumi.Input[str]]:
        """
        Comment.
        """
        return pulumi.get(self, "comment")

    @comment.setter
    def comment(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "comment", value)

    @property
    @pulumi.getter
    def fqdn(self) -> Optional[pulumi.Input[str]]:
        """
        Fully qualified domain name.
        """
        return pulumi.get(self, "fqdn")

    @fqdn.setter
    def fqdn(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "fqdn", value)

    @property
    @pulumi.getter
    def icmpcode(self) -> Optional[pulumi.Input[str]]:
        """
        ICMP code.
        """
        return pulumi.get(self, "icmpcode")

    @icmpcode.setter
    def icmpcode(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "icmpcode", value)

    @property
    @pulumi.getter
    def icmptype(self) -> Optional[pulumi.Input[str]]:
        """
        ICMP type.
        """
        return pulumi.get(self, "icmptype")

    @icmptype.setter
    def icmptype(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "icmptype", value)

    @property
    @pulumi.getter
    def iprange(self) -> Optional[pulumi.Input[str]]:
        """
        Start and end of the IP range associated with service.
        """
        return pulumi.get(self, "iprange")

    @iprange.setter
    def iprange(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "iprange", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Number of minutes before an idle administrator session time out.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def protocol(self) -> Optional[pulumi.Input[str]]:
        """
        Protocol type based on IANA numbers.
        """
        return pulumi.get(self, "protocol")

    @protocol.setter
    def protocol(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "protocol", value)

    @property
    @pulumi.getter(name="protocolNumber")
    def protocol_number(self) -> Optional[pulumi.Input[str]]:
        """
        IP protocol number.
        """
        return pulumi.get(self, "protocol_number")

    @protocol_number.setter
    def protocol_number(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "protocol_number", value)

    @property
    @pulumi.getter(name="sctpPortrange")
    def sctp_portrange(self) -> Optional[pulumi.Input[str]]:
        """
        Multiple SCTP port ranges.
        """
        return pulumi.get(self, "sctp_portrange")

    @sctp_portrange.setter
    def sctp_portrange(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "sctp_portrange", value)

    @property
    @pulumi.getter(name="sessionTtl")
    def session_ttl(self) -> Optional[pulumi.Input[str]]:
        """
        Custom tcp session TTL.
        """
        return pulumi.get(self, "session_ttl")

    @session_ttl.setter
    def session_ttl(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "session_ttl", value)

    @property
    @pulumi.getter(name="tcpPortrange")
    def tcp_portrange(self) -> Optional[pulumi.Input[str]]:
        """
        Multiple TCP port ranges.
        """
        return pulumi.get(self, "tcp_portrange")

    @tcp_portrange.setter
    def tcp_portrange(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "tcp_portrange", value)

    @property
    @pulumi.getter(name="udpPortrange")
    def udp_portrange(self) -> Optional[pulumi.Input[str]]:
        """
        Multiple UDP port ranges.
        """
        return pulumi.get(self, "udp_portrange")

    @udp_portrange.setter
    def udp_portrange(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "udp_portrange", value)


class ObjectService(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 category: Optional[pulumi.Input[str]] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 fqdn: Optional[pulumi.Input[str]] = None,
                 icmpcode: Optional[pulumi.Input[str]] = None,
                 icmptype: Optional[pulumi.Input[str]] = None,
                 iprange: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 protocol: Optional[pulumi.Input[str]] = None,
                 protocol_number: Optional[pulumi.Input[str]] = None,
                 sctp_portrange: Optional[pulumi.Input[str]] = None,
                 session_ttl: Optional[pulumi.Input[str]] = None,
                 tcp_portrange: Optional[pulumi.Input[str]] = None,
                 udp_portrange: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to configure firewall service of FortiOS.

        !> **Warning:** The resource will be deprecated and replaced by new resource `firewall/service.Custom`, we recommend that you use the new resource.

        ## Example Usage

        ### Fqdn Service
        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_fortios as fortios

        v11 = fortios.firewall.ObjectService("v11",
            category="General",
            comment="comment",
            fqdn="abc.com",
            protocol="TCP/UDP/SCTP")
        ```
        <!--End PulumiCodeChooser -->

        ### Iprange Service
        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_fortios as fortios

        v13 = fortios.firewall.ObjectService("v13",
            category="General",
            comment="comment",
            iprange="1.1.1.1-2.2.2.2",
            protocol="TCP/UDP/SCTP",
            sctp_portrange="66-88",
            tcp_portrange="22-33",
            udp_portrange="44-55")
        ```
        <!--End PulumiCodeChooser -->

        ### ICMP Service
        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_fortios as fortios

        i_cmp = fortios.firewall.ObjectService("iCMP",
            category="General",
            comment="comment",
            icmpcode="3",
            icmptype="2",
            protocol="ICMP",
            protocol_number="1")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] category: Service category.
        :param pulumi.Input[str] comment: Comment.
        :param pulumi.Input[str] fqdn: Fully qualified domain name.
        :param pulumi.Input[str] icmpcode: ICMP code.
        :param pulumi.Input[str] icmptype: ICMP type.
        :param pulumi.Input[str] iprange: Start and end of the IP range associated with service.
        :param pulumi.Input[str] name: Number of minutes before an idle administrator session time out.
        :param pulumi.Input[str] protocol: Protocol type based on IANA numbers.
        :param pulumi.Input[str] protocol_number: IP protocol number.
        :param pulumi.Input[str] sctp_portrange: Multiple SCTP port ranges.
        :param pulumi.Input[str] session_ttl: Custom tcp session TTL.
        :param pulumi.Input[str] tcp_portrange: Multiple TCP port ranges.
        :param pulumi.Input[str] udp_portrange: Multiple UDP port ranges.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: ObjectServiceArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to configure firewall service of FortiOS.

        !> **Warning:** The resource will be deprecated and replaced by new resource `firewall/service.Custom`, we recommend that you use the new resource.

        ## Example Usage

        ### Fqdn Service
        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_fortios as fortios

        v11 = fortios.firewall.ObjectService("v11",
            category="General",
            comment="comment",
            fqdn="abc.com",
            protocol="TCP/UDP/SCTP")
        ```
        <!--End PulumiCodeChooser -->

        ### Iprange Service
        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_fortios as fortios

        v13 = fortios.firewall.ObjectService("v13",
            category="General",
            comment="comment",
            iprange="1.1.1.1-2.2.2.2",
            protocol="TCP/UDP/SCTP",
            sctp_portrange="66-88",
            tcp_portrange="22-33",
            udp_portrange="44-55")
        ```
        <!--End PulumiCodeChooser -->

        ### ICMP Service
        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_fortios as fortios

        i_cmp = fortios.firewall.ObjectService("iCMP",
            category="General",
            comment="comment",
            icmpcode="3",
            icmptype="2",
            protocol="ICMP",
            protocol_number="1")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param ObjectServiceArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ObjectServiceArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 category: Optional[pulumi.Input[str]] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 fqdn: Optional[pulumi.Input[str]] = None,
                 icmpcode: Optional[pulumi.Input[str]] = None,
                 icmptype: Optional[pulumi.Input[str]] = None,
                 iprange: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 protocol: Optional[pulumi.Input[str]] = None,
                 protocol_number: Optional[pulumi.Input[str]] = None,
                 sctp_portrange: Optional[pulumi.Input[str]] = None,
                 session_ttl: Optional[pulumi.Input[str]] = None,
                 tcp_portrange: Optional[pulumi.Input[str]] = None,
                 udp_portrange: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ObjectServiceArgs.__new__(ObjectServiceArgs)

            if category is None and not opts.urn:
                raise TypeError("Missing required property 'category'")
            __props__.__dict__["category"] = category
            __props__.__dict__["comment"] = comment
            __props__.__dict__["fqdn"] = fqdn
            __props__.__dict__["icmpcode"] = icmpcode
            __props__.__dict__["icmptype"] = icmptype
            __props__.__dict__["iprange"] = iprange
            __props__.__dict__["name"] = name
            if protocol is None and not opts.urn:
                raise TypeError("Missing required property 'protocol'")
            __props__.__dict__["protocol"] = protocol
            __props__.__dict__["protocol_number"] = protocol_number
            __props__.__dict__["sctp_portrange"] = sctp_portrange
            __props__.__dict__["session_ttl"] = session_ttl
            __props__.__dict__["tcp_portrange"] = tcp_portrange
            __props__.__dict__["udp_portrange"] = udp_portrange
        super(ObjectService, __self__).__init__(
            'fortios:firewall/objectService:ObjectService',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            category: Optional[pulumi.Input[str]] = None,
            comment: Optional[pulumi.Input[str]] = None,
            fqdn: Optional[pulumi.Input[str]] = None,
            icmpcode: Optional[pulumi.Input[str]] = None,
            icmptype: Optional[pulumi.Input[str]] = None,
            iprange: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            protocol: Optional[pulumi.Input[str]] = None,
            protocol_number: Optional[pulumi.Input[str]] = None,
            sctp_portrange: Optional[pulumi.Input[str]] = None,
            session_ttl: Optional[pulumi.Input[str]] = None,
            tcp_portrange: Optional[pulumi.Input[str]] = None,
            udp_portrange: Optional[pulumi.Input[str]] = None) -> 'ObjectService':
        """
        Get an existing ObjectService resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] category: Service category.
        :param pulumi.Input[str] comment: Comment.
        :param pulumi.Input[str] fqdn: Fully qualified domain name.
        :param pulumi.Input[str] icmpcode: ICMP code.
        :param pulumi.Input[str] icmptype: ICMP type.
        :param pulumi.Input[str] iprange: Start and end of the IP range associated with service.
        :param pulumi.Input[str] name: Number of minutes before an idle administrator session time out.
        :param pulumi.Input[str] protocol: Protocol type based on IANA numbers.
        :param pulumi.Input[str] protocol_number: IP protocol number.
        :param pulumi.Input[str] sctp_portrange: Multiple SCTP port ranges.
        :param pulumi.Input[str] session_ttl: Custom tcp session TTL.
        :param pulumi.Input[str] tcp_portrange: Multiple TCP port ranges.
        :param pulumi.Input[str] udp_portrange: Multiple UDP port ranges.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ObjectServiceState.__new__(_ObjectServiceState)

        __props__.__dict__["category"] = category
        __props__.__dict__["comment"] = comment
        __props__.__dict__["fqdn"] = fqdn
        __props__.__dict__["icmpcode"] = icmpcode
        __props__.__dict__["icmptype"] = icmptype
        __props__.__dict__["iprange"] = iprange
        __props__.__dict__["name"] = name
        __props__.__dict__["protocol"] = protocol
        __props__.__dict__["protocol_number"] = protocol_number
        __props__.__dict__["sctp_portrange"] = sctp_portrange
        __props__.__dict__["session_ttl"] = session_ttl
        __props__.__dict__["tcp_portrange"] = tcp_portrange
        __props__.__dict__["udp_portrange"] = udp_portrange
        return ObjectService(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def category(self) -> pulumi.Output[str]:
        """
        Service category.
        """
        return pulumi.get(self, "category")

    @property
    @pulumi.getter
    def comment(self) -> pulumi.Output[Optional[str]]:
        """
        Comment.
        """
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def fqdn(self) -> pulumi.Output[str]:
        """
        Fully qualified domain name.
        """
        return pulumi.get(self, "fqdn")

    @property
    @pulumi.getter
    def icmpcode(self) -> pulumi.Output[str]:
        """
        ICMP code.
        """
        return pulumi.get(self, "icmpcode")

    @property
    @pulumi.getter
    def icmptype(self) -> pulumi.Output[str]:
        """
        ICMP type.
        """
        return pulumi.get(self, "icmptype")

    @property
    @pulumi.getter
    def iprange(self) -> pulumi.Output[str]:
        """
        Start and end of the IP range associated with service.
        """
        return pulumi.get(self, "iprange")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Number of minutes before an idle administrator session time out.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def protocol(self) -> pulumi.Output[str]:
        """
        Protocol type based on IANA numbers.
        """
        return pulumi.get(self, "protocol")

    @property
    @pulumi.getter(name="protocolNumber")
    def protocol_number(self) -> pulumi.Output[str]:
        """
        IP protocol number.
        """
        return pulumi.get(self, "protocol_number")

    @property
    @pulumi.getter(name="sctpPortrange")
    def sctp_portrange(self) -> pulumi.Output[str]:
        """
        Multiple SCTP port ranges.
        """
        return pulumi.get(self, "sctp_portrange")

    @property
    @pulumi.getter(name="sessionTtl")
    def session_ttl(self) -> pulumi.Output[str]:
        """
        Custom tcp session TTL.
        """
        return pulumi.get(self, "session_ttl")

    @property
    @pulumi.getter(name="tcpPortrange")
    def tcp_portrange(self) -> pulumi.Output[str]:
        """
        Multiple TCP port ranges.
        """
        return pulumi.get(self, "tcp_portrange")

    @property
    @pulumi.getter(name="udpPortrange")
    def udp_portrange(self) -> pulumi.Output[str]:
        """
        Multiple UDP port ranges.
        """
        return pulumi.get(self, "udp_portrange")

