# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ProfileprotocoloptionsArgs', 'Profileprotocoloptions']

@pulumi.input_type
class ProfileprotocoloptionsArgs:
    def __init__(__self__, *,
                 cifs: Optional[pulumi.Input['ProfileprotocoloptionsCifsArgs']] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 dns: Optional[pulumi.Input['ProfileprotocoloptionsDnsArgs']] = None,
                 feature_set: Optional[pulumi.Input[str]] = None,
                 ftp: Optional[pulumi.Input['ProfileprotocoloptionsFtpArgs']] = None,
                 get_all_tables: Optional[pulumi.Input[str]] = None,
                 http: Optional[pulumi.Input['ProfileprotocoloptionsHttpArgs']] = None,
                 imap: Optional[pulumi.Input['ProfileprotocoloptionsImapArgs']] = None,
                 mail_signature: Optional[pulumi.Input['ProfileprotocoloptionsMailSignatureArgs']] = None,
                 mapi: Optional[pulumi.Input['ProfileprotocoloptionsMapiArgs']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 nntp: Optional[pulumi.Input['ProfileprotocoloptionsNntpArgs']] = None,
                 oversize_log: Optional[pulumi.Input[str]] = None,
                 pop3: Optional[pulumi.Input['ProfileprotocoloptionsPop3Args']] = None,
                 replacemsg_group: Optional[pulumi.Input[str]] = None,
                 rpc_over_http: Optional[pulumi.Input[str]] = None,
                 smtp: Optional[pulumi.Input['ProfileprotocoloptionsSmtpArgs']] = None,
                 ssh: Optional[pulumi.Input['ProfileprotocoloptionsSshArgs']] = None,
                 switching_protocols_log: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Profileprotocoloptions resource.
        :param pulumi.Input['ProfileprotocoloptionsCifsArgs'] cifs: Configure CIFS protocol options. The structure of `cifs` block is documented below.
        :param pulumi.Input[str] comment: Optional comments.
        :param pulumi.Input['ProfileprotocoloptionsDnsArgs'] dns: Configure DNS protocol options. The structure of `dns` block is documented below.
        :param pulumi.Input[str] feature_set: Flow/proxy feature set. Valid values: `flow`, `proxy`.
        :param pulumi.Input['ProfileprotocoloptionsFtpArgs'] ftp: Configure FTP protocol options. The structure of `ftp` block is documented below.
        :param pulumi.Input[str] get_all_tables: Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        :param pulumi.Input['ProfileprotocoloptionsHttpArgs'] http: Configure HTTP protocol options. The structure of `http` block is documented below.
        :param pulumi.Input['ProfileprotocoloptionsImapArgs'] imap: Configure IMAP protocol options. The structure of `imap` block is documented below.
        :param pulumi.Input['ProfileprotocoloptionsMailSignatureArgs'] mail_signature: Configure Mail signature. The structure of `mail_signature` block is documented below.
        :param pulumi.Input['ProfileprotocoloptionsMapiArgs'] mapi: Configure MAPI protocol options. The structure of `mapi` block is documented below.
        :param pulumi.Input[str] name: Name.
        :param pulumi.Input['ProfileprotocoloptionsNntpArgs'] nntp: Configure NNTP protocol options. The structure of `nntp` block is documented below.
        :param pulumi.Input[str] oversize_log: Enable/disable logging for antivirus oversize file blocking. Valid values: `disable`, `enable`.
        :param pulumi.Input['ProfileprotocoloptionsPop3Args'] pop3: Configure POP3 protocol options. The structure of `pop3` block is documented below.
        :param pulumi.Input[str] replacemsg_group: Name of the replacement message group to be used
        :param pulumi.Input[str] rpc_over_http: Enable/disable inspection of RPC over HTTP. Valid values: `enable`, `disable`.
        :param pulumi.Input['ProfileprotocoloptionsSmtpArgs'] smtp: Configure SMTP protocol options. The structure of `smtp` block is documented below.
        :param pulumi.Input['ProfileprotocoloptionsSshArgs'] ssh: Configure SFTP and SCP protocol options. The structure of `ssh` block is documented below.
        :param pulumi.Input[str] switching_protocols_log: Enable/disable logging for HTTP/HTTPS switching protocols. Valid values: `disable`, `enable`.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        if cifs is not None:
            pulumi.set(__self__, "cifs", cifs)
        if comment is not None:
            pulumi.set(__self__, "comment", comment)
        if dns is not None:
            pulumi.set(__self__, "dns", dns)
        if feature_set is not None:
            pulumi.set(__self__, "feature_set", feature_set)
        if ftp is not None:
            pulumi.set(__self__, "ftp", ftp)
        if get_all_tables is not None:
            pulumi.set(__self__, "get_all_tables", get_all_tables)
        if http is not None:
            pulumi.set(__self__, "http", http)
        if imap is not None:
            pulumi.set(__self__, "imap", imap)
        if mail_signature is not None:
            pulumi.set(__self__, "mail_signature", mail_signature)
        if mapi is not None:
            pulumi.set(__self__, "mapi", mapi)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if nntp is not None:
            pulumi.set(__self__, "nntp", nntp)
        if oversize_log is not None:
            pulumi.set(__self__, "oversize_log", oversize_log)
        if pop3 is not None:
            pulumi.set(__self__, "pop3", pop3)
        if replacemsg_group is not None:
            pulumi.set(__self__, "replacemsg_group", replacemsg_group)
        if rpc_over_http is not None:
            pulumi.set(__self__, "rpc_over_http", rpc_over_http)
        if smtp is not None:
            pulumi.set(__self__, "smtp", smtp)
        if ssh is not None:
            pulumi.set(__self__, "ssh", ssh)
        if switching_protocols_log is not None:
            pulumi.set(__self__, "switching_protocols_log", switching_protocols_log)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter
    def cifs(self) -> Optional[pulumi.Input['ProfileprotocoloptionsCifsArgs']]:
        """
        Configure CIFS protocol options. The structure of `cifs` block is documented below.
        """
        return pulumi.get(self, "cifs")

    @cifs.setter
    def cifs(self, value: Optional[pulumi.Input['ProfileprotocoloptionsCifsArgs']]):
        pulumi.set(self, "cifs", value)

    @property
    @pulumi.getter
    def comment(self) -> Optional[pulumi.Input[str]]:
        """
        Optional comments.
        """
        return pulumi.get(self, "comment")

    @comment.setter
    def comment(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "comment", value)

    @property
    @pulumi.getter
    def dns(self) -> Optional[pulumi.Input['ProfileprotocoloptionsDnsArgs']]:
        """
        Configure DNS protocol options. The structure of `dns` block is documented below.
        """
        return pulumi.get(self, "dns")

    @dns.setter
    def dns(self, value: Optional[pulumi.Input['ProfileprotocoloptionsDnsArgs']]):
        pulumi.set(self, "dns", value)

    @property
    @pulumi.getter(name="featureSet")
    def feature_set(self) -> Optional[pulumi.Input[str]]:
        """
        Flow/proxy feature set. Valid values: `flow`, `proxy`.
        """
        return pulumi.get(self, "feature_set")

    @feature_set.setter
    def feature_set(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "feature_set", value)

    @property
    @pulumi.getter
    def ftp(self) -> Optional[pulumi.Input['ProfileprotocoloptionsFtpArgs']]:
        """
        Configure FTP protocol options. The structure of `ftp` block is documented below.
        """
        return pulumi.get(self, "ftp")

    @ftp.setter
    def ftp(self, value: Optional[pulumi.Input['ProfileprotocoloptionsFtpArgs']]):
        pulumi.set(self, "ftp", value)

    @property
    @pulumi.getter(name="getAllTables")
    def get_all_tables(self) -> Optional[pulumi.Input[str]]:
        """
        Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        """
        return pulumi.get(self, "get_all_tables")

    @get_all_tables.setter
    def get_all_tables(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "get_all_tables", value)

    @property
    @pulumi.getter
    def http(self) -> Optional[pulumi.Input['ProfileprotocoloptionsHttpArgs']]:
        """
        Configure HTTP protocol options. The structure of `http` block is documented below.
        """
        return pulumi.get(self, "http")

    @http.setter
    def http(self, value: Optional[pulumi.Input['ProfileprotocoloptionsHttpArgs']]):
        pulumi.set(self, "http", value)

    @property
    @pulumi.getter
    def imap(self) -> Optional[pulumi.Input['ProfileprotocoloptionsImapArgs']]:
        """
        Configure IMAP protocol options. The structure of `imap` block is documented below.
        """
        return pulumi.get(self, "imap")

    @imap.setter
    def imap(self, value: Optional[pulumi.Input['ProfileprotocoloptionsImapArgs']]):
        pulumi.set(self, "imap", value)

    @property
    @pulumi.getter(name="mailSignature")
    def mail_signature(self) -> Optional[pulumi.Input['ProfileprotocoloptionsMailSignatureArgs']]:
        """
        Configure Mail signature. The structure of `mail_signature` block is documented below.
        """
        return pulumi.get(self, "mail_signature")

    @mail_signature.setter
    def mail_signature(self, value: Optional[pulumi.Input['ProfileprotocoloptionsMailSignatureArgs']]):
        pulumi.set(self, "mail_signature", value)

    @property
    @pulumi.getter
    def mapi(self) -> Optional[pulumi.Input['ProfileprotocoloptionsMapiArgs']]:
        """
        Configure MAPI protocol options. The structure of `mapi` block is documented below.
        """
        return pulumi.get(self, "mapi")

    @mapi.setter
    def mapi(self, value: Optional[pulumi.Input['ProfileprotocoloptionsMapiArgs']]):
        pulumi.set(self, "mapi", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def nntp(self) -> Optional[pulumi.Input['ProfileprotocoloptionsNntpArgs']]:
        """
        Configure NNTP protocol options. The structure of `nntp` block is documented below.
        """
        return pulumi.get(self, "nntp")

    @nntp.setter
    def nntp(self, value: Optional[pulumi.Input['ProfileprotocoloptionsNntpArgs']]):
        pulumi.set(self, "nntp", value)

    @property
    @pulumi.getter(name="oversizeLog")
    def oversize_log(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable logging for antivirus oversize file blocking. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "oversize_log")

    @oversize_log.setter
    def oversize_log(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "oversize_log", value)

    @property
    @pulumi.getter
    def pop3(self) -> Optional[pulumi.Input['ProfileprotocoloptionsPop3Args']]:
        """
        Configure POP3 protocol options. The structure of `pop3` block is documented below.
        """
        return pulumi.get(self, "pop3")

    @pop3.setter
    def pop3(self, value: Optional[pulumi.Input['ProfileprotocoloptionsPop3Args']]):
        pulumi.set(self, "pop3", value)

    @property
    @pulumi.getter(name="replacemsgGroup")
    def replacemsg_group(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the replacement message group to be used
        """
        return pulumi.get(self, "replacemsg_group")

    @replacemsg_group.setter
    def replacemsg_group(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "replacemsg_group", value)

    @property
    @pulumi.getter(name="rpcOverHttp")
    def rpc_over_http(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable inspection of RPC over HTTP. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "rpc_over_http")

    @rpc_over_http.setter
    def rpc_over_http(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rpc_over_http", value)

    @property
    @pulumi.getter
    def smtp(self) -> Optional[pulumi.Input['ProfileprotocoloptionsSmtpArgs']]:
        """
        Configure SMTP protocol options. The structure of `smtp` block is documented below.
        """
        return pulumi.get(self, "smtp")

    @smtp.setter
    def smtp(self, value: Optional[pulumi.Input['ProfileprotocoloptionsSmtpArgs']]):
        pulumi.set(self, "smtp", value)

    @property
    @pulumi.getter
    def ssh(self) -> Optional[pulumi.Input['ProfileprotocoloptionsSshArgs']]:
        """
        Configure SFTP and SCP protocol options. The structure of `ssh` block is documented below.
        """
        return pulumi.get(self, "ssh")

    @ssh.setter
    def ssh(self, value: Optional[pulumi.Input['ProfileprotocoloptionsSshArgs']]):
        pulumi.set(self, "ssh", value)

    @property
    @pulumi.getter(name="switchingProtocolsLog")
    def switching_protocols_log(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable logging for HTTP/HTTPS switching protocols. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "switching_protocols_log")

    @switching_protocols_log.setter
    def switching_protocols_log(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "switching_protocols_log", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)


@pulumi.input_type
class _ProfileprotocoloptionsState:
    def __init__(__self__, *,
                 cifs: Optional[pulumi.Input['ProfileprotocoloptionsCifsArgs']] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 dns: Optional[pulumi.Input['ProfileprotocoloptionsDnsArgs']] = None,
                 feature_set: Optional[pulumi.Input[str]] = None,
                 ftp: Optional[pulumi.Input['ProfileprotocoloptionsFtpArgs']] = None,
                 get_all_tables: Optional[pulumi.Input[str]] = None,
                 http: Optional[pulumi.Input['ProfileprotocoloptionsHttpArgs']] = None,
                 imap: Optional[pulumi.Input['ProfileprotocoloptionsImapArgs']] = None,
                 mail_signature: Optional[pulumi.Input['ProfileprotocoloptionsMailSignatureArgs']] = None,
                 mapi: Optional[pulumi.Input['ProfileprotocoloptionsMapiArgs']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 nntp: Optional[pulumi.Input['ProfileprotocoloptionsNntpArgs']] = None,
                 oversize_log: Optional[pulumi.Input[str]] = None,
                 pop3: Optional[pulumi.Input['ProfileprotocoloptionsPop3Args']] = None,
                 replacemsg_group: Optional[pulumi.Input[str]] = None,
                 rpc_over_http: Optional[pulumi.Input[str]] = None,
                 smtp: Optional[pulumi.Input['ProfileprotocoloptionsSmtpArgs']] = None,
                 ssh: Optional[pulumi.Input['ProfileprotocoloptionsSshArgs']] = None,
                 switching_protocols_log: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Profileprotocoloptions resources.
        :param pulumi.Input['ProfileprotocoloptionsCifsArgs'] cifs: Configure CIFS protocol options. The structure of `cifs` block is documented below.
        :param pulumi.Input[str] comment: Optional comments.
        :param pulumi.Input['ProfileprotocoloptionsDnsArgs'] dns: Configure DNS protocol options. The structure of `dns` block is documented below.
        :param pulumi.Input[str] feature_set: Flow/proxy feature set. Valid values: `flow`, `proxy`.
        :param pulumi.Input['ProfileprotocoloptionsFtpArgs'] ftp: Configure FTP protocol options. The structure of `ftp` block is documented below.
        :param pulumi.Input[str] get_all_tables: Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        :param pulumi.Input['ProfileprotocoloptionsHttpArgs'] http: Configure HTTP protocol options. The structure of `http` block is documented below.
        :param pulumi.Input['ProfileprotocoloptionsImapArgs'] imap: Configure IMAP protocol options. The structure of `imap` block is documented below.
        :param pulumi.Input['ProfileprotocoloptionsMailSignatureArgs'] mail_signature: Configure Mail signature. The structure of `mail_signature` block is documented below.
        :param pulumi.Input['ProfileprotocoloptionsMapiArgs'] mapi: Configure MAPI protocol options. The structure of `mapi` block is documented below.
        :param pulumi.Input[str] name: Name.
        :param pulumi.Input['ProfileprotocoloptionsNntpArgs'] nntp: Configure NNTP protocol options. The structure of `nntp` block is documented below.
        :param pulumi.Input[str] oversize_log: Enable/disable logging for antivirus oversize file blocking. Valid values: `disable`, `enable`.
        :param pulumi.Input['ProfileprotocoloptionsPop3Args'] pop3: Configure POP3 protocol options. The structure of `pop3` block is documented below.
        :param pulumi.Input[str] replacemsg_group: Name of the replacement message group to be used
        :param pulumi.Input[str] rpc_over_http: Enable/disable inspection of RPC over HTTP. Valid values: `enable`, `disable`.
        :param pulumi.Input['ProfileprotocoloptionsSmtpArgs'] smtp: Configure SMTP protocol options. The structure of `smtp` block is documented below.
        :param pulumi.Input['ProfileprotocoloptionsSshArgs'] ssh: Configure SFTP and SCP protocol options. The structure of `ssh` block is documented below.
        :param pulumi.Input[str] switching_protocols_log: Enable/disable logging for HTTP/HTTPS switching protocols. Valid values: `disable`, `enable`.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        if cifs is not None:
            pulumi.set(__self__, "cifs", cifs)
        if comment is not None:
            pulumi.set(__self__, "comment", comment)
        if dns is not None:
            pulumi.set(__self__, "dns", dns)
        if feature_set is not None:
            pulumi.set(__self__, "feature_set", feature_set)
        if ftp is not None:
            pulumi.set(__self__, "ftp", ftp)
        if get_all_tables is not None:
            pulumi.set(__self__, "get_all_tables", get_all_tables)
        if http is not None:
            pulumi.set(__self__, "http", http)
        if imap is not None:
            pulumi.set(__self__, "imap", imap)
        if mail_signature is not None:
            pulumi.set(__self__, "mail_signature", mail_signature)
        if mapi is not None:
            pulumi.set(__self__, "mapi", mapi)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if nntp is not None:
            pulumi.set(__self__, "nntp", nntp)
        if oversize_log is not None:
            pulumi.set(__self__, "oversize_log", oversize_log)
        if pop3 is not None:
            pulumi.set(__self__, "pop3", pop3)
        if replacemsg_group is not None:
            pulumi.set(__self__, "replacemsg_group", replacemsg_group)
        if rpc_over_http is not None:
            pulumi.set(__self__, "rpc_over_http", rpc_over_http)
        if smtp is not None:
            pulumi.set(__self__, "smtp", smtp)
        if ssh is not None:
            pulumi.set(__self__, "ssh", ssh)
        if switching_protocols_log is not None:
            pulumi.set(__self__, "switching_protocols_log", switching_protocols_log)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter
    def cifs(self) -> Optional[pulumi.Input['ProfileprotocoloptionsCifsArgs']]:
        """
        Configure CIFS protocol options. The structure of `cifs` block is documented below.
        """
        return pulumi.get(self, "cifs")

    @cifs.setter
    def cifs(self, value: Optional[pulumi.Input['ProfileprotocoloptionsCifsArgs']]):
        pulumi.set(self, "cifs", value)

    @property
    @pulumi.getter
    def comment(self) -> Optional[pulumi.Input[str]]:
        """
        Optional comments.
        """
        return pulumi.get(self, "comment")

    @comment.setter
    def comment(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "comment", value)

    @property
    @pulumi.getter
    def dns(self) -> Optional[pulumi.Input['ProfileprotocoloptionsDnsArgs']]:
        """
        Configure DNS protocol options. The structure of `dns` block is documented below.
        """
        return pulumi.get(self, "dns")

    @dns.setter
    def dns(self, value: Optional[pulumi.Input['ProfileprotocoloptionsDnsArgs']]):
        pulumi.set(self, "dns", value)

    @property
    @pulumi.getter(name="featureSet")
    def feature_set(self) -> Optional[pulumi.Input[str]]:
        """
        Flow/proxy feature set. Valid values: `flow`, `proxy`.
        """
        return pulumi.get(self, "feature_set")

    @feature_set.setter
    def feature_set(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "feature_set", value)

    @property
    @pulumi.getter
    def ftp(self) -> Optional[pulumi.Input['ProfileprotocoloptionsFtpArgs']]:
        """
        Configure FTP protocol options. The structure of `ftp` block is documented below.
        """
        return pulumi.get(self, "ftp")

    @ftp.setter
    def ftp(self, value: Optional[pulumi.Input['ProfileprotocoloptionsFtpArgs']]):
        pulumi.set(self, "ftp", value)

    @property
    @pulumi.getter(name="getAllTables")
    def get_all_tables(self) -> Optional[pulumi.Input[str]]:
        """
        Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        """
        return pulumi.get(self, "get_all_tables")

    @get_all_tables.setter
    def get_all_tables(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "get_all_tables", value)

    @property
    @pulumi.getter
    def http(self) -> Optional[pulumi.Input['ProfileprotocoloptionsHttpArgs']]:
        """
        Configure HTTP protocol options. The structure of `http` block is documented below.
        """
        return pulumi.get(self, "http")

    @http.setter
    def http(self, value: Optional[pulumi.Input['ProfileprotocoloptionsHttpArgs']]):
        pulumi.set(self, "http", value)

    @property
    @pulumi.getter
    def imap(self) -> Optional[pulumi.Input['ProfileprotocoloptionsImapArgs']]:
        """
        Configure IMAP protocol options. The structure of `imap` block is documented below.
        """
        return pulumi.get(self, "imap")

    @imap.setter
    def imap(self, value: Optional[pulumi.Input['ProfileprotocoloptionsImapArgs']]):
        pulumi.set(self, "imap", value)

    @property
    @pulumi.getter(name="mailSignature")
    def mail_signature(self) -> Optional[pulumi.Input['ProfileprotocoloptionsMailSignatureArgs']]:
        """
        Configure Mail signature. The structure of `mail_signature` block is documented below.
        """
        return pulumi.get(self, "mail_signature")

    @mail_signature.setter
    def mail_signature(self, value: Optional[pulumi.Input['ProfileprotocoloptionsMailSignatureArgs']]):
        pulumi.set(self, "mail_signature", value)

    @property
    @pulumi.getter
    def mapi(self) -> Optional[pulumi.Input['ProfileprotocoloptionsMapiArgs']]:
        """
        Configure MAPI protocol options. The structure of `mapi` block is documented below.
        """
        return pulumi.get(self, "mapi")

    @mapi.setter
    def mapi(self, value: Optional[pulumi.Input['ProfileprotocoloptionsMapiArgs']]):
        pulumi.set(self, "mapi", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def nntp(self) -> Optional[pulumi.Input['ProfileprotocoloptionsNntpArgs']]:
        """
        Configure NNTP protocol options. The structure of `nntp` block is documented below.
        """
        return pulumi.get(self, "nntp")

    @nntp.setter
    def nntp(self, value: Optional[pulumi.Input['ProfileprotocoloptionsNntpArgs']]):
        pulumi.set(self, "nntp", value)

    @property
    @pulumi.getter(name="oversizeLog")
    def oversize_log(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable logging for antivirus oversize file blocking. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "oversize_log")

    @oversize_log.setter
    def oversize_log(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "oversize_log", value)

    @property
    @pulumi.getter
    def pop3(self) -> Optional[pulumi.Input['ProfileprotocoloptionsPop3Args']]:
        """
        Configure POP3 protocol options. The structure of `pop3` block is documented below.
        """
        return pulumi.get(self, "pop3")

    @pop3.setter
    def pop3(self, value: Optional[pulumi.Input['ProfileprotocoloptionsPop3Args']]):
        pulumi.set(self, "pop3", value)

    @property
    @pulumi.getter(name="replacemsgGroup")
    def replacemsg_group(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the replacement message group to be used
        """
        return pulumi.get(self, "replacemsg_group")

    @replacemsg_group.setter
    def replacemsg_group(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "replacemsg_group", value)

    @property
    @pulumi.getter(name="rpcOverHttp")
    def rpc_over_http(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable inspection of RPC over HTTP. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "rpc_over_http")

    @rpc_over_http.setter
    def rpc_over_http(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "rpc_over_http", value)

    @property
    @pulumi.getter
    def smtp(self) -> Optional[pulumi.Input['ProfileprotocoloptionsSmtpArgs']]:
        """
        Configure SMTP protocol options. The structure of `smtp` block is documented below.
        """
        return pulumi.get(self, "smtp")

    @smtp.setter
    def smtp(self, value: Optional[pulumi.Input['ProfileprotocoloptionsSmtpArgs']]):
        pulumi.set(self, "smtp", value)

    @property
    @pulumi.getter
    def ssh(self) -> Optional[pulumi.Input['ProfileprotocoloptionsSshArgs']]:
        """
        Configure SFTP and SCP protocol options. The structure of `ssh` block is documented below.
        """
        return pulumi.get(self, "ssh")

    @ssh.setter
    def ssh(self, value: Optional[pulumi.Input['ProfileprotocoloptionsSshArgs']]):
        pulumi.set(self, "ssh", value)

    @property
    @pulumi.getter(name="switchingProtocolsLog")
    def switching_protocols_log(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable logging for HTTP/HTTPS switching protocols. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "switching_protocols_log")

    @switching_protocols_log.setter
    def switching_protocols_log(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "switching_protocols_log", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)


class Profileprotocoloptions(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cifs: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsCifsArgs']]] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 dns: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsDnsArgs']]] = None,
                 feature_set: Optional[pulumi.Input[str]] = None,
                 ftp: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsFtpArgs']]] = None,
                 get_all_tables: Optional[pulumi.Input[str]] = None,
                 http: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsHttpArgs']]] = None,
                 imap: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsImapArgs']]] = None,
                 mail_signature: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsMailSignatureArgs']]] = None,
                 mapi: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsMapiArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 nntp: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsNntpArgs']]] = None,
                 oversize_log: Optional[pulumi.Input[str]] = None,
                 pop3: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsPop3Args']]] = None,
                 replacemsg_group: Optional[pulumi.Input[str]] = None,
                 rpc_over_http: Optional[pulumi.Input[str]] = None,
                 smtp: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsSmtpArgs']]] = None,
                 ssh: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsSshArgs']]] = None,
                 switching_protocols_log: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Configure protocol options.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_fortios as fortios

        trname = fortios.firewall.Profileprotocoloptions("trname",
            dns=fortios.firewall.ProfileprotocoloptionsDnsArgs(
                ports=53,
                status="enable",
            ),
            ftp=fortios.firewall.ProfileprotocoloptionsFtpArgs(
                comfort_amount=1,
                comfort_interval=10,
                inspect_all="disable",
                options="splice",
                oversize_limit=10,
                ports=21,
                scan_bzip2="enable",
                status="enable",
                uncompressed_nest_limit=12,
                uncompressed_oversize_limit=10,
            ),
            http=fortios.firewall.ProfileprotocoloptionsHttpArgs(
                block_page_status_code=403,
                comfort_amount=1,
                comfort_interval=10,
                fortinet_bar="disable",
                fortinet_bar_port=8011,
                http_policy="disable",
                inspect_all="disable",
                oversize_limit=10,
                ports=80,
                range_block="disable",
                retry_count=0,
                scan_bzip2="enable",
                status="enable",
                streaming_content_bypass="enable",
                strip_x_forwarded_for="disable",
                switching_protocols="bypass",
                uncompressed_nest_limit=12,
                uncompressed_oversize_limit=10,
            ),
            imap=fortios.firewall.ProfileprotocoloptionsImapArgs(
                inspect_all="disable",
                options="fragmail",
                oversize_limit=10,
                ports=143,
                scan_bzip2="enable",
                status="enable",
                uncompressed_nest_limit=12,
                uncompressed_oversize_limit=10,
            ),
            mail_signature=fortios.firewall.ProfileprotocoloptionsMailSignatureArgs(
                status="disable",
            ),
            mapi=fortios.firewall.ProfileprotocoloptionsMapiArgs(
                options="fragmail",
                oversize_limit=10,
                ports=135,
                scan_bzip2="enable",
                status="enable",
                uncompressed_nest_limit=12,
                uncompressed_oversize_limit=10,
            ),
            nntp=fortios.firewall.ProfileprotocoloptionsNntpArgs(
                inspect_all="disable",
                options="splice",
                oversize_limit=10,
                ports=119,
                scan_bzip2="enable",
                status="enable",
                uncompressed_nest_limit=12,
                uncompressed_oversize_limit=10,
            ),
            oversize_log="disable",
            pop3=fortios.firewall.ProfileprotocoloptionsPop3Args(
                inspect_all="disable",
                options="fragmail",
                oversize_limit=10,
                ports=110,
                scan_bzip2="enable",
                status="enable",
                uncompressed_nest_limit=12,
                uncompressed_oversize_limit=10,
            ),
            rpc_over_http="disable",
            smtp=fortios.firewall.ProfileprotocoloptionsSmtpArgs(
                inspect_all="disable",
                options="fragmail splice",
                oversize_limit=10,
                ports=25,
                scan_bzip2="enable",
                server_busy="disable",
                status="enable",
                uncompressed_nest_limit=12,
                uncompressed_oversize_limit=10,
            ),
            switching_protocols_log="disable")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        Firewall ProfileProtocolOptions can be imported using any of these accepted formats:

        ```sh
        $ pulumi import fortios:firewall/profileprotocoloptions:Profileprotocoloptions labelname {{name}}
        ```

        If you do not want to import arguments of block:

        $ export "FORTIOS_IMPORT_TABLE"="false"

        ```sh
        $ pulumi import fortios:firewall/profileprotocoloptions:Profileprotocoloptions labelname {{name}}
        ```

        $ unset "FORTIOS_IMPORT_TABLE"

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsCifsArgs']] cifs: Configure CIFS protocol options. The structure of `cifs` block is documented below.
        :param pulumi.Input[str] comment: Optional comments.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsDnsArgs']] dns: Configure DNS protocol options. The structure of `dns` block is documented below.
        :param pulumi.Input[str] feature_set: Flow/proxy feature set. Valid values: `flow`, `proxy`.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsFtpArgs']] ftp: Configure FTP protocol options. The structure of `ftp` block is documented below.
        :param pulumi.Input[str] get_all_tables: Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsHttpArgs']] http: Configure HTTP protocol options. The structure of `http` block is documented below.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsImapArgs']] imap: Configure IMAP protocol options. The structure of `imap` block is documented below.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsMailSignatureArgs']] mail_signature: Configure Mail signature. The structure of `mail_signature` block is documented below.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsMapiArgs']] mapi: Configure MAPI protocol options. The structure of `mapi` block is documented below.
        :param pulumi.Input[str] name: Name.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsNntpArgs']] nntp: Configure NNTP protocol options. The structure of `nntp` block is documented below.
        :param pulumi.Input[str] oversize_log: Enable/disable logging for antivirus oversize file blocking. Valid values: `disable`, `enable`.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsPop3Args']] pop3: Configure POP3 protocol options. The structure of `pop3` block is documented below.
        :param pulumi.Input[str] replacemsg_group: Name of the replacement message group to be used
        :param pulumi.Input[str] rpc_over_http: Enable/disable inspection of RPC over HTTP. Valid values: `enable`, `disable`.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsSmtpArgs']] smtp: Configure SMTP protocol options. The structure of `smtp` block is documented below.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsSshArgs']] ssh: Configure SFTP and SCP protocol options. The structure of `ssh` block is documented below.
        :param pulumi.Input[str] switching_protocols_log: Enable/disable logging for HTTP/HTTPS switching protocols. Valid values: `disable`, `enable`.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[ProfileprotocoloptionsArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Configure protocol options.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_fortios as fortios

        trname = fortios.firewall.Profileprotocoloptions("trname",
            dns=fortios.firewall.ProfileprotocoloptionsDnsArgs(
                ports=53,
                status="enable",
            ),
            ftp=fortios.firewall.ProfileprotocoloptionsFtpArgs(
                comfort_amount=1,
                comfort_interval=10,
                inspect_all="disable",
                options="splice",
                oversize_limit=10,
                ports=21,
                scan_bzip2="enable",
                status="enable",
                uncompressed_nest_limit=12,
                uncompressed_oversize_limit=10,
            ),
            http=fortios.firewall.ProfileprotocoloptionsHttpArgs(
                block_page_status_code=403,
                comfort_amount=1,
                comfort_interval=10,
                fortinet_bar="disable",
                fortinet_bar_port=8011,
                http_policy="disable",
                inspect_all="disable",
                oversize_limit=10,
                ports=80,
                range_block="disable",
                retry_count=0,
                scan_bzip2="enable",
                status="enable",
                streaming_content_bypass="enable",
                strip_x_forwarded_for="disable",
                switching_protocols="bypass",
                uncompressed_nest_limit=12,
                uncompressed_oversize_limit=10,
            ),
            imap=fortios.firewall.ProfileprotocoloptionsImapArgs(
                inspect_all="disable",
                options="fragmail",
                oversize_limit=10,
                ports=143,
                scan_bzip2="enable",
                status="enable",
                uncompressed_nest_limit=12,
                uncompressed_oversize_limit=10,
            ),
            mail_signature=fortios.firewall.ProfileprotocoloptionsMailSignatureArgs(
                status="disable",
            ),
            mapi=fortios.firewall.ProfileprotocoloptionsMapiArgs(
                options="fragmail",
                oversize_limit=10,
                ports=135,
                scan_bzip2="enable",
                status="enable",
                uncompressed_nest_limit=12,
                uncompressed_oversize_limit=10,
            ),
            nntp=fortios.firewall.ProfileprotocoloptionsNntpArgs(
                inspect_all="disable",
                options="splice",
                oversize_limit=10,
                ports=119,
                scan_bzip2="enable",
                status="enable",
                uncompressed_nest_limit=12,
                uncompressed_oversize_limit=10,
            ),
            oversize_log="disable",
            pop3=fortios.firewall.ProfileprotocoloptionsPop3Args(
                inspect_all="disable",
                options="fragmail",
                oversize_limit=10,
                ports=110,
                scan_bzip2="enable",
                status="enable",
                uncompressed_nest_limit=12,
                uncompressed_oversize_limit=10,
            ),
            rpc_over_http="disable",
            smtp=fortios.firewall.ProfileprotocoloptionsSmtpArgs(
                inspect_all="disable",
                options="fragmail splice",
                oversize_limit=10,
                ports=25,
                scan_bzip2="enable",
                server_busy="disable",
                status="enable",
                uncompressed_nest_limit=12,
                uncompressed_oversize_limit=10,
            ),
            switching_protocols_log="disable")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        Firewall ProfileProtocolOptions can be imported using any of these accepted formats:

        ```sh
        $ pulumi import fortios:firewall/profileprotocoloptions:Profileprotocoloptions labelname {{name}}
        ```

        If you do not want to import arguments of block:

        $ export "FORTIOS_IMPORT_TABLE"="false"

        ```sh
        $ pulumi import fortios:firewall/profileprotocoloptions:Profileprotocoloptions labelname {{name}}
        ```

        $ unset "FORTIOS_IMPORT_TABLE"

        :param str resource_name: The name of the resource.
        :param ProfileprotocoloptionsArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ProfileprotocoloptionsArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 cifs: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsCifsArgs']]] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 dns: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsDnsArgs']]] = None,
                 feature_set: Optional[pulumi.Input[str]] = None,
                 ftp: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsFtpArgs']]] = None,
                 get_all_tables: Optional[pulumi.Input[str]] = None,
                 http: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsHttpArgs']]] = None,
                 imap: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsImapArgs']]] = None,
                 mail_signature: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsMailSignatureArgs']]] = None,
                 mapi: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsMapiArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 nntp: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsNntpArgs']]] = None,
                 oversize_log: Optional[pulumi.Input[str]] = None,
                 pop3: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsPop3Args']]] = None,
                 replacemsg_group: Optional[pulumi.Input[str]] = None,
                 rpc_over_http: Optional[pulumi.Input[str]] = None,
                 smtp: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsSmtpArgs']]] = None,
                 ssh: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsSshArgs']]] = None,
                 switching_protocols_log: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ProfileprotocoloptionsArgs.__new__(ProfileprotocoloptionsArgs)

            __props__.__dict__["cifs"] = cifs
            __props__.__dict__["comment"] = comment
            __props__.__dict__["dns"] = dns
            __props__.__dict__["feature_set"] = feature_set
            __props__.__dict__["ftp"] = ftp
            __props__.__dict__["get_all_tables"] = get_all_tables
            __props__.__dict__["http"] = http
            __props__.__dict__["imap"] = imap
            __props__.__dict__["mail_signature"] = mail_signature
            __props__.__dict__["mapi"] = mapi
            __props__.__dict__["name"] = name
            __props__.__dict__["nntp"] = nntp
            __props__.__dict__["oversize_log"] = oversize_log
            __props__.__dict__["pop3"] = pop3
            __props__.__dict__["replacemsg_group"] = replacemsg_group
            __props__.__dict__["rpc_over_http"] = rpc_over_http
            __props__.__dict__["smtp"] = smtp
            __props__.__dict__["ssh"] = ssh
            __props__.__dict__["switching_protocols_log"] = switching_protocols_log
            __props__.__dict__["vdomparam"] = vdomparam
        super(Profileprotocoloptions, __self__).__init__(
            'fortios:firewall/profileprotocoloptions:Profileprotocoloptions',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            cifs: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsCifsArgs']]] = None,
            comment: Optional[pulumi.Input[str]] = None,
            dns: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsDnsArgs']]] = None,
            feature_set: Optional[pulumi.Input[str]] = None,
            ftp: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsFtpArgs']]] = None,
            get_all_tables: Optional[pulumi.Input[str]] = None,
            http: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsHttpArgs']]] = None,
            imap: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsImapArgs']]] = None,
            mail_signature: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsMailSignatureArgs']]] = None,
            mapi: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsMapiArgs']]] = None,
            name: Optional[pulumi.Input[str]] = None,
            nntp: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsNntpArgs']]] = None,
            oversize_log: Optional[pulumi.Input[str]] = None,
            pop3: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsPop3Args']]] = None,
            replacemsg_group: Optional[pulumi.Input[str]] = None,
            rpc_over_http: Optional[pulumi.Input[str]] = None,
            smtp: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsSmtpArgs']]] = None,
            ssh: Optional[pulumi.Input[pulumi.InputType['ProfileprotocoloptionsSshArgs']]] = None,
            switching_protocols_log: Optional[pulumi.Input[str]] = None,
            vdomparam: Optional[pulumi.Input[str]] = None) -> 'Profileprotocoloptions':
        """
        Get an existing Profileprotocoloptions resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsCifsArgs']] cifs: Configure CIFS protocol options. The structure of `cifs` block is documented below.
        :param pulumi.Input[str] comment: Optional comments.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsDnsArgs']] dns: Configure DNS protocol options. The structure of `dns` block is documented below.
        :param pulumi.Input[str] feature_set: Flow/proxy feature set. Valid values: `flow`, `proxy`.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsFtpArgs']] ftp: Configure FTP protocol options. The structure of `ftp` block is documented below.
        :param pulumi.Input[str] get_all_tables: Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsHttpArgs']] http: Configure HTTP protocol options. The structure of `http` block is documented below.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsImapArgs']] imap: Configure IMAP protocol options. The structure of `imap` block is documented below.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsMailSignatureArgs']] mail_signature: Configure Mail signature. The structure of `mail_signature` block is documented below.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsMapiArgs']] mapi: Configure MAPI protocol options. The structure of `mapi` block is documented below.
        :param pulumi.Input[str] name: Name.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsNntpArgs']] nntp: Configure NNTP protocol options. The structure of `nntp` block is documented below.
        :param pulumi.Input[str] oversize_log: Enable/disable logging for antivirus oversize file blocking. Valid values: `disable`, `enable`.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsPop3Args']] pop3: Configure POP3 protocol options. The structure of `pop3` block is documented below.
        :param pulumi.Input[str] replacemsg_group: Name of the replacement message group to be used
        :param pulumi.Input[str] rpc_over_http: Enable/disable inspection of RPC over HTTP. Valid values: `enable`, `disable`.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsSmtpArgs']] smtp: Configure SMTP protocol options. The structure of `smtp` block is documented below.
        :param pulumi.Input[pulumi.InputType['ProfileprotocoloptionsSshArgs']] ssh: Configure SFTP and SCP protocol options. The structure of `ssh` block is documented below.
        :param pulumi.Input[str] switching_protocols_log: Enable/disable logging for HTTP/HTTPS switching protocols. Valid values: `disable`, `enable`.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ProfileprotocoloptionsState.__new__(_ProfileprotocoloptionsState)

        __props__.__dict__["cifs"] = cifs
        __props__.__dict__["comment"] = comment
        __props__.__dict__["dns"] = dns
        __props__.__dict__["feature_set"] = feature_set
        __props__.__dict__["ftp"] = ftp
        __props__.__dict__["get_all_tables"] = get_all_tables
        __props__.__dict__["http"] = http
        __props__.__dict__["imap"] = imap
        __props__.__dict__["mail_signature"] = mail_signature
        __props__.__dict__["mapi"] = mapi
        __props__.__dict__["name"] = name
        __props__.__dict__["nntp"] = nntp
        __props__.__dict__["oversize_log"] = oversize_log
        __props__.__dict__["pop3"] = pop3
        __props__.__dict__["replacemsg_group"] = replacemsg_group
        __props__.__dict__["rpc_over_http"] = rpc_over_http
        __props__.__dict__["smtp"] = smtp
        __props__.__dict__["ssh"] = ssh
        __props__.__dict__["switching_protocols_log"] = switching_protocols_log
        __props__.__dict__["vdomparam"] = vdomparam
        return Profileprotocoloptions(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def cifs(self) -> pulumi.Output['outputs.ProfileprotocoloptionsCifs']:
        """
        Configure CIFS protocol options. The structure of `cifs` block is documented below.
        """
        return pulumi.get(self, "cifs")

    @property
    @pulumi.getter
    def comment(self) -> pulumi.Output[Optional[str]]:
        """
        Optional comments.
        """
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def dns(self) -> pulumi.Output['outputs.ProfileprotocoloptionsDns']:
        """
        Configure DNS protocol options. The structure of `dns` block is documented below.
        """
        return pulumi.get(self, "dns")

    @property
    @pulumi.getter(name="featureSet")
    def feature_set(self) -> pulumi.Output[str]:
        """
        Flow/proxy feature set. Valid values: `flow`, `proxy`.
        """
        return pulumi.get(self, "feature_set")

    @property
    @pulumi.getter
    def ftp(self) -> pulumi.Output['outputs.ProfileprotocoloptionsFtp']:
        """
        Configure FTP protocol options. The structure of `ftp` block is documented below.
        """
        return pulumi.get(self, "ftp")

    @property
    @pulumi.getter(name="getAllTables")
    def get_all_tables(self) -> pulumi.Output[Optional[str]]:
        """
        Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        """
        return pulumi.get(self, "get_all_tables")

    @property
    @pulumi.getter
    def http(self) -> pulumi.Output['outputs.ProfileprotocoloptionsHttp']:
        """
        Configure HTTP protocol options. The structure of `http` block is documented below.
        """
        return pulumi.get(self, "http")

    @property
    @pulumi.getter
    def imap(self) -> pulumi.Output['outputs.ProfileprotocoloptionsImap']:
        """
        Configure IMAP protocol options. The structure of `imap` block is documented below.
        """
        return pulumi.get(self, "imap")

    @property
    @pulumi.getter(name="mailSignature")
    def mail_signature(self) -> pulumi.Output['outputs.ProfileprotocoloptionsMailSignature']:
        """
        Configure Mail signature. The structure of `mail_signature` block is documented below.
        """
        return pulumi.get(self, "mail_signature")

    @property
    @pulumi.getter
    def mapi(self) -> pulumi.Output['outputs.ProfileprotocoloptionsMapi']:
        """
        Configure MAPI protocol options. The structure of `mapi` block is documented below.
        """
        return pulumi.get(self, "mapi")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def nntp(self) -> pulumi.Output['outputs.ProfileprotocoloptionsNntp']:
        """
        Configure NNTP protocol options. The structure of `nntp` block is documented below.
        """
        return pulumi.get(self, "nntp")

    @property
    @pulumi.getter(name="oversizeLog")
    def oversize_log(self) -> pulumi.Output[str]:
        """
        Enable/disable logging for antivirus oversize file blocking. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "oversize_log")

    @property
    @pulumi.getter
    def pop3(self) -> pulumi.Output['outputs.ProfileprotocoloptionsPop3']:
        """
        Configure POP3 protocol options. The structure of `pop3` block is documented below.
        """
        return pulumi.get(self, "pop3")

    @property
    @pulumi.getter(name="replacemsgGroup")
    def replacemsg_group(self) -> pulumi.Output[str]:
        """
        Name of the replacement message group to be used
        """
        return pulumi.get(self, "replacemsg_group")

    @property
    @pulumi.getter(name="rpcOverHttp")
    def rpc_over_http(self) -> pulumi.Output[str]:
        """
        Enable/disable inspection of RPC over HTTP. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "rpc_over_http")

    @property
    @pulumi.getter
    def smtp(self) -> pulumi.Output['outputs.ProfileprotocoloptionsSmtp']:
        """
        Configure SMTP protocol options. The structure of `smtp` block is documented below.
        """
        return pulumi.get(self, "smtp")

    @property
    @pulumi.getter
    def ssh(self) -> pulumi.Output['outputs.ProfileprotocoloptionsSsh']:
        """
        Configure SFTP and SCP protocol options. The structure of `ssh` block is documented below.
        """
        return pulumi.get(self, "ssh")

    @property
    @pulumi.getter(name="switchingProtocolsLog")
    def switching_protocols_log(self) -> pulumi.Output[str]:
        """
        Enable/disable logging for HTTP/HTTPS switching protocols. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "switching_protocols_log")

    @property
    @pulumi.getter
    def vdomparam(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

