# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['DevicemanagerInstallPolicypackageArgs', 'DevicemanagerInstallPolicypackage']

@pulumi.input_type
class DevicemanagerInstallPolicypackageArgs:
    def __init__(__self__, *,
                 package_name: pulumi.Input[str],
                 adom: Optional[pulumi.Input[str]] = None,
                 timeout: Optional[pulumi.Input[int]] = None):
        """
        The set of arguments for constructing a DevicemanagerInstallPolicypackage resource.
        :param pulumi.Input[str] package_name: The installation package name.
        :param pulumi.Input[str] adom: Source ADOM name. default is 'root'
        :param pulumi.Input[int] timeout: Timeout for installing the package to the target, default: 3 minutes.
        """
        pulumi.set(__self__, "package_name", package_name)
        if adom is not None:
            pulumi.set(__self__, "adom", adom)
        if timeout is not None:
            pulumi.set(__self__, "timeout", timeout)

    @property
    @pulumi.getter(name="packageName")
    def package_name(self) -> pulumi.Input[str]:
        """
        The installation package name.
        """
        return pulumi.get(self, "package_name")

    @package_name.setter
    def package_name(self, value: pulumi.Input[str]):
        pulumi.set(self, "package_name", value)

    @property
    @pulumi.getter
    def adom(self) -> Optional[pulumi.Input[str]]:
        """
        Source ADOM name. default is 'root'
        """
        return pulumi.get(self, "adom")

    @adom.setter
    def adom(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "adom", value)

    @property
    @pulumi.getter
    def timeout(self) -> Optional[pulumi.Input[int]]:
        """
        Timeout for installing the package to the target, default: 3 minutes.
        """
        return pulumi.get(self, "timeout")

    @timeout.setter
    def timeout(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "timeout", value)


@pulumi.input_type
class _DevicemanagerInstallPolicypackageState:
    def __init__(__self__, *,
                 adom: Optional[pulumi.Input[str]] = None,
                 package_name: Optional[pulumi.Input[str]] = None,
                 timeout: Optional[pulumi.Input[int]] = None):
        """
        Input properties used for looking up and filtering DevicemanagerInstallPolicypackage resources.
        :param pulumi.Input[str] adom: Source ADOM name. default is 'root'
        :param pulumi.Input[str] package_name: The installation package name.
        :param pulumi.Input[int] timeout: Timeout for installing the package to the target, default: 3 minutes.
        """
        if adom is not None:
            pulumi.set(__self__, "adom", adom)
        if package_name is not None:
            pulumi.set(__self__, "package_name", package_name)
        if timeout is not None:
            pulumi.set(__self__, "timeout", timeout)

    @property
    @pulumi.getter
    def adom(self) -> Optional[pulumi.Input[str]]:
        """
        Source ADOM name. default is 'root'
        """
        return pulumi.get(self, "adom")

    @adom.setter
    def adom(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "adom", value)

    @property
    @pulumi.getter(name="packageName")
    def package_name(self) -> Optional[pulumi.Input[str]]:
        """
        The installation package name.
        """
        return pulumi.get(self, "package_name")

    @package_name.setter
    def package_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "package_name", value)

    @property
    @pulumi.getter
    def timeout(self) -> Optional[pulumi.Input[int]]:
        """
        Timeout for installing the package to the target, default: 3 minutes.
        """
        return pulumi.get(self, "timeout")

    @timeout.setter
    def timeout(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "timeout", value)


class DevicemanagerInstallPolicypackage(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 adom: Optional[pulumi.Input[str]] = None,
                 package_name: Optional[pulumi.Input[str]] = None,
                 timeout: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        """
        This resource supports installing devicemanager policy package from FortiManager to the related FortiGate

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_fortios as fortios

        test1 = fortios.fmg.DevicemanagerInstallPolicypackage("test1",
            package_name="test-pkg1",
            timeout=5)
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] adom: Source ADOM name. default is 'root'
        :param pulumi.Input[str] package_name: The installation package name.
        :param pulumi.Input[int] timeout: Timeout for installing the package to the target, default: 3 minutes.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DevicemanagerInstallPolicypackageArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        This resource supports installing devicemanager policy package from FortiManager to the related FortiGate

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_fortios as fortios

        test1 = fortios.fmg.DevicemanagerInstallPolicypackage("test1",
            package_name="test-pkg1",
            timeout=5)
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param DevicemanagerInstallPolicypackageArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DevicemanagerInstallPolicypackageArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 adom: Optional[pulumi.Input[str]] = None,
                 package_name: Optional[pulumi.Input[str]] = None,
                 timeout: Optional[pulumi.Input[int]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DevicemanagerInstallPolicypackageArgs.__new__(DevicemanagerInstallPolicypackageArgs)

            __props__.__dict__["adom"] = adom
            if package_name is None and not opts.urn:
                raise TypeError("Missing required property 'package_name'")
            __props__.__dict__["package_name"] = package_name
            __props__.__dict__["timeout"] = timeout
        super(DevicemanagerInstallPolicypackage, __self__).__init__(
            'fortios:fmg/devicemanagerInstallPolicypackage:DevicemanagerInstallPolicypackage',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            adom: Optional[pulumi.Input[str]] = None,
            package_name: Optional[pulumi.Input[str]] = None,
            timeout: Optional[pulumi.Input[int]] = None) -> 'DevicemanagerInstallPolicypackage':
        """
        Get an existing DevicemanagerInstallPolicypackage resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] adom: Source ADOM name. default is 'root'
        :param pulumi.Input[str] package_name: The installation package name.
        :param pulumi.Input[int] timeout: Timeout for installing the package to the target, default: 3 minutes.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DevicemanagerInstallPolicypackageState.__new__(_DevicemanagerInstallPolicypackageState)

        __props__.__dict__["adom"] = adom
        __props__.__dict__["package_name"] = package_name
        __props__.__dict__["timeout"] = timeout
        return DevicemanagerInstallPolicypackage(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def adom(self) -> pulumi.Output[Optional[str]]:
        """
        Source ADOM name. default is 'root'
        """
        return pulumi.get(self, "adom")

    @property
    @pulumi.getter(name="packageName")
    def package_name(self) -> pulumi.Output[str]:
        """
        The installation package name.
        """
        return pulumi.get(self, "package_name")

    @property
    @pulumi.getter
    def timeout(self) -> pulumi.Output[Optional[int]]:
        """
        Timeout for installing the package to the target, default: 3 minutes.
        """
        return pulumi.get(self, "timeout")

