# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'SettingCustomLogField',
    'ThreatweightApplication',
    'ThreatweightGeolocation',
    'ThreatweightIps',
    'ThreatweightLevel',
    'ThreatweightMalware',
    'ThreatweightWeb',
]

@pulumi.output_type
class SettingCustomLogField(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "fieldId":
            suggest = "field_id"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SettingCustomLogField. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SettingCustomLogField.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SettingCustomLogField.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 field_id: Optional[str] = None):
        """
        :param str field_id: Custom log field.
        """
        if field_id is not None:
            pulumi.set(__self__, "field_id", field_id)

    @property
    @pulumi.getter(name="fieldId")
    def field_id(self) -> Optional[str]:
        """
        Custom log field.
        """
        return pulumi.get(self, "field_id")


@pulumi.output_type
class ThreatweightApplication(dict):
    def __init__(__self__, *,
                 category: Optional[int] = None,
                 id: Optional[int] = None,
                 level: Optional[str] = None):
        """
        :param int category: Application category.
        :param int id: Entry ID.
        :param str level: Threat weight score for Application events. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        if category is not None:
            pulumi.set(__self__, "category", category)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if level is not None:
            pulumi.set(__self__, "level", level)

    @property
    @pulumi.getter
    def category(self) -> Optional[int]:
        """
        Application category.
        """
        return pulumi.get(self, "category")

    @property
    @pulumi.getter
    def id(self) -> Optional[int]:
        """
        Entry ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def level(self) -> Optional[str]:
        """
        Threat weight score for Application events. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "level")


@pulumi.output_type
class ThreatweightGeolocation(dict):
    def __init__(__self__, *,
                 country: Optional[str] = None,
                 id: Optional[int] = None,
                 level: Optional[str] = None):
        """
        :param str country: Country code.
        :param int id: Entry ID.
        :param str level: Threat weight score for Geolocation-based events. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        if country is not None:
            pulumi.set(__self__, "country", country)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if level is not None:
            pulumi.set(__self__, "level", level)

    @property
    @pulumi.getter
    def country(self) -> Optional[str]:
        """
        Country code.
        """
        return pulumi.get(self, "country")

    @property
    @pulumi.getter
    def id(self) -> Optional[int]:
        """
        Entry ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def level(self) -> Optional[str]:
        """
        Threat weight score for Geolocation-based events. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "level")


@pulumi.output_type
class ThreatweightIps(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "criticalSeverity":
            suggest = "critical_severity"
        elif key == "highSeverity":
            suggest = "high_severity"
        elif key == "infoSeverity":
            suggest = "info_severity"
        elif key == "lowSeverity":
            suggest = "low_severity"
        elif key == "mediumSeverity":
            suggest = "medium_severity"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ThreatweightIps. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ThreatweightIps.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ThreatweightIps.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 critical_severity: Optional[str] = None,
                 high_severity: Optional[str] = None,
                 info_severity: Optional[str] = None,
                 low_severity: Optional[str] = None,
                 medium_severity: Optional[str] = None):
        """
        :param str critical_severity: Threat weight score for IPS critical severity events. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str high_severity: Threat weight score for IPS high severity events. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str info_severity: Threat weight score for IPS info severity events. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str low_severity: Threat weight score for IPS low severity events. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str medium_severity: Threat weight score for IPS medium severity events. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        if critical_severity is not None:
            pulumi.set(__self__, "critical_severity", critical_severity)
        if high_severity is not None:
            pulumi.set(__self__, "high_severity", high_severity)
        if info_severity is not None:
            pulumi.set(__self__, "info_severity", info_severity)
        if low_severity is not None:
            pulumi.set(__self__, "low_severity", low_severity)
        if medium_severity is not None:
            pulumi.set(__self__, "medium_severity", medium_severity)

    @property
    @pulumi.getter(name="criticalSeverity")
    def critical_severity(self) -> Optional[str]:
        """
        Threat weight score for IPS critical severity events. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "critical_severity")

    @property
    @pulumi.getter(name="highSeverity")
    def high_severity(self) -> Optional[str]:
        """
        Threat weight score for IPS high severity events. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "high_severity")

    @property
    @pulumi.getter(name="infoSeverity")
    def info_severity(self) -> Optional[str]:
        """
        Threat weight score for IPS info severity events. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "info_severity")

    @property
    @pulumi.getter(name="lowSeverity")
    def low_severity(self) -> Optional[str]:
        """
        Threat weight score for IPS low severity events. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "low_severity")

    @property
    @pulumi.getter(name="mediumSeverity")
    def medium_severity(self) -> Optional[str]:
        """
        Threat weight score for IPS medium severity events. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "medium_severity")


@pulumi.output_type
class ThreatweightLevel(dict):
    def __init__(__self__, *,
                 critical: Optional[int] = None,
                 high: Optional[int] = None,
                 low: Optional[int] = None,
                 medium: Optional[int] = None):
        """
        :param int critical: Critical level score value (1 - 100).
        :param int high: High level score value (1 - 100).
        :param int low: Low level score value (1 - 100).
        :param int medium: Medium level score value (1 - 100).
        """
        if critical is not None:
            pulumi.set(__self__, "critical", critical)
        if high is not None:
            pulumi.set(__self__, "high", high)
        if low is not None:
            pulumi.set(__self__, "low", low)
        if medium is not None:
            pulumi.set(__self__, "medium", medium)

    @property
    @pulumi.getter
    def critical(self) -> Optional[int]:
        """
        Critical level score value (1 - 100).
        """
        return pulumi.get(self, "critical")

    @property
    @pulumi.getter
    def high(self) -> Optional[int]:
        """
        High level score value (1 - 100).
        """
        return pulumi.get(self, "high")

    @property
    @pulumi.getter
    def low(self) -> Optional[int]:
        """
        Low level score value (1 - 100).
        """
        return pulumi.get(self, "low")

    @property
    @pulumi.getter
    def medium(self) -> Optional[int]:
        """
        Medium level score value (1 - 100).
        """
        return pulumi.get(self, "medium")


@pulumi.output_type
class ThreatweightMalware(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "botnetConnection":
            suggest = "botnet_connection"
        elif key == "commandBlocked":
            suggest = "command_blocked"
        elif key == "contentDisarm":
            suggest = "content_disarm"
        elif key == "emsThreatFeed":
            suggest = "ems_threat_feed"
        elif key == "fileBlocked":
            suggest = "file_blocked"
        elif key == "fsaHighRisk":
            suggest = "fsa_high_risk"
        elif key == "fsaMalicious":
            suggest = "fsa_malicious"
        elif key == "fsaMediumRisk":
            suggest = "fsa_medium_risk"
        elif key == "inlineBlock":
            suggest = "inline_block"
        elif key == "malwareList":
            suggest = "malware_list"
        elif key == "switchProto":
            suggest = "switch_proto"
        elif key == "virusFileTypeExecutable":
            suggest = "virus_file_type_executable"
        elif key == "virusInfected":
            suggest = "virus_infected"
        elif key == "virusOutbreakPrevention":
            suggest = "virus_outbreak_prevention"
        elif key == "virusScanError":
            suggest = "virus_scan_error"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ThreatweightMalware. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ThreatweightMalware.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ThreatweightMalware.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 botnet_connection: Optional[str] = None,
                 command_blocked: Optional[str] = None,
                 content_disarm: Optional[str] = None,
                 ems_threat_feed: Optional[str] = None,
                 file_blocked: Optional[str] = None,
                 fortiai: Optional[str] = None,
                 fortindr: Optional[str] = None,
                 fortisandbox: Optional[str] = None,
                 fsa_high_risk: Optional[str] = None,
                 fsa_malicious: Optional[str] = None,
                 fsa_medium_risk: Optional[str] = None,
                 inline_block: Optional[str] = None,
                 malware_list: Optional[str] = None,
                 mimefragmented: Optional[str] = None,
                 oversized: Optional[str] = None,
                 switch_proto: Optional[str] = None,
                 virus_file_type_executable: Optional[str] = None,
                 virus_infected: Optional[str] = None,
                 virus_outbreak_prevention: Optional[str] = None,
                 virus_scan_error: Optional[str] = None):
        """
        :param str botnet_connection: Threat weight score for detected botnet connections. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str command_blocked: Threat weight score for blocked command detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str content_disarm: Threat weight score for virus (content disarm) detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str ems_threat_feed: Threat weight score for virus (EMS threat feed) detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str file_blocked: Threat weight score for blocked file detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str fortiai: Threat weight score for FortiAI-detected virus. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str fortindr: Threat weight score for FortiNDR-detected virus. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str fortisandbox: Threat weight score for FortiSandbox-detected virus. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str fsa_high_risk: Threat weight score for FortiSandbox high risk malware detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str fsa_malicious: Threat weight score for FortiSandbox malicious malware detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str fsa_medium_risk: Threat weight score for FortiSandbox medium risk malware detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str inline_block: Threat weight score for malware detected by inline block. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str malware_list: Threat weight score for virus (malware list) detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str mimefragmented: Threat weight score for mimefragmented detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str oversized: Threat weight score for oversized file detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str switch_proto: Threat weight score for switch proto detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str virus_file_type_executable: Threat weight score for virus (filetype executable) detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str virus_infected: Threat weight score for virus (infected) detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str virus_outbreak_prevention: Threat weight score for virus (outbreak prevention) event. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        :param str virus_scan_error: Threat weight score for virus (scan error) detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        if botnet_connection is not None:
            pulumi.set(__self__, "botnet_connection", botnet_connection)
        if command_blocked is not None:
            pulumi.set(__self__, "command_blocked", command_blocked)
        if content_disarm is not None:
            pulumi.set(__self__, "content_disarm", content_disarm)
        if ems_threat_feed is not None:
            pulumi.set(__self__, "ems_threat_feed", ems_threat_feed)
        if file_blocked is not None:
            pulumi.set(__self__, "file_blocked", file_blocked)
        if fortiai is not None:
            pulumi.set(__self__, "fortiai", fortiai)
        if fortindr is not None:
            pulumi.set(__self__, "fortindr", fortindr)
        if fortisandbox is not None:
            pulumi.set(__self__, "fortisandbox", fortisandbox)
        if fsa_high_risk is not None:
            pulumi.set(__self__, "fsa_high_risk", fsa_high_risk)
        if fsa_malicious is not None:
            pulumi.set(__self__, "fsa_malicious", fsa_malicious)
        if fsa_medium_risk is not None:
            pulumi.set(__self__, "fsa_medium_risk", fsa_medium_risk)
        if inline_block is not None:
            pulumi.set(__self__, "inline_block", inline_block)
        if malware_list is not None:
            pulumi.set(__self__, "malware_list", malware_list)
        if mimefragmented is not None:
            pulumi.set(__self__, "mimefragmented", mimefragmented)
        if oversized is not None:
            pulumi.set(__self__, "oversized", oversized)
        if switch_proto is not None:
            pulumi.set(__self__, "switch_proto", switch_proto)
        if virus_file_type_executable is not None:
            pulumi.set(__self__, "virus_file_type_executable", virus_file_type_executable)
        if virus_infected is not None:
            pulumi.set(__self__, "virus_infected", virus_infected)
        if virus_outbreak_prevention is not None:
            pulumi.set(__self__, "virus_outbreak_prevention", virus_outbreak_prevention)
        if virus_scan_error is not None:
            pulumi.set(__self__, "virus_scan_error", virus_scan_error)

    @property
    @pulumi.getter(name="botnetConnection")
    def botnet_connection(self) -> Optional[str]:
        """
        Threat weight score for detected botnet connections. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "botnet_connection")

    @property
    @pulumi.getter(name="commandBlocked")
    def command_blocked(self) -> Optional[str]:
        """
        Threat weight score for blocked command detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "command_blocked")

    @property
    @pulumi.getter(name="contentDisarm")
    def content_disarm(self) -> Optional[str]:
        """
        Threat weight score for virus (content disarm) detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "content_disarm")

    @property
    @pulumi.getter(name="emsThreatFeed")
    def ems_threat_feed(self) -> Optional[str]:
        """
        Threat weight score for virus (EMS threat feed) detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "ems_threat_feed")

    @property
    @pulumi.getter(name="fileBlocked")
    def file_blocked(self) -> Optional[str]:
        """
        Threat weight score for blocked file detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "file_blocked")

    @property
    @pulumi.getter
    def fortiai(self) -> Optional[str]:
        """
        Threat weight score for FortiAI-detected virus. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "fortiai")

    @property
    @pulumi.getter
    def fortindr(self) -> Optional[str]:
        """
        Threat weight score for FortiNDR-detected virus. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "fortindr")

    @property
    @pulumi.getter
    def fortisandbox(self) -> Optional[str]:
        """
        Threat weight score for FortiSandbox-detected virus. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "fortisandbox")

    @property
    @pulumi.getter(name="fsaHighRisk")
    def fsa_high_risk(self) -> Optional[str]:
        """
        Threat weight score for FortiSandbox high risk malware detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "fsa_high_risk")

    @property
    @pulumi.getter(name="fsaMalicious")
    def fsa_malicious(self) -> Optional[str]:
        """
        Threat weight score for FortiSandbox malicious malware detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "fsa_malicious")

    @property
    @pulumi.getter(name="fsaMediumRisk")
    def fsa_medium_risk(self) -> Optional[str]:
        """
        Threat weight score for FortiSandbox medium risk malware detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "fsa_medium_risk")

    @property
    @pulumi.getter(name="inlineBlock")
    def inline_block(self) -> Optional[str]:
        """
        Threat weight score for malware detected by inline block. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "inline_block")

    @property
    @pulumi.getter(name="malwareList")
    def malware_list(self) -> Optional[str]:
        """
        Threat weight score for virus (malware list) detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "malware_list")

    @property
    @pulumi.getter
    def mimefragmented(self) -> Optional[str]:
        """
        Threat weight score for mimefragmented detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "mimefragmented")

    @property
    @pulumi.getter
    def oversized(self) -> Optional[str]:
        """
        Threat weight score for oversized file detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "oversized")

    @property
    @pulumi.getter(name="switchProto")
    def switch_proto(self) -> Optional[str]:
        """
        Threat weight score for switch proto detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "switch_proto")

    @property
    @pulumi.getter(name="virusFileTypeExecutable")
    def virus_file_type_executable(self) -> Optional[str]:
        """
        Threat weight score for virus (filetype executable) detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "virus_file_type_executable")

    @property
    @pulumi.getter(name="virusInfected")
    def virus_infected(self) -> Optional[str]:
        """
        Threat weight score for virus (infected) detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "virus_infected")

    @property
    @pulumi.getter(name="virusOutbreakPrevention")
    def virus_outbreak_prevention(self) -> Optional[str]:
        """
        Threat weight score for virus (outbreak prevention) event. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "virus_outbreak_prevention")

    @property
    @pulumi.getter(name="virusScanError")
    def virus_scan_error(self) -> Optional[str]:
        """
        Threat weight score for virus (scan error) detected. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "virus_scan_error")


@pulumi.output_type
class ThreatweightWeb(dict):
    def __init__(__self__, *,
                 category: Optional[int] = None,
                 id: Optional[int] = None,
                 level: Optional[str] = None):
        """
        :param int category: Threat weight score for web category filtering matches.
        :param int id: Entry ID.
        :param str level: Threat weight score for web category filtering matches. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        if category is not None:
            pulumi.set(__self__, "category", category)
        if id is not None:
            pulumi.set(__self__, "id", id)
        if level is not None:
            pulumi.set(__self__, "level", level)

    @property
    @pulumi.getter
    def category(self) -> Optional[int]:
        """
        Threat weight score for web category filtering matches.
        """
        return pulumi.get(self, "category")

    @property
    @pulumi.getter
    def id(self) -> Optional[int]:
        """
        Entry ID.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def level(self) -> Optional[str]:
        """
        Threat weight score for web category filtering matches. Valid values: `disable`, `low`, `medium`, `high`, `critical`.
        """
        return pulumi.get(self, "level")


