# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['RouteStaticArgs', 'RouteStatic']

@pulumi.input_type
class RouteStaticArgs:
    def __init__(__self__, *,
                 device: pulumi.Input[str],
                 gateway: pulumi.Input[str],
                 blackhole: Optional[pulumi.Input[str]] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 distance: Optional[pulumi.Input[str]] = None,
                 dst: Optional[pulumi.Input[str]] = None,
                 internet_service: Optional[pulumi.Input[int]] = None,
                 priority: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 weight: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a RouteStatic resource.
        :param pulumi.Input[str] device: Gateway out interface or tunnel.
        :param pulumi.Input[str] gateway: Gateway IP for this route.
        :param pulumi.Input[str] blackhole: Enable/disable black hole.
        :param pulumi.Input[str] comment: Optional comments.
        :param pulumi.Input[str] distance: Administrative distance.
        :param pulumi.Input[str] dst: Destination IP and mask for this route.
        :param pulumi.Input[int] internet_service: Application ID in the Internet service database.
        :param pulumi.Input[str] priority: Administrative priority.
        :param pulumi.Input[str] status: Enable/disable this static route. default is "enable".
        :param pulumi.Input[str] weight: Administrative weight.
        """
        pulumi.set(__self__, "device", device)
        pulumi.set(__self__, "gateway", gateway)
        if blackhole is not None:
            pulumi.set(__self__, "blackhole", blackhole)
        if comment is not None:
            pulumi.set(__self__, "comment", comment)
        if distance is not None:
            pulumi.set(__self__, "distance", distance)
        if dst is not None:
            pulumi.set(__self__, "dst", dst)
        if internet_service is not None:
            pulumi.set(__self__, "internet_service", internet_service)
        if priority is not None:
            pulumi.set(__self__, "priority", priority)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if weight is not None:
            pulumi.set(__self__, "weight", weight)

    @property
    @pulumi.getter
    def device(self) -> pulumi.Input[str]:
        """
        Gateway out interface or tunnel.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: pulumi.Input[str]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter
    def gateway(self) -> pulumi.Input[str]:
        """
        Gateway IP for this route.
        """
        return pulumi.get(self, "gateway")

    @gateway.setter
    def gateway(self, value: pulumi.Input[str]):
        pulumi.set(self, "gateway", value)

    @property
    @pulumi.getter
    def blackhole(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable black hole.
        """
        return pulumi.get(self, "blackhole")

    @blackhole.setter
    def blackhole(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "blackhole", value)

    @property
    @pulumi.getter
    def comment(self) -> Optional[pulumi.Input[str]]:
        """
        Optional comments.
        """
        return pulumi.get(self, "comment")

    @comment.setter
    def comment(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "comment", value)

    @property
    @pulumi.getter
    def distance(self) -> Optional[pulumi.Input[str]]:
        """
        Administrative distance.
        """
        return pulumi.get(self, "distance")

    @distance.setter
    def distance(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "distance", value)

    @property
    @pulumi.getter
    def dst(self) -> Optional[pulumi.Input[str]]:
        """
        Destination IP and mask for this route.
        """
        return pulumi.get(self, "dst")

    @dst.setter
    def dst(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dst", value)

    @property
    @pulumi.getter(name="internetService")
    def internet_service(self) -> Optional[pulumi.Input[int]]:
        """
        Application ID in the Internet service database.
        """
        return pulumi.get(self, "internet_service")

    @internet_service.setter
    def internet_service(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "internet_service", value)

    @property
    @pulumi.getter
    def priority(self) -> Optional[pulumi.Input[str]]:
        """
        Administrative priority.
        """
        return pulumi.get(self, "priority")

    @priority.setter
    def priority(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "priority", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable this static route. default is "enable".
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter
    def weight(self) -> Optional[pulumi.Input[str]]:
        """
        Administrative weight.
        """
        return pulumi.get(self, "weight")

    @weight.setter
    def weight(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "weight", value)


@pulumi.input_type
class _RouteStaticState:
    def __init__(__self__, *,
                 blackhole: Optional[pulumi.Input[str]] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 distance: Optional[pulumi.Input[str]] = None,
                 dst: Optional[pulumi.Input[str]] = None,
                 gateway: Optional[pulumi.Input[str]] = None,
                 internet_service: Optional[pulumi.Input[int]] = None,
                 priority: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 weight: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering RouteStatic resources.
        :param pulumi.Input[str] blackhole: Enable/disable black hole.
        :param pulumi.Input[str] comment: Optional comments.
        :param pulumi.Input[str] device: Gateway out interface or tunnel.
        :param pulumi.Input[str] distance: Administrative distance.
        :param pulumi.Input[str] dst: Destination IP and mask for this route.
        :param pulumi.Input[str] gateway: Gateway IP for this route.
        :param pulumi.Input[int] internet_service: Application ID in the Internet service database.
        :param pulumi.Input[str] priority: Administrative priority.
        :param pulumi.Input[str] status: Enable/disable this static route. default is "enable".
        :param pulumi.Input[str] weight: Administrative weight.
        """
        if blackhole is not None:
            pulumi.set(__self__, "blackhole", blackhole)
        if comment is not None:
            pulumi.set(__self__, "comment", comment)
        if device is not None:
            pulumi.set(__self__, "device", device)
        if distance is not None:
            pulumi.set(__self__, "distance", distance)
        if dst is not None:
            pulumi.set(__self__, "dst", dst)
        if gateway is not None:
            pulumi.set(__self__, "gateway", gateway)
        if internet_service is not None:
            pulumi.set(__self__, "internet_service", internet_service)
        if priority is not None:
            pulumi.set(__self__, "priority", priority)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if weight is not None:
            pulumi.set(__self__, "weight", weight)

    @property
    @pulumi.getter
    def blackhole(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable black hole.
        """
        return pulumi.get(self, "blackhole")

    @blackhole.setter
    def blackhole(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "blackhole", value)

    @property
    @pulumi.getter
    def comment(self) -> Optional[pulumi.Input[str]]:
        """
        Optional comments.
        """
        return pulumi.get(self, "comment")

    @comment.setter
    def comment(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "comment", value)

    @property
    @pulumi.getter
    def device(self) -> Optional[pulumi.Input[str]]:
        """
        Gateway out interface or tunnel.
        """
        return pulumi.get(self, "device")

    @device.setter
    def device(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "device", value)

    @property
    @pulumi.getter
    def distance(self) -> Optional[pulumi.Input[str]]:
        """
        Administrative distance.
        """
        return pulumi.get(self, "distance")

    @distance.setter
    def distance(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "distance", value)

    @property
    @pulumi.getter
    def dst(self) -> Optional[pulumi.Input[str]]:
        """
        Destination IP and mask for this route.
        """
        return pulumi.get(self, "dst")

    @dst.setter
    def dst(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dst", value)

    @property
    @pulumi.getter
    def gateway(self) -> Optional[pulumi.Input[str]]:
        """
        Gateway IP for this route.
        """
        return pulumi.get(self, "gateway")

    @gateway.setter
    def gateway(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "gateway", value)

    @property
    @pulumi.getter(name="internetService")
    def internet_service(self) -> Optional[pulumi.Input[int]]:
        """
        Application ID in the Internet service database.
        """
        return pulumi.get(self, "internet_service")

    @internet_service.setter
    def internet_service(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "internet_service", value)

    @property
    @pulumi.getter
    def priority(self) -> Optional[pulumi.Input[str]]:
        """
        Administrative priority.
        """
        return pulumi.get(self, "priority")

    @priority.setter
    def priority(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "priority", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable this static route. default is "enable".
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter
    def weight(self) -> Optional[pulumi.Input[str]]:
        """
        Administrative weight.
        """
        return pulumi.get(self, "weight")

    @weight.setter
    def weight(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "weight", value)


class RouteStatic(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 blackhole: Optional[pulumi.Input[str]] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 distance: Optional[pulumi.Input[str]] = None,
                 dst: Optional[pulumi.Input[str]] = None,
                 gateway: Optional[pulumi.Input[str]] = None,
                 internet_service: Optional[pulumi.Input[int]] = None,
                 priority: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 weight: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Provides a resource to configure static route of FortiOS.

        !> **Warning:** The resource will be deprecated and replaced by new resource `router.Static`, we recommend that you use the new resource.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_fortios as fortios

        subnet = fortios.networking.RouteStatic("subnet",
            blackhole="disable",
            comment="Terraform test",
            device="port2",
            distance="22",
            dst="110.2.2.122/32",
            gateway="2.2.2.2",
            priority="3",
            status="enable",
            weight="3")
        internet_service = fortios.networking.RouteStatic("internetService",
            blackhole="disable",
            comment="Terraform Test",
            device="port2",
            distance="22",
            gateway="2.2.2.2",
            internet_service=5242881,
            priority="3",
            status="enable",
            weight="3")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] blackhole: Enable/disable black hole.
        :param pulumi.Input[str] comment: Optional comments.
        :param pulumi.Input[str] device: Gateway out interface or tunnel.
        :param pulumi.Input[str] distance: Administrative distance.
        :param pulumi.Input[str] dst: Destination IP and mask for this route.
        :param pulumi.Input[str] gateway: Gateway IP for this route.
        :param pulumi.Input[int] internet_service: Application ID in the Internet service database.
        :param pulumi.Input[str] priority: Administrative priority.
        :param pulumi.Input[str] status: Enable/disable this static route. default is "enable".
        :param pulumi.Input[str] weight: Administrative weight.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: RouteStaticArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a resource to configure static route of FortiOS.

        !> **Warning:** The resource will be deprecated and replaced by new resource `router.Static`, we recommend that you use the new resource.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_fortios as fortios

        subnet = fortios.networking.RouteStatic("subnet",
            blackhole="disable",
            comment="Terraform test",
            device="port2",
            distance="22",
            dst="110.2.2.122/32",
            gateway="2.2.2.2",
            priority="3",
            status="enable",
            weight="3")
        internet_service = fortios.networking.RouteStatic("internetService",
            blackhole="disable",
            comment="Terraform Test",
            device="port2",
            distance="22",
            gateway="2.2.2.2",
            internet_service=5242881,
            priority="3",
            status="enable",
            weight="3")
        ```
        <!--End PulumiCodeChooser -->

        :param str resource_name: The name of the resource.
        :param RouteStaticArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(RouteStaticArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 blackhole: Optional[pulumi.Input[str]] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 device: Optional[pulumi.Input[str]] = None,
                 distance: Optional[pulumi.Input[str]] = None,
                 dst: Optional[pulumi.Input[str]] = None,
                 gateway: Optional[pulumi.Input[str]] = None,
                 internet_service: Optional[pulumi.Input[int]] = None,
                 priority: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 weight: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = RouteStaticArgs.__new__(RouteStaticArgs)

            __props__.__dict__["blackhole"] = blackhole
            __props__.__dict__["comment"] = comment
            if device is None and not opts.urn:
                raise TypeError("Missing required property 'device'")
            __props__.__dict__["device"] = device
            __props__.__dict__["distance"] = distance
            __props__.__dict__["dst"] = dst
            if gateway is None and not opts.urn:
                raise TypeError("Missing required property 'gateway'")
            __props__.__dict__["gateway"] = gateway
            __props__.__dict__["internet_service"] = internet_service
            __props__.__dict__["priority"] = priority
            __props__.__dict__["status"] = status
            __props__.__dict__["weight"] = weight
        super(RouteStatic, __self__).__init__(
            'fortios:networking/routeStatic:RouteStatic',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            blackhole: Optional[pulumi.Input[str]] = None,
            comment: Optional[pulumi.Input[str]] = None,
            device: Optional[pulumi.Input[str]] = None,
            distance: Optional[pulumi.Input[str]] = None,
            dst: Optional[pulumi.Input[str]] = None,
            gateway: Optional[pulumi.Input[str]] = None,
            internet_service: Optional[pulumi.Input[int]] = None,
            priority: Optional[pulumi.Input[str]] = None,
            status: Optional[pulumi.Input[str]] = None,
            weight: Optional[pulumi.Input[str]] = None) -> 'RouteStatic':
        """
        Get an existing RouteStatic resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] blackhole: Enable/disable black hole.
        :param pulumi.Input[str] comment: Optional comments.
        :param pulumi.Input[str] device: Gateway out interface or tunnel.
        :param pulumi.Input[str] distance: Administrative distance.
        :param pulumi.Input[str] dst: Destination IP and mask for this route.
        :param pulumi.Input[str] gateway: Gateway IP for this route.
        :param pulumi.Input[int] internet_service: Application ID in the Internet service database.
        :param pulumi.Input[str] priority: Administrative priority.
        :param pulumi.Input[str] status: Enable/disable this static route. default is "enable".
        :param pulumi.Input[str] weight: Administrative weight.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _RouteStaticState.__new__(_RouteStaticState)

        __props__.__dict__["blackhole"] = blackhole
        __props__.__dict__["comment"] = comment
        __props__.__dict__["device"] = device
        __props__.__dict__["distance"] = distance
        __props__.__dict__["dst"] = dst
        __props__.__dict__["gateway"] = gateway
        __props__.__dict__["internet_service"] = internet_service
        __props__.__dict__["priority"] = priority
        __props__.__dict__["status"] = status
        __props__.__dict__["weight"] = weight
        return RouteStatic(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def blackhole(self) -> pulumi.Output[str]:
        """
        Enable/disable black hole.
        """
        return pulumi.get(self, "blackhole")

    @property
    @pulumi.getter
    def comment(self) -> pulumi.Output[Optional[str]]:
        """
        Optional comments.
        """
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def device(self) -> pulumi.Output[str]:
        """
        Gateway out interface or tunnel.
        """
        return pulumi.get(self, "device")

    @property
    @pulumi.getter
    def distance(self) -> pulumi.Output[str]:
        """
        Administrative distance.
        """
        return pulumi.get(self, "distance")

    @property
    @pulumi.getter
    def dst(self) -> pulumi.Output[str]:
        """
        Destination IP and mask for this route.
        """
        return pulumi.get(self, "dst")

    @property
    @pulumi.getter
    def gateway(self) -> pulumi.Output[str]:
        """
        Gateway IP for this route.
        """
        return pulumi.get(self, "gateway")

    @property
    @pulumi.getter(name="internetService")
    def internet_service(self) -> pulumi.Output[int]:
        """
        Application ID in the Internet service database.
        """
        return pulumi.get(self, "internet_service")

    @property
    @pulumi.getter
    def priority(self) -> pulumi.Output[str]:
        """
        Administrative priority.
        """
        return pulumi.get(self, "priority")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        Enable/disable this static route. default is "enable".
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def weight(self) -> pulumi.Output[str]:
        """
        Administrative weight.
        """
        return pulumi.get(self, "weight")

