# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs

__all__ = [
    'GetMulticast6Result',
    'AwaitableGetMulticast6Result',
    'get_multicast6',
    'get_multicast6_output',
]

@pulumi.output_type
class GetMulticast6Result:
    """
    A collection of values returned by getMulticast6.
    """
    def __init__(__self__, id=None, interfaces=None, multicast_pmtu=None, multicast_routing=None, pim_sm_globals=None, vdomparam=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if interfaces and not isinstance(interfaces, list):
            raise TypeError("Expected argument 'interfaces' to be a list")
        pulumi.set(__self__, "interfaces", interfaces)
        if multicast_pmtu and not isinstance(multicast_pmtu, str):
            raise TypeError("Expected argument 'multicast_pmtu' to be a str")
        pulumi.set(__self__, "multicast_pmtu", multicast_pmtu)
        if multicast_routing and not isinstance(multicast_routing, str):
            raise TypeError("Expected argument 'multicast_routing' to be a str")
        pulumi.set(__self__, "multicast_routing", multicast_routing)
        if pim_sm_globals and not isinstance(pim_sm_globals, list):
            raise TypeError("Expected argument 'pim_sm_globals' to be a list")
        pulumi.set(__self__, "pim_sm_globals", pim_sm_globals)
        if vdomparam and not isinstance(vdomparam, str):
            raise TypeError("Expected argument 'vdomparam' to be a str")
        pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def interfaces(self) -> Sequence['outputs.GetMulticast6InterfaceResult']:
        """
        Protocol Independent Multicast (PIM) interfaces. The structure of `interface` block is documented below.
        """
        return pulumi.get(self, "interfaces")

    @property
    @pulumi.getter(name="multicastPmtu")
    def multicast_pmtu(self) -> str:
        """
        Enable/disable PMTU for IPv6 multicast.
        """
        return pulumi.get(self, "multicast_pmtu")

    @property
    @pulumi.getter(name="multicastRouting")
    def multicast_routing(self) -> str:
        """
        Enable/disable IPv6 multicast routing.
        """
        return pulumi.get(self, "multicast_routing")

    @property
    @pulumi.getter(name="pimSmGlobals")
    def pim_sm_globals(self) -> Sequence['outputs.GetMulticast6PimSmGlobalResult']:
        """
        PIM sparse-mode global settings. The structure of `pim_sm_global` block is documented below.
        """
        return pulumi.get(self, "pim_sm_globals")

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[str]:
        return pulumi.get(self, "vdomparam")


class AwaitableGetMulticast6Result(GetMulticast6Result):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetMulticast6Result(
            id=self.id,
            interfaces=self.interfaces,
            multicast_pmtu=self.multicast_pmtu,
            multicast_routing=self.multicast_routing,
            pim_sm_globals=self.pim_sm_globals,
            vdomparam=self.vdomparam)


def get_multicast6(vdomparam: Optional[str] = None,
                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetMulticast6Result:
    """
    Use this data source to get information on fortios router multicast6


    :param str vdomparam: Specifies the vdom to which the data source will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
    """
    __args__ = dict()
    __args__['vdomparam'] = vdomparam
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('fortios:router/getMulticast6:getMulticast6', __args__, opts=opts, typ=GetMulticast6Result).value

    return AwaitableGetMulticast6Result(
        id=pulumi.get(__ret__, 'id'),
        interfaces=pulumi.get(__ret__, 'interfaces'),
        multicast_pmtu=pulumi.get(__ret__, 'multicast_pmtu'),
        multicast_routing=pulumi.get(__ret__, 'multicast_routing'),
        pim_sm_globals=pulumi.get(__ret__, 'pim_sm_globals'),
        vdomparam=pulumi.get(__ret__, 'vdomparam'))


@_utilities.lift_output_func(get_multicast6)
def get_multicast6_output(vdomparam: Optional[pulumi.Input[Optional[str]]] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetMulticast6Result]:
    """
    Use this data source to get information on fortios router multicast6


    :param str vdomparam: Specifies the vdom to which the data source will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
    """
    ...
