# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities

__all__ = [
    'IpdscpmapMap',
    'QueuepolicyCosQueue',
]

@pulumi.output_type
class IpdscpmapMap(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "cosQueue":
            suggest = "cos_queue"
        elif key == "ipPrecedence":
            suggest = "ip_precedence"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in IpdscpmapMap. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        IpdscpmapMap.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        IpdscpmapMap.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 cos_queue: Optional[int] = None,
                 diffserv: Optional[str] = None,
                 ip_precedence: Optional[str] = None,
                 name: Optional[str] = None,
                 value: Optional[str] = None):
        """
        :param int cos_queue: COS queue number.
        :param str diffserv: Differentiated service. Valid values: `CS0`, `CS1`, `AF11`, `AF12`, `AF13`, `CS2`, `AF21`, `AF22`, `AF23`, `CS3`, `AF31`, `AF32`, `AF33`, `CS4`, `AF41`, `AF42`, `AF43`, `CS5`, `EF`, `CS6`, `CS7`.
        :param str ip_precedence: IP Precedence. Valid values: `network-control`, `internetwork-control`, `critic-ecp`, `flashoverride`, `flash`, `immediate`, `priority`, `routine`.
        :param str name: Dscp mapping entry name.
        :param str value: Raw values of DSCP (0 - 63).
        """
        if cos_queue is not None:
            pulumi.set(__self__, "cos_queue", cos_queue)
        if diffserv is not None:
            pulumi.set(__self__, "diffserv", diffserv)
        if ip_precedence is not None:
            pulumi.set(__self__, "ip_precedence", ip_precedence)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if value is not None:
            pulumi.set(__self__, "value", value)

    @property
    @pulumi.getter(name="cosQueue")
    def cos_queue(self) -> Optional[int]:
        """
        COS queue number.
        """
        return pulumi.get(self, "cos_queue")

    @property
    @pulumi.getter
    def diffserv(self) -> Optional[str]:
        """
        Differentiated service. Valid values: `CS0`, `CS1`, `AF11`, `AF12`, `AF13`, `CS2`, `AF21`, `AF22`, `AF23`, `CS3`, `AF31`, `AF32`, `AF33`, `CS4`, `AF41`, `AF42`, `AF43`, `CS5`, `EF`, `CS6`, `CS7`.
        """
        return pulumi.get(self, "diffserv")

    @property
    @pulumi.getter(name="ipPrecedence")
    def ip_precedence(self) -> Optional[str]:
        """
        IP Precedence. Valid values: `network-control`, `internetwork-control`, `critic-ecp`, `flashoverride`, `flash`, `immediate`, `priority`, `routine`.
        """
        return pulumi.get(self, "ip_precedence")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Dscp mapping entry name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def value(self) -> Optional[str]:
        """
        Raw values of DSCP (0 - 63).
        """
        return pulumi.get(self, "value")


@pulumi.output_type
class QueuepolicyCosQueue(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "dropPolicy":
            suggest = "drop_policy"
        elif key == "maxRate":
            suggest = "max_rate"
        elif key == "maxRatePercent":
            suggest = "max_rate_percent"
        elif key == "minRate":
            suggest = "min_rate"
        elif key == "minRatePercent":
            suggest = "min_rate_percent"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in QueuepolicyCosQueue. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        QueuepolicyCosQueue.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        QueuepolicyCosQueue.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 description: Optional[str] = None,
                 drop_policy: Optional[str] = None,
                 ecn: Optional[str] = None,
                 max_rate: Optional[int] = None,
                 max_rate_percent: Optional[int] = None,
                 min_rate: Optional[int] = None,
                 min_rate_percent: Optional[int] = None,
                 name: Optional[str] = None,
                 weight: Optional[int] = None):
        """
        :param str description: Description of the COS queue.
        :param str drop_policy: COS queue drop policy. Valid values: `taildrop`, `weighted-random-early-detection`.
        :param str ecn: Enable/disable ECN packet marking to drop eligible packets. Valid values: `disable`, `enable`.
        :param int max_rate: Maximum rate (0 - 4294967295 kbps, 0 to disable).
        :param int max_rate_percent: Maximum rate (%!o(MISSING)f link speed).
        :param int min_rate: Minimum rate (0 - 4294967295 kbps, 0 to disable).
        :param int min_rate_percent: Minimum rate (%!o(MISSING)f link speed).
        :param str name: Cos queue ID.
        :param int weight: Weight of weighted round robin scheduling.
        """
        if description is not None:
            pulumi.set(__self__, "description", description)
        if drop_policy is not None:
            pulumi.set(__self__, "drop_policy", drop_policy)
        if ecn is not None:
            pulumi.set(__self__, "ecn", ecn)
        if max_rate is not None:
            pulumi.set(__self__, "max_rate", max_rate)
        if max_rate_percent is not None:
            pulumi.set(__self__, "max_rate_percent", max_rate_percent)
        if min_rate is not None:
            pulumi.set(__self__, "min_rate", min_rate)
        if min_rate_percent is not None:
            pulumi.set(__self__, "min_rate_percent", min_rate_percent)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if weight is not None:
            pulumi.set(__self__, "weight", weight)

    @property
    @pulumi.getter
    def description(self) -> Optional[str]:
        """
        Description of the COS queue.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="dropPolicy")
    def drop_policy(self) -> Optional[str]:
        """
        COS queue drop policy. Valid values: `taildrop`, `weighted-random-early-detection`.
        """
        return pulumi.get(self, "drop_policy")

    @property
    @pulumi.getter
    def ecn(self) -> Optional[str]:
        """
        Enable/disable ECN packet marking to drop eligible packets. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "ecn")

    @property
    @pulumi.getter(name="maxRate")
    def max_rate(self) -> Optional[int]:
        """
        Maximum rate (0 - 4294967295 kbps, 0 to disable).
        """
        return pulumi.get(self, "max_rate")

    @property
    @pulumi.getter(name="maxRatePercent")
    def max_rate_percent(self) -> Optional[int]:
        """
        Maximum rate (%!o(MISSING)f link speed).
        """
        return pulumi.get(self, "max_rate_percent")

    @property
    @pulumi.getter(name="minRate")
    def min_rate(self) -> Optional[int]:
        """
        Minimum rate (0 - 4294967295 kbps, 0 to disable).
        """
        return pulumi.get(self, "min_rate")

    @property
    @pulumi.getter(name="minRatePercent")
    def min_rate_percent(self) -> Optional[int]:
        """
        Minimum rate (%!o(MISSING)f link speed).
        """
        return pulumi.get(self, "min_rate_percent")

    @property
    @pulumi.getter
    def name(self) -> Optional[str]:
        """
        Cos queue ID.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def weight(self) -> Optional[int]:
        """
        Weight of weighted round robin scheduling.
        """
        return pulumi.get(self, "weight")


