# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = ['Dns64Args', 'Dns64']

@pulumi.input_type
class Dns64Args:
    def __init__(__self__, *,
                 always_synthesize_aaaa_record: Optional[pulumi.Input[str]] = None,
                 dns64_prefix: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Dns64 resource.
        :param pulumi.Input[str] always_synthesize_aaaa_record: Enable/disable AAAA record synthesis (default = enable). Valid values: `enable`, `disable`.
        :param pulumi.Input[str] dns64_prefix: DNS64 prefix must be ::/96 (default = 64:ff9b::/96).
        :param pulumi.Input[str] status: Enable/disable DNS64 (default = disable). Valid values: `enable`, `disable`.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        if always_synthesize_aaaa_record is not None:
            pulumi.set(__self__, "always_synthesize_aaaa_record", always_synthesize_aaaa_record)
        if dns64_prefix is not None:
            pulumi.set(__self__, "dns64_prefix", dns64_prefix)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter(name="alwaysSynthesizeAaaaRecord")
    def always_synthesize_aaaa_record(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable AAAA record synthesis (default = enable). Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "always_synthesize_aaaa_record")

    @always_synthesize_aaaa_record.setter
    def always_synthesize_aaaa_record(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "always_synthesize_aaaa_record", value)

    @property
    @pulumi.getter(name="dns64Prefix")
    def dns64_prefix(self) -> Optional[pulumi.Input[str]]:
        """
        DNS64 prefix must be ::/96 (default = 64:ff9b::/96).
        """
        return pulumi.get(self, "dns64_prefix")

    @dns64_prefix.setter
    def dns64_prefix(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dns64_prefix", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable DNS64 (default = disable). Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)


@pulumi.input_type
class _Dns64State:
    def __init__(__self__, *,
                 always_synthesize_aaaa_record: Optional[pulumi.Input[str]] = None,
                 dns64_prefix: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Dns64 resources.
        :param pulumi.Input[str] always_synthesize_aaaa_record: Enable/disable AAAA record synthesis (default = enable). Valid values: `enable`, `disable`.
        :param pulumi.Input[str] dns64_prefix: DNS64 prefix must be ::/96 (default = 64:ff9b::/96).
        :param pulumi.Input[str] status: Enable/disable DNS64 (default = disable). Valid values: `enable`, `disable`.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        if always_synthesize_aaaa_record is not None:
            pulumi.set(__self__, "always_synthesize_aaaa_record", always_synthesize_aaaa_record)
        if dns64_prefix is not None:
            pulumi.set(__self__, "dns64_prefix", dns64_prefix)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter(name="alwaysSynthesizeAaaaRecord")
    def always_synthesize_aaaa_record(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable AAAA record synthesis (default = enable). Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "always_synthesize_aaaa_record")

    @always_synthesize_aaaa_record.setter
    def always_synthesize_aaaa_record(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "always_synthesize_aaaa_record", value)

    @property
    @pulumi.getter(name="dns64Prefix")
    def dns64_prefix(self) -> Optional[pulumi.Input[str]]:
        """
        DNS64 prefix must be ::/96 (default = 64:ff9b::/96).
        """
        return pulumi.get(self, "dns64_prefix")

    @dns64_prefix.setter
    def dns64_prefix(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dns64_prefix", value)

    @property
    @pulumi.getter
    def status(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable DNS64 (default = disable). Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "status")

    @status.setter
    def status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "status", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)


class Dns64(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 always_synthesize_aaaa_record: Optional[pulumi.Input[str]] = None,
                 dns64_prefix: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Configure DNS64. Applies to FortiOS Version `>= 7.0.1`.

        ## Import

        System Dns64 can be imported using any of these accepted formats:

        ```sh
        $ pulumi import fortios:system/dns64:Dns64 labelname SystemDns64
        ```

        If you do not want to import arguments of block:

        $ export "FORTIOS_IMPORT_TABLE"="false"

        ```sh
        $ pulumi import fortios:system/dns64:Dns64 labelname SystemDns64
        ```

        $ unset "FORTIOS_IMPORT_TABLE"

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] always_synthesize_aaaa_record: Enable/disable AAAA record synthesis (default = enable). Valid values: `enable`, `disable`.
        :param pulumi.Input[str] dns64_prefix: DNS64 prefix must be ::/96 (default = 64:ff9b::/96).
        :param pulumi.Input[str] status: Enable/disable DNS64 (default = disable). Valid values: `enable`, `disable`.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[Dns64Args] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Configure DNS64. Applies to FortiOS Version `>= 7.0.1`.

        ## Import

        System Dns64 can be imported using any of these accepted formats:

        ```sh
        $ pulumi import fortios:system/dns64:Dns64 labelname SystemDns64
        ```

        If you do not want to import arguments of block:

        $ export "FORTIOS_IMPORT_TABLE"="false"

        ```sh
        $ pulumi import fortios:system/dns64:Dns64 labelname SystemDns64
        ```

        $ unset "FORTIOS_IMPORT_TABLE"

        :param str resource_name: The name of the resource.
        :param Dns64Args args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(Dns64Args, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 always_synthesize_aaaa_record: Optional[pulumi.Input[str]] = None,
                 dns64_prefix: Optional[pulumi.Input[str]] = None,
                 status: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = Dns64Args.__new__(Dns64Args)

            __props__.__dict__["always_synthesize_aaaa_record"] = always_synthesize_aaaa_record
            __props__.__dict__["dns64_prefix"] = dns64_prefix
            __props__.__dict__["status"] = status
            __props__.__dict__["vdomparam"] = vdomparam
        super(Dns64, __self__).__init__(
            'fortios:system/dns64:Dns64',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            always_synthesize_aaaa_record: Optional[pulumi.Input[str]] = None,
            dns64_prefix: Optional[pulumi.Input[str]] = None,
            status: Optional[pulumi.Input[str]] = None,
            vdomparam: Optional[pulumi.Input[str]] = None) -> 'Dns64':
        """
        Get an existing Dns64 resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] always_synthesize_aaaa_record: Enable/disable AAAA record synthesis (default = enable). Valid values: `enable`, `disable`.
        :param pulumi.Input[str] dns64_prefix: DNS64 prefix must be ::/96 (default = 64:ff9b::/96).
        :param pulumi.Input[str] status: Enable/disable DNS64 (default = disable). Valid values: `enable`, `disable`.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _Dns64State.__new__(_Dns64State)

        __props__.__dict__["always_synthesize_aaaa_record"] = always_synthesize_aaaa_record
        __props__.__dict__["dns64_prefix"] = dns64_prefix
        __props__.__dict__["status"] = status
        __props__.__dict__["vdomparam"] = vdomparam
        return Dns64(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="alwaysSynthesizeAaaaRecord")
    def always_synthesize_aaaa_record(self) -> pulumi.Output[str]:
        """
        Enable/disable AAAA record synthesis (default = enable). Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "always_synthesize_aaaa_record")

    @property
    @pulumi.getter(name="dns64Prefix")
    def dns64_prefix(self) -> pulumi.Output[str]:
        """
        DNS64 prefix must be ::/96 (default = 64:ff9b::/96).
        """
        return pulumi.get(self, "dns64_prefix")

    @property
    @pulumi.getter
    def status(self) -> pulumi.Output[str]:
        """
        Enable/disable DNS64 (default = disable). Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter
    def vdomparam(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

