# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'GetSmsserverResult',
    'AwaitableGetSmsserverResult',
    'get_smsserver',
    'get_smsserver_output',
]

@pulumi.output_type
class GetSmsserverResult:
    """
    A collection of values returned by getSmsserver.
    """
    def __init__(__self__, id=None, mail_server=None, name=None, vdomparam=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if mail_server and not isinstance(mail_server, str):
            raise TypeError("Expected argument 'mail_server' to be a str")
        pulumi.set(__self__, "mail_server", mail_server)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if vdomparam and not isinstance(vdomparam, str):
            raise TypeError("Expected argument 'vdomparam' to be a str")
        pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="mailServer")
    def mail_server(self) -> str:
        """
        Email-to-SMS server domain name.
        """
        return pulumi.get(self, "mail_server")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        Name of SMS server.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[str]:
        return pulumi.get(self, "vdomparam")


class AwaitableGetSmsserverResult(GetSmsserverResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetSmsserverResult(
            id=self.id,
            mail_server=self.mail_server,
            name=self.name,
            vdomparam=self.vdomparam)


def get_smsserver(name: Optional[str] = None,
                  vdomparam: Optional[str] = None,
                  opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetSmsserverResult:
    """
    Use this data source to get information on an fortios system smsserver


    :param str name: Specify the name of the desired system smsserver.
    :param str vdomparam: Specifies the vdom to which the data source will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
    """
    __args__ = dict()
    __args__['name'] = name
    __args__['vdomparam'] = vdomparam
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('fortios:system/getSmsserver:getSmsserver', __args__, opts=opts, typ=GetSmsserverResult).value

    return AwaitableGetSmsserverResult(
        id=pulumi.get(__ret__, 'id'),
        mail_server=pulumi.get(__ret__, 'mail_server'),
        name=pulumi.get(__ret__, 'name'),
        vdomparam=pulumi.get(__ret__, 'vdomparam'))


@_utilities.lift_output_func(get_smsserver)
def get_smsserver_output(name: Optional[pulumi.Input[str]] = None,
                         vdomparam: Optional[pulumi.Input[Optional[str]]] = None,
                         opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetSmsserverResult]:
    """
    Use this data source to get information on an fortios system smsserver


    :param str name: Specify the name of the desired system smsserver.
    :param str vdomparam: Specifies the vdom to which the data source will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
    """
    ...
