# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities

__all__ = [
    'ProfileMsrp',
    'ProfileSccp',
    'ProfileSip',
]

@pulumi.output_type
class ProfileMsrp(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "logViolations":
            suggest = "log_violations"
        elif key == "maxMsgSize":
            suggest = "max_msg_size"
        elif key == "maxMsgSizeAction":
            suggest = "max_msg_size_action"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ProfileMsrp. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ProfileMsrp.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ProfileMsrp.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 log_violations: Optional[str] = None,
                 max_msg_size: Optional[int] = None,
                 max_msg_size_action: Optional[str] = None,
                 status: Optional[str] = None):
        """
        :param str log_violations: Enable/disable logging of MSRP violations. Valid values: `disable`, `enable`.
        :param int max_msg_size: Maximum allowable MSRP message size (1-65535).
        :param str max_msg_size_action: Action for violation of max-msg-size. Valid values: `pass`, `block`, `reset`, `monitor`.
        :param str status: Enable/disable MSRP. Valid values: `disable`, `enable`.
        """
        if log_violations is not None:
            pulumi.set(__self__, "log_violations", log_violations)
        if max_msg_size is not None:
            pulumi.set(__self__, "max_msg_size", max_msg_size)
        if max_msg_size_action is not None:
            pulumi.set(__self__, "max_msg_size_action", max_msg_size_action)
        if status is not None:
            pulumi.set(__self__, "status", status)

    @property
    @pulumi.getter(name="logViolations")
    def log_violations(self) -> Optional[str]:
        """
        Enable/disable logging of MSRP violations. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "log_violations")

    @property
    @pulumi.getter(name="maxMsgSize")
    def max_msg_size(self) -> Optional[int]:
        """
        Maximum allowable MSRP message size (1-65535).
        """
        return pulumi.get(self, "max_msg_size")

    @property
    @pulumi.getter(name="maxMsgSizeAction")
    def max_msg_size_action(self) -> Optional[str]:
        """
        Action for violation of max-msg-size. Valid values: `pass`, `block`, `reset`, `monitor`.
        """
        return pulumi.get(self, "max_msg_size_action")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        Enable/disable MSRP. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "status")


@pulumi.output_type
class ProfileSccp(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "blockMcast":
            suggest = "block_mcast"
        elif key == "logCallSummary":
            suggest = "log_call_summary"
        elif key == "logViolations":
            suggest = "log_violations"
        elif key == "maxCalls":
            suggest = "max_calls"
        elif key == "verifyHeader":
            suggest = "verify_header"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ProfileSccp. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ProfileSccp.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ProfileSccp.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 block_mcast: Optional[str] = None,
                 log_call_summary: Optional[str] = None,
                 log_violations: Optional[str] = None,
                 max_calls: Optional[int] = None,
                 status: Optional[str] = None,
                 verify_header: Optional[str] = None):
        """
        :param str block_mcast: Enable/disable block multicast RTP connections. Valid values: `disable`, `enable`.
        :param str log_call_summary: Enable/disable log summary of SCCP calls. Valid values: `disable`, `enable`.
        :param str log_violations: Enable/disable logging of SCCP violations. Valid values: `disable`, `enable`.
        :param int max_calls: Maximum calls per minute per SCCP client (max 65535).
        :param str status: Enable/disable SCCP. Valid values: `disable`, `enable`.
        :param str verify_header: Enable/disable verify SCCP header content. Valid values: `disable`, `enable`.
        """
        if block_mcast is not None:
            pulumi.set(__self__, "block_mcast", block_mcast)
        if log_call_summary is not None:
            pulumi.set(__self__, "log_call_summary", log_call_summary)
        if log_violations is not None:
            pulumi.set(__self__, "log_violations", log_violations)
        if max_calls is not None:
            pulumi.set(__self__, "max_calls", max_calls)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if verify_header is not None:
            pulumi.set(__self__, "verify_header", verify_header)

    @property
    @pulumi.getter(name="blockMcast")
    def block_mcast(self) -> Optional[str]:
        """
        Enable/disable block multicast RTP connections. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "block_mcast")

    @property
    @pulumi.getter(name="logCallSummary")
    def log_call_summary(self) -> Optional[str]:
        """
        Enable/disable log summary of SCCP calls. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "log_call_summary")

    @property
    @pulumi.getter(name="logViolations")
    def log_violations(self) -> Optional[str]:
        """
        Enable/disable logging of SCCP violations. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "log_violations")

    @property
    @pulumi.getter(name="maxCalls")
    def max_calls(self) -> Optional[int]:
        """
        Maximum calls per minute per SCCP client (max 65535).
        """
        return pulumi.get(self, "max_calls")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        Enable/disable SCCP. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="verifyHeader")
    def verify_header(self) -> Optional[str]:
        """
        Enable/disable verify SCCP header content. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "verify_header")


@pulumi.output_type
class ProfileSip(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "ackRate":
            suggest = "ack_rate"
        elif key == "ackRateTrack":
            suggest = "ack_rate_track"
        elif key == "blockAck":
            suggest = "block_ack"
        elif key == "blockBye":
            suggest = "block_bye"
        elif key == "blockCancel":
            suggest = "block_cancel"
        elif key == "blockGeoRedOptions":
            suggest = "block_geo_red_options"
        elif key == "blockInfo":
            suggest = "block_info"
        elif key == "blockInvite":
            suggest = "block_invite"
        elif key == "blockLongLines":
            suggest = "block_long_lines"
        elif key == "blockMessage":
            suggest = "block_message"
        elif key == "blockNotify":
            suggest = "block_notify"
        elif key == "blockOptions":
            suggest = "block_options"
        elif key == "blockPrack":
            suggest = "block_prack"
        elif key == "blockPublish":
            suggest = "block_publish"
        elif key == "blockRefer":
            suggest = "block_refer"
        elif key == "blockRegister":
            suggest = "block_register"
        elif key == "blockSubscribe":
            suggest = "block_subscribe"
        elif key == "blockUnknown":
            suggest = "block_unknown"
        elif key == "blockUpdate":
            suggest = "block_update"
        elif key == "byeRate":
            suggest = "bye_rate"
        elif key == "byeRateTrack":
            suggest = "bye_rate_track"
        elif key == "callIdRegex":
            suggest = "call_id_regex"
        elif key == "callKeepalive":
            suggest = "call_keepalive"
        elif key == "cancelRate":
            suggest = "cancel_rate"
        elif key == "cancelRateTrack":
            suggest = "cancel_rate_track"
        elif key == "contactFixup":
            suggest = "contact_fixup"
        elif key == "contentTypeRegex":
            suggest = "content_type_regex"
        elif key == "hntRestrictSourceIp":
            suggest = "hnt_restrict_source_ip"
        elif key == "hostedNatTraversal":
            suggest = "hosted_nat_traversal"
        elif key == "infoRate":
            suggest = "info_rate"
        elif key == "infoRateTrack":
            suggest = "info_rate_track"
        elif key == "inviteRate":
            suggest = "invite_rate"
        elif key == "inviteRateTrack":
            suggest = "invite_rate_track"
        elif key == "ipsRtp":
            suggest = "ips_rtp"
        elif key == "logCallSummary":
            suggest = "log_call_summary"
        elif key == "logViolations":
            suggest = "log_violations"
        elif key == "malformedHeaderAllow":
            suggest = "malformed_header_allow"
        elif key == "malformedHeaderCallId":
            suggest = "malformed_header_call_id"
        elif key == "malformedHeaderContact":
            suggest = "malformed_header_contact"
        elif key == "malformedHeaderContentLength":
            suggest = "malformed_header_content_length"
        elif key == "malformedHeaderContentType":
            suggest = "malformed_header_content_type"
        elif key == "malformedHeaderCseq":
            suggest = "malformed_header_cseq"
        elif key == "malformedHeaderExpires":
            suggest = "malformed_header_expires"
        elif key == "malformedHeaderFrom":
            suggest = "malformed_header_from"
        elif key == "malformedHeaderMaxForwards":
            suggest = "malformed_header_max_forwards"
        elif key == "malformedHeaderNoProxyRequire":
            suggest = "malformed_header_no_proxy_require"
        elif key == "malformedHeaderNoRequire":
            suggest = "malformed_header_no_require"
        elif key == "malformedHeaderPAssertedIdentity":
            suggest = "malformed_header_passerted_identity"
        elif key == "malformedHeaderRack":
            suggest = "malformed_header_rack"
        elif key == "malformedHeaderRecordRoute":
            suggest = "malformed_header_record_route"
        elif key == "malformedHeaderRoute":
            suggest = "malformed_header_route"
        elif key == "malformedHeaderRseq":
            suggest = "malformed_header_rseq"
        elif key == "malformedHeaderSdpA":
            suggest = "malformed_header_sdp_a"
        elif key == "malformedHeaderSdpB":
            suggest = "malformed_header_sdp_b"
        elif key == "malformedHeaderSdpC":
            suggest = "malformed_header_sdp_c"
        elif key == "malformedHeaderSdpI":
            suggest = "malformed_header_sdp_i"
        elif key == "malformedHeaderSdpK":
            suggest = "malformed_header_sdp_k"
        elif key == "malformedHeaderSdpM":
            suggest = "malformed_header_sdp_m"
        elif key == "malformedHeaderSdpO":
            suggest = "malformed_header_sdp_o"
        elif key == "malformedHeaderSdpR":
            suggest = "malformed_header_sdp_r"
        elif key == "malformedHeaderSdpS":
            suggest = "malformed_header_sdp_s"
        elif key == "malformedHeaderSdpT":
            suggest = "malformed_header_sdp_t"
        elif key == "malformedHeaderSdpV":
            suggest = "malformed_header_sdp_v"
        elif key == "malformedHeaderSdpZ":
            suggest = "malformed_header_sdp_z"
        elif key == "malformedHeaderTo":
            suggest = "malformed_header_to"
        elif key == "malformedHeaderVia":
            suggest = "malformed_header_via"
        elif key == "malformedRequestLine":
            suggest = "malformed_request_line"
        elif key == "maxBodyLength":
            suggest = "max_body_length"
        elif key == "maxDialogs":
            suggest = "max_dialogs"
        elif key == "maxIdleDialogs":
            suggest = "max_idle_dialogs"
        elif key == "maxLineLength":
            suggest = "max_line_length"
        elif key == "messageRate":
            suggest = "message_rate"
        elif key == "messageRateTrack":
            suggest = "message_rate_track"
        elif key == "natPortRange":
            suggest = "nat_port_range"
        elif key == "natTrace":
            suggest = "nat_trace"
        elif key == "noSdpFixup":
            suggest = "no_sdp_fixup"
        elif key == "notifyRate":
            suggest = "notify_rate"
        elif key == "notifyRateTrack":
            suggest = "notify_rate_track"
        elif key == "openContactPinhole":
            suggest = "open_contact_pinhole"
        elif key == "openRecordRoutePinhole":
            suggest = "open_record_route_pinhole"
        elif key == "openRegisterPinhole":
            suggest = "open_register_pinhole"
        elif key == "openViaPinhole":
            suggest = "open_via_pinhole"
        elif key == "optionsRate":
            suggest = "options_rate"
        elif key == "optionsRateTrack":
            suggest = "options_rate_track"
        elif key == "prackRate":
            suggest = "prack_rate"
        elif key == "prackRateTrack":
            suggest = "prack_rate_track"
        elif key == "preserveOverride":
            suggest = "preserve_override"
        elif key == "provisionalInviteExpiryTime":
            suggest = "provisional_invite_expiry_time"
        elif key == "publishRate":
            suggest = "publish_rate"
        elif key == "publishRateTrack":
            suggest = "publish_rate_track"
        elif key == "referRate":
            suggest = "refer_rate"
        elif key == "referRateTrack":
            suggest = "refer_rate_track"
        elif key == "registerContactTrace":
            suggest = "register_contact_trace"
        elif key == "registerRate":
            suggest = "register_rate"
        elif key == "registerRateTrack":
            suggest = "register_rate_track"
        elif key == "rfc2543Branch":
            suggest = "rfc2543_branch"
        elif key == "sslAlgorithm":
            suggest = "ssl_algorithm"
        elif key == "sslAuthClient":
            suggest = "ssl_auth_client"
        elif key == "sslAuthServer":
            suggest = "ssl_auth_server"
        elif key == "sslClientCertificate":
            suggest = "ssl_client_certificate"
        elif key == "sslClientRenegotiation":
            suggest = "ssl_client_renegotiation"
        elif key == "sslMaxVersion":
            suggest = "ssl_max_version"
        elif key == "sslMinVersion":
            suggest = "ssl_min_version"
        elif key == "sslMode":
            suggest = "ssl_mode"
        elif key == "sslPfs":
            suggest = "ssl_pfs"
        elif key == "sslSendEmptyFrags":
            suggest = "ssl_send_empty_frags"
        elif key == "sslServerCertificate":
            suggest = "ssl_server_certificate"
        elif key == "strictRegister":
            suggest = "strict_register"
        elif key == "subscribeRate":
            suggest = "subscribe_rate"
        elif key == "subscribeRateTrack":
            suggest = "subscribe_rate_track"
        elif key == "unknownHeader":
            suggest = "unknown_header"
        elif key == "updateRate":
            suggest = "update_rate"
        elif key == "updateRateTrack":
            suggest = "update_rate_track"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in ProfileSip. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        ProfileSip.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        ProfileSip.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 ack_rate: Optional[int] = None,
                 ack_rate_track: Optional[str] = None,
                 block_ack: Optional[str] = None,
                 block_bye: Optional[str] = None,
                 block_cancel: Optional[str] = None,
                 block_geo_red_options: Optional[str] = None,
                 block_info: Optional[str] = None,
                 block_invite: Optional[str] = None,
                 block_long_lines: Optional[str] = None,
                 block_message: Optional[str] = None,
                 block_notify: Optional[str] = None,
                 block_options: Optional[str] = None,
                 block_prack: Optional[str] = None,
                 block_publish: Optional[str] = None,
                 block_refer: Optional[str] = None,
                 block_register: Optional[str] = None,
                 block_subscribe: Optional[str] = None,
                 block_unknown: Optional[str] = None,
                 block_update: Optional[str] = None,
                 bye_rate: Optional[int] = None,
                 bye_rate_track: Optional[str] = None,
                 call_id_regex: Optional[str] = None,
                 call_keepalive: Optional[int] = None,
                 cancel_rate: Optional[int] = None,
                 cancel_rate_track: Optional[str] = None,
                 contact_fixup: Optional[str] = None,
                 content_type_regex: Optional[str] = None,
                 hnt_restrict_source_ip: Optional[str] = None,
                 hosted_nat_traversal: Optional[str] = None,
                 info_rate: Optional[int] = None,
                 info_rate_track: Optional[str] = None,
                 invite_rate: Optional[int] = None,
                 invite_rate_track: Optional[str] = None,
                 ips_rtp: Optional[str] = None,
                 log_call_summary: Optional[str] = None,
                 log_violations: Optional[str] = None,
                 malformed_header_allow: Optional[str] = None,
                 malformed_header_call_id: Optional[str] = None,
                 malformed_header_contact: Optional[str] = None,
                 malformed_header_content_length: Optional[str] = None,
                 malformed_header_content_type: Optional[str] = None,
                 malformed_header_cseq: Optional[str] = None,
                 malformed_header_expires: Optional[str] = None,
                 malformed_header_from: Optional[str] = None,
                 malformed_header_max_forwards: Optional[str] = None,
                 malformed_header_no_proxy_require: Optional[str] = None,
                 malformed_header_no_require: Optional[str] = None,
                 malformed_header_passerted_identity: Optional[str] = None,
                 malformed_header_rack: Optional[str] = None,
                 malformed_header_record_route: Optional[str] = None,
                 malformed_header_route: Optional[str] = None,
                 malformed_header_rseq: Optional[str] = None,
                 malformed_header_sdp_a: Optional[str] = None,
                 malformed_header_sdp_b: Optional[str] = None,
                 malformed_header_sdp_c: Optional[str] = None,
                 malformed_header_sdp_i: Optional[str] = None,
                 malformed_header_sdp_k: Optional[str] = None,
                 malformed_header_sdp_m: Optional[str] = None,
                 malformed_header_sdp_o: Optional[str] = None,
                 malformed_header_sdp_r: Optional[str] = None,
                 malformed_header_sdp_s: Optional[str] = None,
                 malformed_header_sdp_t: Optional[str] = None,
                 malformed_header_sdp_v: Optional[str] = None,
                 malformed_header_sdp_z: Optional[str] = None,
                 malformed_header_to: Optional[str] = None,
                 malformed_header_via: Optional[str] = None,
                 malformed_request_line: Optional[str] = None,
                 max_body_length: Optional[int] = None,
                 max_dialogs: Optional[int] = None,
                 max_idle_dialogs: Optional[int] = None,
                 max_line_length: Optional[int] = None,
                 message_rate: Optional[int] = None,
                 message_rate_track: Optional[str] = None,
                 nat_port_range: Optional[str] = None,
                 nat_trace: Optional[str] = None,
                 no_sdp_fixup: Optional[str] = None,
                 notify_rate: Optional[int] = None,
                 notify_rate_track: Optional[str] = None,
                 open_contact_pinhole: Optional[str] = None,
                 open_record_route_pinhole: Optional[str] = None,
                 open_register_pinhole: Optional[str] = None,
                 open_via_pinhole: Optional[str] = None,
                 options_rate: Optional[int] = None,
                 options_rate_track: Optional[str] = None,
                 prack_rate: Optional[int] = None,
                 prack_rate_track: Optional[str] = None,
                 preserve_override: Optional[str] = None,
                 provisional_invite_expiry_time: Optional[int] = None,
                 publish_rate: Optional[int] = None,
                 publish_rate_track: Optional[str] = None,
                 refer_rate: Optional[int] = None,
                 refer_rate_track: Optional[str] = None,
                 register_contact_trace: Optional[str] = None,
                 register_rate: Optional[int] = None,
                 register_rate_track: Optional[str] = None,
                 rfc2543_branch: Optional[str] = None,
                 rtp: Optional[str] = None,
                 ssl_algorithm: Optional[str] = None,
                 ssl_auth_client: Optional[str] = None,
                 ssl_auth_server: Optional[str] = None,
                 ssl_client_certificate: Optional[str] = None,
                 ssl_client_renegotiation: Optional[str] = None,
                 ssl_max_version: Optional[str] = None,
                 ssl_min_version: Optional[str] = None,
                 ssl_mode: Optional[str] = None,
                 ssl_pfs: Optional[str] = None,
                 ssl_send_empty_frags: Optional[str] = None,
                 ssl_server_certificate: Optional[str] = None,
                 status: Optional[str] = None,
                 strict_register: Optional[str] = None,
                 subscribe_rate: Optional[int] = None,
                 subscribe_rate_track: Optional[str] = None,
                 unknown_header: Optional[str] = None,
                 update_rate: Optional[int] = None,
                 update_rate_track: Optional[str] = None):
        """
        :param int ack_rate: ACK request rate limit (per second, per policy).
        :param str ack_rate_track: Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        :param str block_ack: Enable/disable block ACK requests. Valid values: `disable`, `enable`.
        :param str block_bye: Enable/disable block BYE requests. Valid values: `disable`, `enable`.
        :param str block_cancel: Enable/disable block CANCEL requests. Valid values: `disable`, `enable`.
        :param str block_geo_red_options: Enable/disable block OPTIONS requests, but OPTIONS requests still notify for redundancy. Valid values: `disable`, `enable`.
        :param str block_info: Enable/disable block INFO requests. Valid values: `disable`, `enable`.
        :param str block_invite: Enable/disable block INVITE requests. Valid values: `disable`, `enable`.
        :param str block_long_lines: Enable/disable block requests with headers exceeding max-line-length. Valid values: `disable`, `enable`.
        :param str block_message: Enable/disable block MESSAGE requests. Valid values: `disable`, `enable`.
        :param str block_notify: Enable/disable block NOTIFY requests. Valid values: `disable`, `enable`.
        :param str block_options: Enable/disable block OPTIONS requests and no OPTIONS as notifying message for redundancy either. Valid values: `disable`, `enable`.
        :param str block_prack: Enable/disable block prack requests. Valid values: `disable`, `enable`.
        :param str block_publish: Enable/disable block PUBLISH requests. Valid values: `disable`, `enable`.
        :param str block_refer: Enable/disable block REFER requests. Valid values: `disable`, `enable`.
        :param str block_register: Enable/disable block REGISTER requests. Valid values: `disable`, `enable`.
        :param str block_subscribe: Enable/disable block SUBSCRIBE requests. Valid values: `disable`, `enable`.
        :param str block_unknown: Block unrecognized SIP requests (enabled by default). Valid values: `disable`, `enable`.
        :param str block_update: Enable/disable block UPDATE requests. Valid values: `disable`, `enable`.
        :param int bye_rate: BYE request rate limit (per second, per policy).
        :param str bye_rate_track: Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        :param str call_id_regex: Validate PCRE regular expression for Call-Id header value.
        :param int call_keepalive: Continue tracking calls with no RTP for this many minutes.
        :param int cancel_rate: CANCEL request rate limit (per second, per policy).
        :param str cancel_rate_track: Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        :param str contact_fixup: Fixup contact anyway even if contact's IP:port doesn't match session's IP:port. Valid values: `disable`, `enable`.
        :param str content_type_regex: Validate PCRE regular expression for Content-Type header value.
        :param str hnt_restrict_source_ip: Enable/disable restrict RTP source IP to be the same as SIP source IP when HNT is enabled. Valid values: `disable`, `enable`.
        :param str hosted_nat_traversal: Hosted NAT Traversal (HNT). Valid values: `disable`, `enable`.
        :param int info_rate: INFO request rate limit (per second, per policy).
        :param str info_rate_track: Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        :param int invite_rate: INVITE request rate limit (per second, per policy).
        :param str invite_rate_track: Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        :param str ips_rtp: Enable/disable allow IPS on RTP. Valid values: `disable`, `enable`.
        :param str log_call_summary: Enable/disable logging of SIP call summary. Valid values: `disable`, `enable`.
        :param str log_violations: Enable/disable logging of SIP violations. Valid values: `disable`, `enable`.
        :param str malformed_header_allow: Action for malformed Allow header. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_call_id: Action for malformed Call-ID header. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_contact: Action for malformed Contact header. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_content_length: Action for malformed Content-Length header. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_content_type: Action for malformed Content-Type header. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_cseq: Action for malformed CSeq header. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_expires: Action for malformed Expires header. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_from: Action for malformed From header. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_max_forwards: Action for malformed Max-Forwards header. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_no_proxy_require: Action for malformed SIP messages without Proxy-Require header. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_no_require: Action for malformed SIP messages without Require header. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_passerted_identity: Action for malformed P-Asserted-Identity header. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_rack: Action for malformed RAck header. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_record_route: Action for malformed Record-Route header. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_route: Action for malformed Route header. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_rseq: Action for malformed RSeq header. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_sdp_a: Action for malformed SDP a line. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_sdp_b: Action for malformed SDP b line. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_sdp_c: Action for malformed SDP c line. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_sdp_i: Action for malformed SDP i line. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_sdp_k: Action for malformed SDP k line. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_sdp_m: Action for malformed SDP m line. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_sdp_o: Action for malformed SDP o line. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_sdp_r: Action for malformed SDP r line. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_sdp_s: Action for malformed SDP s line. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_sdp_t: Action for malformed SDP t line. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_sdp_v: Action for malformed SDP v line. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_sdp_z: Action for malformed SDP z line. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_to: Action for malformed To header. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_header_via: Action for malformed VIA header. Valid values: `discard`, `pass`, `respond`.
        :param str malformed_request_line: Action for malformed request line. Valid values: `discard`, `pass`, `respond`.
        :param int max_body_length: Maximum SIP message body length (0 meaning no limit).
        :param int max_dialogs: Maximum number of concurrent calls/dialogs (per policy).
        :param int max_idle_dialogs: Maximum number established but idle dialogs to retain (per policy).
        :param int max_line_length: Maximum SIP header line length (78-4096).
        :param int message_rate: MESSAGE request rate limit (per second, per policy).
        :param str message_rate_track: Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        :param str nat_port_range: RTP NAT port range.
        :param str nat_trace: Enable/disable preservation of original IP in SDP i line. Valid values: `disable`, `enable`.
        :param str no_sdp_fixup: Enable/disable no SDP fix-up. Valid values: `disable`, `enable`.
        :param int notify_rate: NOTIFY request rate limit (per second, per policy).
        :param str notify_rate_track: Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        :param str open_contact_pinhole: Enable/disable open pinhole for non-REGISTER Contact port. Valid values: `disable`, `enable`.
        :param str open_record_route_pinhole: Enable/disable open pinhole for Record-Route port. Valid values: `disable`, `enable`.
        :param str open_register_pinhole: Enable/disable open pinhole for REGISTER Contact port. Valid values: `disable`, `enable`.
        :param str open_via_pinhole: Enable/disable open pinhole for Via port. Valid values: `disable`, `enable`.
        :param int options_rate: OPTIONS request rate limit (per second, per policy).
        :param str options_rate_track: Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        :param int prack_rate: PRACK request rate limit (per second, per policy).
        :param str prack_rate_track: Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        :param str preserve_override: Override i line to preserve original IPS (default: append). Valid values: `disable`, `enable`.
        :param int provisional_invite_expiry_time: Expiry time for provisional INVITE (10 - 3600 sec).
        :param int publish_rate: PUBLISH request rate limit (per second, per policy).
        :param str publish_rate_track: Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        :param int refer_rate: REFER request rate limit (per second, per policy).
        :param str refer_rate_track: Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        :param str register_contact_trace: Enable/disable trace original IP/port within the contact header of REGISTER requests. Valid values: `disable`, `enable`.
        :param int register_rate: REGISTER request rate limit (per second, per policy).
        :param str register_rate_track: Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        :param str rfc2543_branch: Enable/disable support via branch compliant with RFC 2543. Valid values: `disable`, `enable`.
        :param str rtp: Enable/disable create pinholes for RTP traffic to traverse firewall. Valid values: `disable`, `enable`.
        :param str ssl_algorithm: Relative strength of encryption algorithms accepted in negotiation. Valid values: `high`, `medium`, `low`.
        :param str ssl_auth_client: Require a client certificate and authenticate it with the peer/peergrp.
        :param str ssl_auth_server: Authenticate the server's certificate with the peer/peergrp.
        :param str ssl_client_certificate: Name of Certificate to offer to server if requested.
        :param str ssl_client_renegotiation: Allow/block client renegotiation by server. Valid values: `allow`, `deny`, `secure`.
        :param str ssl_max_version: Highest SSL/TLS version to negotiate.
        :param str ssl_min_version: Lowest SSL/TLS version to negotiate.
        :param str ssl_mode: SSL/TLS mode for encryption & decryption of traffic. Valid values: `off`, `full`.
        :param str ssl_pfs: SSL Perfect Forward Secrecy. Valid values: `require`, `deny`, `allow`.
        :param str ssl_send_empty_frags: Send empty fragments to avoid attack on CBC IV (SSL 3.0 & TLS 1.0 only). Valid values: `enable`, `disable`.
        :param str ssl_server_certificate: Name of Certificate return to the client in every SSL connection.
        :param str status: Enable/disable SIP. Valid values: `disable`, `enable`.
        :param str strict_register: Enable/disable only allow the registrar to connect. Valid values: `disable`, `enable`.
        :param int subscribe_rate: SUBSCRIBE request rate limit (per second, per policy).
        :param str subscribe_rate_track: Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        :param str unknown_header: Action for unknown SIP header. Valid values: `discard`, `pass`, `respond`.
        :param int update_rate: UPDATE request rate limit (per second, per policy).
        :param str update_rate_track: Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        """
        if ack_rate is not None:
            pulumi.set(__self__, "ack_rate", ack_rate)
        if ack_rate_track is not None:
            pulumi.set(__self__, "ack_rate_track", ack_rate_track)
        if block_ack is not None:
            pulumi.set(__self__, "block_ack", block_ack)
        if block_bye is not None:
            pulumi.set(__self__, "block_bye", block_bye)
        if block_cancel is not None:
            pulumi.set(__self__, "block_cancel", block_cancel)
        if block_geo_red_options is not None:
            pulumi.set(__self__, "block_geo_red_options", block_geo_red_options)
        if block_info is not None:
            pulumi.set(__self__, "block_info", block_info)
        if block_invite is not None:
            pulumi.set(__self__, "block_invite", block_invite)
        if block_long_lines is not None:
            pulumi.set(__self__, "block_long_lines", block_long_lines)
        if block_message is not None:
            pulumi.set(__self__, "block_message", block_message)
        if block_notify is not None:
            pulumi.set(__self__, "block_notify", block_notify)
        if block_options is not None:
            pulumi.set(__self__, "block_options", block_options)
        if block_prack is not None:
            pulumi.set(__self__, "block_prack", block_prack)
        if block_publish is not None:
            pulumi.set(__self__, "block_publish", block_publish)
        if block_refer is not None:
            pulumi.set(__self__, "block_refer", block_refer)
        if block_register is not None:
            pulumi.set(__self__, "block_register", block_register)
        if block_subscribe is not None:
            pulumi.set(__self__, "block_subscribe", block_subscribe)
        if block_unknown is not None:
            pulumi.set(__self__, "block_unknown", block_unknown)
        if block_update is not None:
            pulumi.set(__self__, "block_update", block_update)
        if bye_rate is not None:
            pulumi.set(__self__, "bye_rate", bye_rate)
        if bye_rate_track is not None:
            pulumi.set(__self__, "bye_rate_track", bye_rate_track)
        if call_id_regex is not None:
            pulumi.set(__self__, "call_id_regex", call_id_regex)
        if call_keepalive is not None:
            pulumi.set(__self__, "call_keepalive", call_keepalive)
        if cancel_rate is not None:
            pulumi.set(__self__, "cancel_rate", cancel_rate)
        if cancel_rate_track is not None:
            pulumi.set(__self__, "cancel_rate_track", cancel_rate_track)
        if contact_fixup is not None:
            pulumi.set(__self__, "contact_fixup", contact_fixup)
        if content_type_regex is not None:
            pulumi.set(__self__, "content_type_regex", content_type_regex)
        if hnt_restrict_source_ip is not None:
            pulumi.set(__self__, "hnt_restrict_source_ip", hnt_restrict_source_ip)
        if hosted_nat_traversal is not None:
            pulumi.set(__self__, "hosted_nat_traversal", hosted_nat_traversal)
        if info_rate is not None:
            pulumi.set(__self__, "info_rate", info_rate)
        if info_rate_track is not None:
            pulumi.set(__self__, "info_rate_track", info_rate_track)
        if invite_rate is not None:
            pulumi.set(__self__, "invite_rate", invite_rate)
        if invite_rate_track is not None:
            pulumi.set(__self__, "invite_rate_track", invite_rate_track)
        if ips_rtp is not None:
            pulumi.set(__self__, "ips_rtp", ips_rtp)
        if log_call_summary is not None:
            pulumi.set(__self__, "log_call_summary", log_call_summary)
        if log_violations is not None:
            pulumi.set(__self__, "log_violations", log_violations)
        if malformed_header_allow is not None:
            pulumi.set(__self__, "malformed_header_allow", malformed_header_allow)
        if malformed_header_call_id is not None:
            pulumi.set(__self__, "malformed_header_call_id", malformed_header_call_id)
        if malformed_header_contact is not None:
            pulumi.set(__self__, "malformed_header_contact", malformed_header_contact)
        if malformed_header_content_length is not None:
            pulumi.set(__self__, "malformed_header_content_length", malformed_header_content_length)
        if malformed_header_content_type is not None:
            pulumi.set(__self__, "malformed_header_content_type", malformed_header_content_type)
        if malformed_header_cseq is not None:
            pulumi.set(__self__, "malformed_header_cseq", malformed_header_cseq)
        if malformed_header_expires is not None:
            pulumi.set(__self__, "malformed_header_expires", malformed_header_expires)
        if malformed_header_from is not None:
            pulumi.set(__self__, "malformed_header_from", malformed_header_from)
        if malformed_header_max_forwards is not None:
            pulumi.set(__self__, "malformed_header_max_forwards", malformed_header_max_forwards)
        if malformed_header_no_proxy_require is not None:
            pulumi.set(__self__, "malformed_header_no_proxy_require", malformed_header_no_proxy_require)
        if malformed_header_no_require is not None:
            pulumi.set(__self__, "malformed_header_no_require", malformed_header_no_require)
        if malformed_header_passerted_identity is not None:
            pulumi.set(__self__, "malformed_header_passerted_identity", malformed_header_passerted_identity)
        if malformed_header_rack is not None:
            pulumi.set(__self__, "malformed_header_rack", malformed_header_rack)
        if malformed_header_record_route is not None:
            pulumi.set(__self__, "malformed_header_record_route", malformed_header_record_route)
        if malformed_header_route is not None:
            pulumi.set(__self__, "malformed_header_route", malformed_header_route)
        if malformed_header_rseq is not None:
            pulumi.set(__self__, "malformed_header_rseq", malformed_header_rseq)
        if malformed_header_sdp_a is not None:
            pulumi.set(__self__, "malformed_header_sdp_a", malformed_header_sdp_a)
        if malformed_header_sdp_b is not None:
            pulumi.set(__self__, "malformed_header_sdp_b", malformed_header_sdp_b)
        if malformed_header_sdp_c is not None:
            pulumi.set(__self__, "malformed_header_sdp_c", malformed_header_sdp_c)
        if malformed_header_sdp_i is not None:
            pulumi.set(__self__, "malformed_header_sdp_i", malformed_header_sdp_i)
        if malformed_header_sdp_k is not None:
            pulumi.set(__self__, "malformed_header_sdp_k", malformed_header_sdp_k)
        if malformed_header_sdp_m is not None:
            pulumi.set(__self__, "malformed_header_sdp_m", malformed_header_sdp_m)
        if malformed_header_sdp_o is not None:
            pulumi.set(__self__, "malformed_header_sdp_o", malformed_header_sdp_o)
        if malformed_header_sdp_r is not None:
            pulumi.set(__self__, "malformed_header_sdp_r", malformed_header_sdp_r)
        if malformed_header_sdp_s is not None:
            pulumi.set(__self__, "malformed_header_sdp_s", malformed_header_sdp_s)
        if malformed_header_sdp_t is not None:
            pulumi.set(__self__, "malformed_header_sdp_t", malformed_header_sdp_t)
        if malformed_header_sdp_v is not None:
            pulumi.set(__self__, "malformed_header_sdp_v", malformed_header_sdp_v)
        if malformed_header_sdp_z is not None:
            pulumi.set(__self__, "malformed_header_sdp_z", malformed_header_sdp_z)
        if malformed_header_to is not None:
            pulumi.set(__self__, "malformed_header_to", malformed_header_to)
        if malformed_header_via is not None:
            pulumi.set(__self__, "malformed_header_via", malformed_header_via)
        if malformed_request_line is not None:
            pulumi.set(__self__, "malformed_request_line", malformed_request_line)
        if max_body_length is not None:
            pulumi.set(__self__, "max_body_length", max_body_length)
        if max_dialogs is not None:
            pulumi.set(__self__, "max_dialogs", max_dialogs)
        if max_idle_dialogs is not None:
            pulumi.set(__self__, "max_idle_dialogs", max_idle_dialogs)
        if max_line_length is not None:
            pulumi.set(__self__, "max_line_length", max_line_length)
        if message_rate is not None:
            pulumi.set(__self__, "message_rate", message_rate)
        if message_rate_track is not None:
            pulumi.set(__self__, "message_rate_track", message_rate_track)
        if nat_port_range is not None:
            pulumi.set(__self__, "nat_port_range", nat_port_range)
        if nat_trace is not None:
            pulumi.set(__self__, "nat_trace", nat_trace)
        if no_sdp_fixup is not None:
            pulumi.set(__self__, "no_sdp_fixup", no_sdp_fixup)
        if notify_rate is not None:
            pulumi.set(__self__, "notify_rate", notify_rate)
        if notify_rate_track is not None:
            pulumi.set(__self__, "notify_rate_track", notify_rate_track)
        if open_contact_pinhole is not None:
            pulumi.set(__self__, "open_contact_pinhole", open_contact_pinhole)
        if open_record_route_pinhole is not None:
            pulumi.set(__self__, "open_record_route_pinhole", open_record_route_pinhole)
        if open_register_pinhole is not None:
            pulumi.set(__self__, "open_register_pinhole", open_register_pinhole)
        if open_via_pinhole is not None:
            pulumi.set(__self__, "open_via_pinhole", open_via_pinhole)
        if options_rate is not None:
            pulumi.set(__self__, "options_rate", options_rate)
        if options_rate_track is not None:
            pulumi.set(__self__, "options_rate_track", options_rate_track)
        if prack_rate is not None:
            pulumi.set(__self__, "prack_rate", prack_rate)
        if prack_rate_track is not None:
            pulumi.set(__self__, "prack_rate_track", prack_rate_track)
        if preserve_override is not None:
            pulumi.set(__self__, "preserve_override", preserve_override)
        if provisional_invite_expiry_time is not None:
            pulumi.set(__self__, "provisional_invite_expiry_time", provisional_invite_expiry_time)
        if publish_rate is not None:
            pulumi.set(__self__, "publish_rate", publish_rate)
        if publish_rate_track is not None:
            pulumi.set(__self__, "publish_rate_track", publish_rate_track)
        if refer_rate is not None:
            pulumi.set(__self__, "refer_rate", refer_rate)
        if refer_rate_track is not None:
            pulumi.set(__self__, "refer_rate_track", refer_rate_track)
        if register_contact_trace is not None:
            pulumi.set(__self__, "register_contact_trace", register_contact_trace)
        if register_rate is not None:
            pulumi.set(__self__, "register_rate", register_rate)
        if register_rate_track is not None:
            pulumi.set(__self__, "register_rate_track", register_rate_track)
        if rfc2543_branch is not None:
            pulumi.set(__self__, "rfc2543_branch", rfc2543_branch)
        if rtp is not None:
            pulumi.set(__self__, "rtp", rtp)
        if ssl_algorithm is not None:
            pulumi.set(__self__, "ssl_algorithm", ssl_algorithm)
        if ssl_auth_client is not None:
            pulumi.set(__self__, "ssl_auth_client", ssl_auth_client)
        if ssl_auth_server is not None:
            pulumi.set(__self__, "ssl_auth_server", ssl_auth_server)
        if ssl_client_certificate is not None:
            pulumi.set(__self__, "ssl_client_certificate", ssl_client_certificate)
        if ssl_client_renegotiation is not None:
            pulumi.set(__self__, "ssl_client_renegotiation", ssl_client_renegotiation)
        if ssl_max_version is not None:
            pulumi.set(__self__, "ssl_max_version", ssl_max_version)
        if ssl_min_version is not None:
            pulumi.set(__self__, "ssl_min_version", ssl_min_version)
        if ssl_mode is not None:
            pulumi.set(__self__, "ssl_mode", ssl_mode)
        if ssl_pfs is not None:
            pulumi.set(__self__, "ssl_pfs", ssl_pfs)
        if ssl_send_empty_frags is not None:
            pulumi.set(__self__, "ssl_send_empty_frags", ssl_send_empty_frags)
        if ssl_server_certificate is not None:
            pulumi.set(__self__, "ssl_server_certificate", ssl_server_certificate)
        if status is not None:
            pulumi.set(__self__, "status", status)
        if strict_register is not None:
            pulumi.set(__self__, "strict_register", strict_register)
        if subscribe_rate is not None:
            pulumi.set(__self__, "subscribe_rate", subscribe_rate)
        if subscribe_rate_track is not None:
            pulumi.set(__self__, "subscribe_rate_track", subscribe_rate_track)
        if unknown_header is not None:
            pulumi.set(__self__, "unknown_header", unknown_header)
        if update_rate is not None:
            pulumi.set(__self__, "update_rate", update_rate)
        if update_rate_track is not None:
            pulumi.set(__self__, "update_rate_track", update_rate_track)

    @property
    @pulumi.getter(name="ackRate")
    def ack_rate(self) -> Optional[int]:
        """
        ACK request rate limit (per second, per policy).
        """
        return pulumi.get(self, "ack_rate")

    @property
    @pulumi.getter(name="ackRateTrack")
    def ack_rate_track(self) -> Optional[str]:
        """
        Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        """
        return pulumi.get(self, "ack_rate_track")

    @property
    @pulumi.getter(name="blockAck")
    def block_ack(self) -> Optional[str]:
        """
        Enable/disable block ACK requests. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "block_ack")

    @property
    @pulumi.getter(name="blockBye")
    def block_bye(self) -> Optional[str]:
        """
        Enable/disable block BYE requests. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "block_bye")

    @property
    @pulumi.getter(name="blockCancel")
    def block_cancel(self) -> Optional[str]:
        """
        Enable/disable block CANCEL requests. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "block_cancel")

    @property
    @pulumi.getter(name="blockGeoRedOptions")
    def block_geo_red_options(self) -> Optional[str]:
        """
        Enable/disable block OPTIONS requests, but OPTIONS requests still notify for redundancy. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "block_geo_red_options")

    @property
    @pulumi.getter(name="blockInfo")
    def block_info(self) -> Optional[str]:
        """
        Enable/disable block INFO requests. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "block_info")

    @property
    @pulumi.getter(name="blockInvite")
    def block_invite(self) -> Optional[str]:
        """
        Enable/disable block INVITE requests. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "block_invite")

    @property
    @pulumi.getter(name="blockLongLines")
    def block_long_lines(self) -> Optional[str]:
        """
        Enable/disable block requests with headers exceeding max-line-length. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "block_long_lines")

    @property
    @pulumi.getter(name="blockMessage")
    def block_message(self) -> Optional[str]:
        """
        Enable/disable block MESSAGE requests. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "block_message")

    @property
    @pulumi.getter(name="blockNotify")
    def block_notify(self) -> Optional[str]:
        """
        Enable/disable block NOTIFY requests. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "block_notify")

    @property
    @pulumi.getter(name="blockOptions")
    def block_options(self) -> Optional[str]:
        """
        Enable/disable block OPTIONS requests and no OPTIONS as notifying message for redundancy either. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "block_options")

    @property
    @pulumi.getter(name="blockPrack")
    def block_prack(self) -> Optional[str]:
        """
        Enable/disable block prack requests. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "block_prack")

    @property
    @pulumi.getter(name="blockPublish")
    def block_publish(self) -> Optional[str]:
        """
        Enable/disable block PUBLISH requests. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "block_publish")

    @property
    @pulumi.getter(name="blockRefer")
    def block_refer(self) -> Optional[str]:
        """
        Enable/disable block REFER requests. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "block_refer")

    @property
    @pulumi.getter(name="blockRegister")
    def block_register(self) -> Optional[str]:
        """
        Enable/disable block REGISTER requests. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "block_register")

    @property
    @pulumi.getter(name="blockSubscribe")
    def block_subscribe(self) -> Optional[str]:
        """
        Enable/disable block SUBSCRIBE requests. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "block_subscribe")

    @property
    @pulumi.getter(name="blockUnknown")
    def block_unknown(self) -> Optional[str]:
        """
        Block unrecognized SIP requests (enabled by default). Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "block_unknown")

    @property
    @pulumi.getter(name="blockUpdate")
    def block_update(self) -> Optional[str]:
        """
        Enable/disable block UPDATE requests. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "block_update")

    @property
    @pulumi.getter(name="byeRate")
    def bye_rate(self) -> Optional[int]:
        """
        BYE request rate limit (per second, per policy).
        """
        return pulumi.get(self, "bye_rate")

    @property
    @pulumi.getter(name="byeRateTrack")
    def bye_rate_track(self) -> Optional[str]:
        """
        Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        """
        return pulumi.get(self, "bye_rate_track")

    @property
    @pulumi.getter(name="callIdRegex")
    def call_id_regex(self) -> Optional[str]:
        """
        Validate PCRE regular expression for Call-Id header value.
        """
        return pulumi.get(self, "call_id_regex")

    @property
    @pulumi.getter(name="callKeepalive")
    def call_keepalive(self) -> Optional[int]:
        """
        Continue tracking calls with no RTP for this many minutes.
        """
        return pulumi.get(self, "call_keepalive")

    @property
    @pulumi.getter(name="cancelRate")
    def cancel_rate(self) -> Optional[int]:
        """
        CANCEL request rate limit (per second, per policy).
        """
        return pulumi.get(self, "cancel_rate")

    @property
    @pulumi.getter(name="cancelRateTrack")
    def cancel_rate_track(self) -> Optional[str]:
        """
        Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        """
        return pulumi.get(self, "cancel_rate_track")

    @property
    @pulumi.getter(name="contactFixup")
    def contact_fixup(self) -> Optional[str]:
        """
        Fixup contact anyway even if contact's IP:port doesn't match session's IP:port. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "contact_fixup")

    @property
    @pulumi.getter(name="contentTypeRegex")
    def content_type_regex(self) -> Optional[str]:
        """
        Validate PCRE regular expression for Content-Type header value.
        """
        return pulumi.get(self, "content_type_regex")

    @property
    @pulumi.getter(name="hntRestrictSourceIp")
    def hnt_restrict_source_ip(self) -> Optional[str]:
        """
        Enable/disable restrict RTP source IP to be the same as SIP source IP when HNT is enabled. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "hnt_restrict_source_ip")

    @property
    @pulumi.getter(name="hostedNatTraversal")
    def hosted_nat_traversal(self) -> Optional[str]:
        """
        Hosted NAT Traversal (HNT). Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "hosted_nat_traversal")

    @property
    @pulumi.getter(name="infoRate")
    def info_rate(self) -> Optional[int]:
        """
        INFO request rate limit (per second, per policy).
        """
        return pulumi.get(self, "info_rate")

    @property
    @pulumi.getter(name="infoRateTrack")
    def info_rate_track(self) -> Optional[str]:
        """
        Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        """
        return pulumi.get(self, "info_rate_track")

    @property
    @pulumi.getter(name="inviteRate")
    def invite_rate(self) -> Optional[int]:
        """
        INVITE request rate limit (per second, per policy).
        """
        return pulumi.get(self, "invite_rate")

    @property
    @pulumi.getter(name="inviteRateTrack")
    def invite_rate_track(self) -> Optional[str]:
        """
        Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        """
        return pulumi.get(self, "invite_rate_track")

    @property
    @pulumi.getter(name="ipsRtp")
    def ips_rtp(self) -> Optional[str]:
        """
        Enable/disable allow IPS on RTP. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "ips_rtp")

    @property
    @pulumi.getter(name="logCallSummary")
    def log_call_summary(self) -> Optional[str]:
        """
        Enable/disable logging of SIP call summary. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "log_call_summary")

    @property
    @pulumi.getter(name="logViolations")
    def log_violations(self) -> Optional[str]:
        """
        Enable/disable logging of SIP violations. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "log_violations")

    @property
    @pulumi.getter(name="malformedHeaderAllow")
    def malformed_header_allow(self) -> Optional[str]:
        """
        Action for malformed Allow header. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_allow")

    @property
    @pulumi.getter(name="malformedHeaderCallId")
    def malformed_header_call_id(self) -> Optional[str]:
        """
        Action for malformed Call-ID header. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_call_id")

    @property
    @pulumi.getter(name="malformedHeaderContact")
    def malformed_header_contact(self) -> Optional[str]:
        """
        Action for malformed Contact header. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_contact")

    @property
    @pulumi.getter(name="malformedHeaderContentLength")
    def malformed_header_content_length(self) -> Optional[str]:
        """
        Action for malformed Content-Length header. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_content_length")

    @property
    @pulumi.getter(name="malformedHeaderContentType")
    def malformed_header_content_type(self) -> Optional[str]:
        """
        Action for malformed Content-Type header. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_content_type")

    @property
    @pulumi.getter(name="malformedHeaderCseq")
    def malformed_header_cseq(self) -> Optional[str]:
        """
        Action for malformed CSeq header. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_cseq")

    @property
    @pulumi.getter(name="malformedHeaderExpires")
    def malformed_header_expires(self) -> Optional[str]:
        """
        Action for malformed Expires header. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_expires")

    @property
    @pulumi.getter(name="malformedHeaderFrom")
    def malformed_header_from(self) -> Optional[str]:
        """
        Action for malformed From header. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_from")

    @property
    @pulumi.getter(name="malformedHeaderMaxForwards")
    def malformed_header_max_forwards(self) -> Optional[str]:
        """
        Action for malformed Max-Forwards header. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_max_forwards")

    @property
    @pulumi.getter(name="malformedHeaderNoProxyRequire")
    def malformed_header_no_proxy_require(self) -> Optional[str]:
        """
        Action for malformed SIP messages without Proxy-Require header. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_no_proxy_require")

    @property
    @pulumi.getter(name="malformedHeaderNoRequire")
    def malformed_header_no_require(self) -> Optional[str]:
        """
        Action for malformed SIP messages without Require header. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_no_require")

    @property
    @pulumi.getter(name="malformedHeaderPAssertedIdentity")
    def malformed_header_passerted_identity(self) -> Optional[str]:
        """
        Action for malformed P-Asserted-Identity header. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_passerted_identity")

    @property
    @pulumi.getter(name="malformedHeaderRack")
    def malformed_header_rack(self) -> Optional[str]:
        """
        Action for malformed RAck header. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_rack")

    @property
    @pulumi.getter(name="malformedHeaderRecordRoute")
    def malformed_header_record_route(self) -> Optional[str]:
        """
        Action for malformed Record-Route header. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_record_route")

    @property
    @pulumi.getter(name="malformedHeaderRoute")
    def malformed_header_route(self) -> Optional[str]:
        """
        Action for malformed Route header. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_route")

    @property
    @pulumi.getter(name="malformedHeaderRseq")
    def malformed_header_rseq(self) -> Optional[str]:
        """
        Action for malformed RSeq header. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_rseq")

    @property
    @pulumi.getter(name="malformedHeaderSdpA")
    def malformed_header_sdp_a(self) -> Optional[str]:
        """
        Action for malformed SDP a line. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_sdp_a")

    @property
    @pulumi.getter(name="malformedHeaderSdpB")
    def malformed_header_sdp_b(self) -> Optional[str]:
        """
        Action for malformed SDP b line. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_sdp_b")

    @property
    @pulumi.getter(name="malformedHeaderSdpC")
    def malformed_header_sdp_c(self) -> Optional[str]:
        """
        Action for malformed SDP c line. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_sdp_c")

    @property
    @pulumi.getter(name="malformedHeaderSdpI")
    def malformed_header_sdp_i(self) -> Optional[str]:
        """
        Action for malformed SDP i line. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_sdp_i")

    @property
    @pulumi.getter(name="malformedHeaderSdpK")
    def malformed_header_sdp_k(self) -> Optional[str]:
        """
        Action for malformed SDP k line. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_sdp_k")

    @property
    @pulumi.getter(name="malformedHeaderSdpM")
    def malformed_header_sdp_m(self) -> Optional[str]:
        """
        Action for malformed SDP m line. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_sdp_m")

    @property
    @pulumi.getter(name="malformedHeaderSdpO")
    def malformed_header_sdp_o(self) -> Optional[str]:
        """
        Action for malformed SDP o line. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_sdp_o")

    @property
    @pulumi.getter(name="malformedHeaderSdpR")
    def malformed_header_sdp_r(self) -> Optional[str]:
        """
        Action for malformed SDP r line. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_sdp_r")

    @property
    @pulumi.getter(name="malformedHeaderSdpS")
    def malformed_header_sdp_s(self) -> Optional[str]:
        """
        Action for malformed SDP s line. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_sdp_s")

    @property
    @pulumi.getter(name="malformedHeaderSdpT")
    def malformed_header_sdp_t(self) -> Optional[str]:
        """
        Action for malformed SDP t line. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_sdp_t")

    @property
    @pulumi.getter(name="malformedHeaderSdpV")
    def malformed_header_sdp_v(self) -> Optional[str]:
        """
        Action for malformed SDP v line. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_sdp_v")

    @property
    @pulumi.getter(name="malformedHeaderSdpZ")
    def malformed_header_sdp_z(self) -> Optional[str]:
        """
        Action for malformed SDP z line. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_sdp_z")

    @property
    @pulumi.getter(name="malformedHeaderTo")
    def malformed_header_to(self) -> Optional[str]:
        """
        Action for malformed To header. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_to")

    @property
    @pulumi.getter(name="malformedHeaderVia")
    def malformed_header_via(self) -> Optional[str]:
        """
        Action for malformed VIA header. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_header_via")

    @property
    @pulumi.getter(name="malformedRequestLine")
    def malformed_request_line(self) -> Optional[str]:
        """
        Action for malformed request line. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "malformed_request_line")

    @property
    @pulumi.getter(name="maxBodyLength")
    def max_body_length(self) -> Optional[int]:
        """
        Maximum SIP message body length (0 meaning no limit).
        """
        return pulumi.get(self, "max_body_length")

    @property
    @pulumi.getter(name="maxDialogs")
    def max_dialogs(self) -> Optional[int]:
        """
        Maximum number of concurrent calls/dialogs (per policy).
        """
        return pulumi.get(self, "max_dialogs")

    @property
    @pulumi.getter(name="maxIdleDialogs")
    def max_idle_dialogs(self) -> Optional[int]:
        """
        Maximum number established but idle dialogs to retain (per policy).
        """
        return pulumi.get(self, "max_idle_dialogs")

    @property
    @pulumi.getter(name="maxLineLength")
    def max_line_length(self) -> Optional[int]:
        """
        Maximum SIP header line length (78-4096).
        """
        return pulumi.get(self, "max_line_length")

    @property
    @pulumi.getter(name="messageRate")
    def message_rate(self) -> Optional[int]:
        """
        MESSAGE request rate limit (per second, per policy).
        """
        return pulumi.get(self, "message_rate")

    @property
    @pulumi.getter(name="messageRateTrack")
    def message_rate_track(self) -> Optional[str]:
        """
        Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        """
        return pulumi.get(self, "message_rate_track")

    @property
    @pulumi.getter(name="natPortRange")
    def nat_port_range(self) -> Optional[str]:
        """
        RTP NAT port range.
        """
        return pulumi.get(self, "nat_port_range")

    @property
    @pulumi.getter(name="natTrace")
    def nat_trace(self) -> Optional[str]:
        """
        Enable/disable preservation of original IP in SDP i line. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "nat_trace")

    @property
    @pulumi.getter(name="noSdpFixup")
    def no_sdp_fixup(self) -> Optional[str]:
        """
        Enable/disable no SDP fix-up. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "no_sdp_fixup")

    @property
    @pulumi.getter(name="notifyRate")
    def notify_rate(self) -> Optional[int]:
        """
        NOTIFY request rate limit (per second, per policy).
        """
        return pulumi.get(self, "notify_rate")

    @property
    @pulumi.getter(name="notifyRateTrack")
    def notify_rate_track(self) -> Optional[str]:
        """
        Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        """
        return pulumi.get(self, "notify_rate_track")

    @property
    @pulumi.getter(name="openContactPinhole")
    def open_contact_pinhole(self) -> Optional[str]:
        """
        Enable/disable open pinhole for non-REGISTER Contact port. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "open_contact_pinhole")

    @property
    @pulumi.getter(name="openRecordRoutePinhole")
    def open_record_route_pinhole(self) -> Optional[str]:
        """
        Enable/disable open pinhole for Record-Route port. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "open_record_route_pinhole")

    @property
    @pulumi.getter(name="openRegisterPinhole")
    def open_register_pinhole(self) -> Optional[str]:
        """
        Enable/disable open pinhole for REGISTER Contact port. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "open_register_pinhole")

    @property
    @pulumi.getter(name="openViaPinhole")
    def open_via_pinhole(self) -> Optional[str]:
        """
        Enable/disable open pinhole for Via port. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "open_via_pinhole")

    @property
    @pulumi.getter(name="optionsRate")
    def options_rate(self) -> Optional[int]:
        """
        OPTIONS request rate limit (per second, per policy).
        """
        return pulumi.get(self, "options_rate")

    @property
    @pulumi.getter(name="optionsRateTrack")
    def options_rate_track(self) -> Optional[str]:
        """
        Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        """
        return pulumi.get(self, "options_rate_track")

    @property
    @pulumi.getter(name="prackRate")
    def prack_rate(self) -> Optional[int]:
        """
        PRACK request rate limit (per second, per policy).
        """
        return pulumi.get(self, "prack_rate")

    @property
    @pulumi.getter(name="prackRateTrack")
    def prack_rate_track(self) -> Optional[str]:
        """
        Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        """
        return pulumi.get(self, "prack_rate_track")

    @property
    @pulumi.getter(name="preserveOverride")
    def preserve_override(self) -> Optional[str]:
        """
        Override i line to preserve original IPS (default: append). Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "preserve_override")

    @property
    @pulumi.getter(name="provisionalInviteExpiryTime")
    def provisional_invite_expiry_time(self) -> Optional[int]:
        """
        Expiry time for provisional INVITE (10 - 3600 sec).
        """
        return pulumi.get(self, "provisional_invite_expiry_time")

    @property
    @pulumi.getter(name="publishRate")
    def publish_rate(self) -> Optional[int]:
        """
        PUBLISH request rate limit (per second, per policy).
        """
        return pulumi.get(self, "publish_rate")

    @property
    @pulumi.getter(name="publishRateTrack")
    def publish_rate_track(self) -> Optional[str]:
        """
        Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        """
        return pulumi.get(self, "publish_rate_track")

    @property
    @pulumi.getter(name="referRate")
    def refer_rate(self) -> Optional[int]:
        """
        REFER request rate limit (per second, per policy).
        """
        return pulumi.get(self, "refer_rate")

    @property
    @pulumi.getter(name="referRateTrack")
    def refer_rate_track(self) -> Optional[str]:
        """
        Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        """
        return pulumi.get(self, "refer_rate_track")

    @property
    @pulumi.getter(name="registerContactTrace")
    def register_contact_trace(self) -> Optional[str]:
        """
        Enable/disable trace original IP/port within the contact header of REGISTER requests. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "register_contact_trace")

    @property
    @pulumi.getter(name="registerRate")
    def register_rate(self) -> Optional[int]:
        """
        REGISTER request rate limit (per second, per policy).
        """
        return pulumi.get(self, "register_rate")

    @property
    @pulumi.getter(name="registerRateTrack")
    def register_rate_track(self) -> Optional[str]:
        """
        Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        """
        return pulumi.get(self, "register_rate_track")

    @property
    @pulumi.getter(name="rfc2543Branch")
    def rfc2543_branch(self) -> Optional[str]:
        """
        Enable/disable support via branch compliant with RFC 2543. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "rfc2543_branch")

    @property
    @pulumi.getter
    def rtp(self) -> Optional[str]:
        """
        Enable/disable create pinholes for RTP traffic to traverse firewall. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "rtp")

    @property
    @pulumi.getter(name="sslAlgorithm")
    def ssl_algorithm(self) -> Optional[str]:
        """
        Relative strength of encryption algorithms accepted in negotiation. Valid values: `high`, `medium`, `low`.
        """
        return pulumi.get(self, "ssl_algorithm")

    @property
    @pulumi.getter(name="sslAuthClient")
    def ssl_auth_client(self) -> Optional[str]:
        """
        Require a client certificate and authenticate it with the peer/peergrp.
        """
        return pulumi.get(self, "ssl_auth_client")

    @property
    @pulumi.getter(name="sslAuthServer")
    def ssl_auth_server(self) -> Optional[str]:
        """
        Authenticate the server's certificate with the peer/peergrp.
        """
        return pulumi.get(self, "ssl_auth_server")

    @property
    @pulumi.getter(name="sslClientCertificate")
    def ssl_client_certificate(self) -> Optional[str]:
        """
        Name of Certificate to offer to server if requested.
        """
        return pulumi.get(self, "ssl_client_certificate")

    @property
    @pulumi.getter(name="sslClientRenegotiation")
    def ssl_client_renegotiation(self) -> Optional[str]:
        """
        Allow/block client renegotiation by server. Valid values: `allow`, `deny`, `secure`.
        """
        return pulumi.get(self, "ssl_client_renegotiation")

    @property
    @pulumi.getter(name="sslMaxVersion")
    def ssl_max_version(self) -> Optional[str]:
        """
        Highest SSL/TLS version to negotiate.
        """
        return pulumi.get(self, "ssl_max_version")

    @property
    @pulumi.getter(name="sslMinVersion")
    def ssl_min_version(self) -> Optional[str]:
        """
        Lowest SSL/TLS version to negotiate.
        """
        return pulumi.get(self, "ssl_min_version")

    @property
    @pulumi.getter(name="sslMode")
    def ssl_mode(self) -> Optional[str]:
        """
        SSL/TLS mode for encryption & decryption of traffic. Valid values: `off`, `full`.
        """
        return pulumi.get(self, "ssl_mode")

    @property
    @pulumi.getter(name="sslPfs")
    def ssl_pfs(self) -> Optional[str]:
        """
        SSL Perfect Forward Secrecy. Valid values: `require`, `deny`, `allow`.
        """
        return pulumi.get(self, "ssl_pfs")

    @property
    @pulumi.getter(name="sslSendEmptyFrags")
    def ssl_send_empty_frags(self) -> Optional[str]:
        """
        Send empty fragments to avoid attack on CBC IV (SSL 3.0 & TLS 1.0 only). Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "ssl_send_empty_frags")

    @property
    @pulumi.getter(name="sslServerCertificate")
    def ssl_server_certificate(self) -> Optional[str]:
        """
        Name of Certificate return to the client in every SSL connection.
        """
        return pulumi.get(self, "ssl_server_certificate")

    @property
    @pulumi.getter
    def status(self) -> Optional[str]:
        """
        Enable/disable SIP. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "status")

    @property
    @pulumi.getter(name="strictRegister")
    def strict_register(self) -> Optional[str]:
        """
        Enable/disable only allow the registrar to connect. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "strict_register")

    @property
    @pulumi.getter(name="subscribeRate")
    def subscribe_rate(self) -> Optional[int]:
        """
        SUBSCRIBE request rate limit (per second, per policy).
        """
        return pulumi.get(self, "subscribe_rate")

    @property
    @pulumi.getter(name="subscribeRateTrack")
    def subscribe_rate_track(self) -> Optional[str]:
        """
        Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        """
        return pulumi.get(self, "subscribe_rate_track")

    @property
    @pulumi.getter(name="unknownHeader")
    def unknown_header(self) -> Optional[str]:
        """
        Action for unknown SIP header. Valid values: `discard`, `pass`, `respond`.
        """
        return pulumi.get(self, "unknown_header")

    @property
    @pulumi.getter(name="updateRate")
    def update_rate(self) -> Optional[int]:
        """
        UPDATE request rate limit (per second, per policy).
        """
        return pulumi.get(self, "update_rate")

    @property
    @pulumi.getter(name="updateRateTrack")
    def update_rate_track(self) -> Optional[str]:
        """
        Track the packet protocol field. Valid values: `none`, `src-ip`, `dest-ip`.
        """
        return pulumi.get(self, "update_rate_track")


