# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from ... import _utilities

__all__ = [
    'SettingCrlVerification',
]

@pulumi.output_type
class SettingCrlVerification(dict):
    @staticmethod
    def __key_warning(key: str):
        suggest = None
        if key == "chainCrlAbsence":
            suggest = "chain_crl_absence"
        elif key == "leafCrlAbsence":
            suggest = "leaf_crl_absence"

        if suggest:
            pulumi.log.warn(f"Key '{key}' not found in SettingCrlVerification. Access the value via the '{suggest}' property getter instead.")

    def __getitem__(self, key: str) -> Any:
        SettingCrlVerification.__key_warning(key)
        return super().__getitem__(key)

    def get(self, key: str, default = None) -> Any:
        SettingCrlVerification.__key_warning(key)
        return super().get(key, default)

    def __init__(__self__, *,
                 chain_crl_absence: Optional[str] = None,
                 expiry: Optional[str] = None,
                 leaf_crl_absence: Optional[str] = None):
        """
        :param str chain_crl_absence: CRL verification option when CRL of any certificate in chain is absent (default = ignore). Valid values: `ignore`, `revoke`.
        :param str expiry: CRL verification option when CRL is expired (default = ignore). Valid values: `ignore`, `revoke`.
        :param str leaf_crl_absence: CRL verification option when leaf CRL is absent (default = ignore). Valid values: `ignore`, `revoke`.
        """
        if chain_crl_absence is not None:
            pulumi.set(__self__, "chain_crl_absence", chain_crl_absence)
        if expiry is not None:
            pulumi.set(__self__, "expiry", expiry)
        if leaf_crl_absence is not None:
            pulumi.set(__self__, "leaf_crl_absence", leaf_crl_absence)

    @property
    @pulumi.getter(name="chainCrlAbsence")
    def chain_crl_absence(self) -> Optional[str]:
        """
        CRL verification option when CRL of any certificate in chain is absent (default = ignore). Valid values: `ignore`, `revoke`.
        """
        return pulumi.get(self, "chain_crl_absence")

    @property
    @pulumi.getter
    def expiry(self) -> Optional[str]:
        """
        CRL verification option when CRL is expired (default = ignore). Valid values: `ignore`, `revoke`.
        """
        return pulumi.get(self, "expiry")

    @property
    @pulumi.getter(name="leafCrlAbsence")
    def leaf_crl_absence(self) -> Optional[str]:
        """
        CRL verification option when leaf CRL is absent (default = ignore). Valid values: `ignore`, `revoke`.
        """
        return pulumi.get(self, "leaf_crl_absence")


