# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['ProfileArgs', 'Profile']

@pulumi.input_type
class ProfileArgs:
    def __init__(__self__, *,
                 address_list: Optional[pulumi.Input['ProfileAddressListArgs']] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 constraint: Optional[pulumi.Input['ProfileConstraintArgs']] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 extended_log: Optional[pulumi.Input[str]] = None,
                 external: Optional[pulumi.Input[str]] = None,
                 get_all_tables: Optional[pulumi.Input[str]] = None,
                 method: Optional[pulumi.Input['ProfileMethodArgs']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 signature: Optional[pulumi.Input['ProfileSignatureArgs']] = None,
                 url_accesses: Optional[pulumi.Input[Sequence[pulumi.Input['ProfileUrlAccessArgs']]]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Profile resource.
        :param pulumi.Input['ProfileAddressListArgs'] address_list: Black address list and white address list. The structure of `address_list` block is documented below.
        :param pulumi.Input[str] comment: Comment.
        :param pulumi.Input['ProfileConstraintArgs'] constraint: WAF HTTP protocol restrictions. The structure of `constraint` block is documented below.
        :param pulumi.Input[str] dynamic_sort_subtable: Sort sub-tables, please do not set this parameter when configuring static sub-tables. Options: [ false, true, natural, alphabetical ]. false: Default value, do not sort tables; true/natural: sort tables in natural order. For example: [ a10, a2 ] -> [ a2, a10 ]; alphabetical: sort tables in alphabetical order. For example: [ a10, a2 ] -> [ a10, a2 ].
        :param pulumi.Input[str] extended_log: Enable/disable extended logging. Valid values: `enable`, `disable`.
        :param pulumi.Input[str] external: Disable/Enable external HTTP Inspection. Valid values: `disable`, `enable`.
        :param pulumi.Input[str] get_all_tables: Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        :param pulumi.Input['ProfileMethodArgs'] method: Method restriction. The structure of `method` block is documented below.
        :param pulumi.Input[str] name: WAF Profile name.
        :param pulumi.Input['ProfileSignatureArgs'] signature: WAF signatures. The structure of `signature` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input['ProfileUrlAccessArgs']]] url_accesses: URL access list The structure of `url_access` block is documented below.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        if address_list is not None:
            pulumi.set(__self__, "address_list", address_list)
        if comment is not None:
            pulumi.set(__self__, "comment", comment)
        if constraint is not None:
            pulumi.set(__self__, "constraint", constraint)
        if dynamic_sort_subtable is not None:
            pulumi.set(__self__, "dynamic_sort_subtable", dynamic_sort_subtable)
        if extended_log is not None:
            pulumi.set(__self__, "extended_log", extended_log)
        if external is not None:
            pulumi.set(__self__, "external", external)
        if get_all_tables is not None:
            pulumi.set(__self__, "get_all_tables", get_all_tables)
        if method is not None:
            pulumi.set(__self__, "method", method)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if signature is not None:
            pulumi.set(__self__, "signature", signature)
        if url_accesses is not None:
            pulumi.set(__self__, "url_accesses", url_accesses)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter(name="addressList")
    def address_list(self) -> Optional[pulumi.Input['ProfileAddressListArgs']]:
        """
        Black address list and white address list. The structure of `address_list` block is documented below.
        """
        return pulumi.get(self, "address_list")

    @address_list.setter
    def address_list(self, value: Optional[pulumi.Input['ProfileAddressListArgs']]):
        pulumi.set(self, "address_list", value)

    @property
    @pulumi.getter
    def comment(self) -> Optional[pulumi.Input[str]]:
        """
        Comment.
        """
        return pulumi.get(self, "comment")

    @comment.setter
    def comment(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "comment", value)

    @property
    @pulumi.getter
    def constraint(self) -> Optional[pulumi.Input['ProfileConstraintArgs']]:
        """
        WAF HTTP protocol restrictions. The structure of `constraint` block is documented below.
        """
        return pulumi.get(self, "constraint")

    @constraint.setter
    def constraint(self, value: Optional[pulumi.Input['ProfileConstraintArgs']]):
        pulumi.set(self, "constraint", value)

    @property
    @pulumi.getter(name="dynamicSortSubtable")
    def dynamic_sort_subtable(self) -> Optional[pulumi.Input[str]]:
        """
        Sort sub-tables, please do not set this parameter when configuring static sub-tables. Options: [ false, true, natural, alphabetical ]. false: Default value, do not sort tables; true/natural: sort tables in natural order. For example: [ a10, a2 ] -> [ a2, a10 ]; alphabetical: sort tables in alphabetical order. For example: [ a10, a2 ] -> [ a10, a2 ].
        """
        return pulumi.get(self, "dynamic_sort_subtable")

    @dynamic_sort_subtable.setter
    def dynamic_sort_subtable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dynamic_sort_subtable", value)

    @property
    @pulumi.getter(name="extendedLog")
    def extended_log(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable extended logging. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "extended_log")

    @extended_log.setter
    def extended_log(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "extended_log", value)

    @property
    @pulumi.getter
    def external(self) -> Optional[pulumi.Input[str]]:
        """
        Disable/Enable external HTTP Inspection. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "external")

    @external.setter
    def external(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "external", value)

    @property
    @pulumi.getter(name="getAllTables")
    def get_all_tables(self) -> Optional[pulumi.Input[str]]:
        """
        Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        """
        return pulumi.get(self, "get_all_tables")

    @get_all_tables.setter
    def get_all_tables(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "get_all_tables", value)

    @property
    @pulumi.getter
    def method(self) -> Optional[pulumi.Input['ProfileMethodArgs']]:
        """
        Method restriction. The structure of `method` block is documented below.
        """
        return pulumi.get(self, "method")

    @method.setter
    def method(self, value: Optional[pulumi.Input['ProfileMethodArgs']]):
        pulumi.set(self, "method", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        WAF Profile name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def signature(self) -> Optional[pulumi.Input['ProfileSignatureArgs']]:
        """
        WAF signatures. The structure of `signature` block is documented below.
        """
        return pulumi.get(self, "signature")

    @signature.setter
    def signature(self, value: Optional[pulumi.Input['ProfileSignatureArgs']]):
        pulumi.set(self, "signature", value)

    @property
    @pulumi.getter(name="urlAccesses")
    def url_accesses(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ProfileUrlAccessArgs']]]]:
        """
        URL access list The structure of `url_access` block is documented below.
        """
        return pulumi.get(self, "url_accesses")

    @url_accesses.setter
    def url_accesses(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ProfileUrlAccessArgs']]]]):
        pulumi.set(self, "url_accesses", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)


@pulumi.input_type
class _ProfileState:
    def __init__(__self__, *,
                 address_list: Optional[pulumi.Input['ProfileAddressListArgs']] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 constraint: Optional[pulumi.Input['ProfileConstraintArgs']] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 extended_log: Optional[pulumi.Input[str]] = None,
                 external: Optional[pulumi.Input[str]] = None,
                 get_all_tables: Optional[pulumi.Input[str]] = None,
                 method: Optional[pulumi.Input['ProfileMethodArgs']] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 signature: Optional[pulumi.Input['ProfileSignatureArgs']] = None,
                 url_accesses: Optional[pulumi.Input[Sequence[pulumi.Input['ProfileUrlAccessArgs']]]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Profile resources.
        :param pulumi.Input['ProfileAddressListArgs'] address_list: Black address list and white address list. The structure of `address_list` block is documented below.
        :param pulumi.Input[str] comment: Comment.
        :param pulumi.Input['ProfileConstraintArgs'] constraint: WAF HTTP protocol restrictions. The structure of `constraint` block is documented below.
        :param pulumi.Input[str] dynamic_sort_subtable: Sort sub-tables, please do not set this parameter when configuring static sub-tables. Options: [ false, true, natural, alphabetical ]. false: Default value, do not sort tables; true/natural: sort tables in natural order. For example: [ a10, a2 ] -> [ a2, a10 ]; alphabetical: sort tables in alphabetical order. For example: [ a10, a2 ] -> [ a10, a2 ].
        :param pulumi.Input[str] extended_log: Enable/disable extended logging. Valid values: `enable`, `disable`.
        :param pulumi.Input[str] external: Disable/Enable external HTTP Inspection. Valid values: `disable`, `enable`.
        :param pulumi.Input[str] get_all_tables: Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        :param pulumi.Input['ProfileMethodArgs'] method: Method restriction. The structure of `method` block is documented below.
        :param pulumi.Input[str] name: WAF Profile name.
        :param pulumi.Input['ProfileSignatureArgs'] signature: WAF signatures. The structure of `signature` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input['ProfileUrlAccessArgs']]] url_accesses: URL access list The structure of `url_access` block is documented below.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        if address_list is not None:
            pulumi.set(__self__, "address_list", address_list)
        if comment is not None:
            pulumi.set(__self__, "comment", comment)
        if constraint is not None:
            pulumi.set(__self__, "constraint", constraint)
        if dynamic_sort_subtable is not None:
            pulumi.set(__self__, "dynamic_sort_subtable", dynamic_sort_subtable)
        if extended_log is not None:
            pulumi.set(__self__, "extended_log", extended_log)
        if external is not None:
            pulumi.set(__self__, "external", external)
        if get_all_tables is not None:
            pulumi.set(__self__, "get_all_tables", get_all_tables)
        if method is not None:
            pulumi.set(__self__, "method", method)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if signature is not None:
            pulumi.set(__self__, "signature", signature)
        if url_accesses is not None:
            pulumi.set(__self__, "url_accesses", url_accesses)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter(name="addressList")
    def address_list(self) -> Optional[pulumi.Input['ProfileAddressListArgs']]:
        """
        Black address list and white address list. The structure of `address_list` block is documented below.
        """
        return pulumi.get(self, "address_list")

    @address_list.setter
    def address_list(self, value: Optional[pulumi.Input['ProfileAddressListArgs']]):
        pulumi.set(self, "address_list", value)

    @property
    @pulumi.getter
    def comment(self) -> Optional[pulumi.Input[str]]:
        """
        Comment.
        """
        return pulumi.get(self, "comment")

    @comment.setter
    def comment(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "comment", value)

    @property
    @pulumi.getter
    def constraint(self) -> Optional[pulumi.Input['ProfileConstraintArgs']]:
        """
        WAF HTTP protocol restrictions. The structure of `constraint` block is documented below.
        """
        return pulumi.get(self, "constraint")

    @constraint.setter
    def constraint(self, value: Optional[pulumi.Input['ProfileConstraintArgs']]):
        pulumi.set(self, "constraint", value)

    @property
    @pulumi.getter(name="dynamicSortSubtable")
    def dynamic_sort_subtable(self) -> Optional[pulumi.Input[str]]:
        """
        Sort sub-tables, please do not set this parameter when configuring static sub-tables. Options: [ false, true, natural, alphabetical ]. false: Default value, do not sort tables; true/natural: sort tables in natural order. For example: [ a10, a2 ] -> [ a2, a10 ]; alphabetical: sort tables in alphabetical order. For example: [ a10, a2 ] -> [ a10, a2 ].
        """
        return pulumi.get(self, "dynamic_sort_subtable")

    @dynamic_sort_subtable.setter
    def dynamic_sort_subtable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dynamic_sort_subtable", value)

    @property
    @pulumi.getter(name="extendedLog")
    def extended_log(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable extended logging. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "extended_log")

    @extended_log.setter
    def extended_log(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "extended_log", value)

    @property
    @pulumi.getter
    def external(self) -> Optional[pulumi.Input[str]]:
        """
        Disable/Enable external HTTP Inspection. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "external")

    @external.setter
    def external(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "external", value)

    @property
    @pulumi.getter(name="getAllTables")
    def get_all_tables(self) -> Optional[pulumi.Input[str]]:
        """
        Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        """
        return pulumi.get(self, "get_all_tables")

    @get_all_tables.setter
    def get_all_tables(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "get_all_tables", value)

    @property
    @pulumi.getter
    def method(self) -> Optional[pulumi.Input['ProfileMethodArgs']]:
        """
        Method restriction. The structure of `method` block is documented below.
        """
        return pulumi.get(self, "method")

    @method.setter
    def method(self, value: Optional[pulumi.Input['ProfileMethodArgs']]):
        pulumi.set(self, "method", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        WAF Profile name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def signature(self) -> Optional[pulumi.Input['ProfileSignatureArgs']]:
        """
        WAF signatures. The structure of `signature` block is documented below.
        """
        return pulumi.get(self, "signature")

    @signature.setter
    def signature(self, value: Optional[pulumi.Input['ProfileSignatureArgs']]):
        pulumi.set(self, "signature", value)

    @property
    @pulumi.getter(name="urlAccesses")
    def url_accesses(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['ProfileUrlAccessArgs']]]]:
        """
        URL access list The structure of `url_access` block is documented below.
        """
        return pulumi.get(self, "url_accesses")

    @url_accesses.setter
    def url_accesses(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['ProfileUrlAccessArgs']]]]):
        pulumi.set(self, "url_accesses", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)


class Profile(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 address_list: Optional[pulumi.Input[pulumi.InputType['ProfileAddressListArgs']]] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 constraint: Optional[pulumi.Input[pulumi.InputType['ProfileConstraintArgs']]] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 extended_log: Optional[pulumi.Input[str]] = None,
                 external: Optional[pulumi.Input[str]] = None,
                 get_all_tables: Optional[pulumi.Input[str]] = None,
                 method: Optional[pulumi.Input[pulumi.InputType['ProfileMethodArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 signature: Optional[pulumi.Input[pulumi.InputType['ProfileSignatureArgs']]] = None,
                 url_accesses: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProfileUrlAccessArgs']]]]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Web application firewall configuration.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_fortios as fortios

        trname = fortios.waf.Profile("trname",
            extended_log="disable",
            external="disable")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        Waf Profile can be imported using any of these accepted formats:

        ```sh
        $ pulumi import fortios:waf/profile:Profile labelname {{name}}
        ```

        If you do not want to import arguments of block:

        $ export "FORTIOS_IMPORT_TABLE"="false"

        ```sh
        $ pulumi import fortios:waf/profile:Profile labelname {{name}}
        ```

        $ unset "FORTIOS_IMPORT_TABLE"

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['ProfileAddressListArgs']] address_list: Black address list and white address list. The structure of `address_list` block is documented below.
        :param pulumi.Input[str] comment: Comment.
        :param pulumi.Input[pulumi.InputType['ProfileConstraintArgs']] constraint: WAF HTTP protocol restrictions. The structure of `constraint` block is documented below.
        :param pulumi.Input[str] dynamic_sort_subtable: Sort sub-tables, please do not set this parameter when configuring static sub-tables. Options: [ false, true, natural, alphabetical ]. false: Default value, do not sort tables; true/natural: sort tables in natural order. For example: [ a10, a2 ] -> [ a2, a10 ]; alphabetical: sort tables in alphabetical order. For example: [ a10, a2 ] -> [ a10, a2 ].
        :param pulumi.Input[str] extended_log: Enable/disable extended logging. Valid values: `enable`, `disable`.
        :param pulumi.Input[str] external: Disable/Enable external HTTP Inspection. Valid values: `disable`, `enable`.
        :param pulumi.Input[str] get_all_tables: Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        :param pulumi.Input[pulumi.InputType['ProfileMethodArgs']] method: Method restriction. The structure of `method` block is documented below.
        :param pulumi.Input[str] name: WAF Profile name.
        :param pulumi.Input[pulumi.InputType['ProfileSignatureArgs']] signature: WAF signatures. The structure of `signature` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProfileUrlAccessArgs']]]] url_accesses: URL access list The structure of `url_access` block is documented below.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[ProfileArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Web application firewall configuration.

        ## Example Usage

        <!--Start PulumiCodeChooser -->
        ```python
        import pulumi
        import pulumiverse_fortios as fortios

        trname = fortios.waf.Profile("trname",
            extended_log="disable",
            external="disable")
        ```
        <!--End PulumiCodeChooser -->

        ## Import

        Waf Profile can be imported using any of these accepted formats:

        ```sh
        $ pulumi import fortios:waf/profile:Profile labelname {{name}}
        ```

        If you do not want to import arguments of block:

        $ export "FORTIOS_IMPORT_TABLE"="false"

        ```sh
        $ pulumi import fortios:waf/profile:Profile labelname {{name}}
        ```

        $ unset "FORTIOS_IMPORT_TABLE"

        :param str resource_name: The name of the resource.
        :param ProfileArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(ProfileArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 address_list: Optional[pulumi.Input[pulumi.InputType['ProfileAddressListArgs']]] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 constraint: Optional[pulumi.Input[pulumi.InputType['ProfileConstraintArgs']]] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 extended_log: Optional[pulumi.Input[str]] = None,
                 external: Optional[pulumi.Input[str]] = None,
                 get_all_tables: Optional[pulumi.Input[str]] = None,
                 method: Optional[pulumi.Input[pulumi.InputType['ProfileMethodArgs']]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 signature: Optional[pulumi.Input[pulumi.InputType['ProfileSignatureArgs']]] = None,
                 url_accesses: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProfileUrlAccessArgs']]]]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = ProfileArgs.__new__(ProfileArgs)

            __props__.__dict__["address_list"] = address_list
            __props__.__dict__["comment"] = comment
            __props__.__dict__["constraint"] = constraint
            __props__.__dict__["dynamic_sort_subtable"] = dynamic_sort_subtable
            __props__.__dict__["extended_log"] = extended_log
            __props__.__dict__["external"] = external
            __props__.__dict__["get_all_tables"] = get_all_tables
            __props__.__dict__["method"] = method
            __props__.__dict__["name"] = name
            __props__.__dict__["signature"] = signature
            __props__.__dict__["url_accesses"] = url_accesses
            __props__.__dict__["vdomparam"] = vdomparam
        super(Profile, __self__).__init__(
            'fortios:waf/profile:Profile',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            address_list: Optional[pulumi.Input[pulumi.InputType['ProfileAddressListArgs']]] = None,
            comment: Optional[pulumi.Input[str]] = None,
            constraint: Optional[pulumi.Input[pulumi.InputType['ProfileConstraintArgs']]] = None,
            dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
            extended_log: Optional[pulumi.Input[str]] = None,
            external: Optional[pulumi.Input[str]] = None,
            get_all_tables: Optional[pulumi.Input[str]] = None,
            method: Optional[pulumi.Input[pulumi.InputType['ProfileMethodArgs']]] = None,
            name: Optional[pulumi.Input[str]] = None,
            signature: Optional[pulumi.Input[pulumi.InputType['ProfileSignatureArgs']]] = None,
            url_accesses: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProfileUrlAccessArgs']]]]] = None,
            vdomparam: Optional[pulumi.Input[str]] = None) -> 'Profile':
        """
        Get an existing Profile resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[pulumi.InputType['ProfileAddressListArgs']] address_list: Black address list and white address list. The structure of `address_list` block is documented below.
        :param pulumi.Input[str] comment: Comment.
        :param pulumi.Input[pulumi.InputType['ProfileConstraintArgs']] constraint: WAF HTTP protocol restrictions. The structure of `constraint` block is documented below.
        :param pulumi.Input[str] dynamic_sort_subtable: Sort sub-tables, please do not set this parameter when configuring static sub-tables. Options: [ false, true, natural, alphabetical ]. false: Default value, do not sort tables; true/natural: sort tables in natural order. For example: [ a10, a2 ] -> [ a2, a10 ]; alphabetical: sort tables in alphabetical order. For example: [ a10, a2 ] -> [ a10, a2 ].
        :param pulumi.Input[str] extended_log: Enable/disable extended logging. Valid values: `enable`, `disable`.
        :param pulumi.Input[str] external: Disable/Enable external HTTP Inspection. Valid values: `disable`, `enable`.
        :param pulumi.Input[str] get_all_tables: Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        :param pulumi.Input[pulumi.InputType['ProfileMethodArgs']] method: Method restriction. The structure of `method` block is documented below.
        :param pulumi.Input[str] name: WAF Profile name.
        :param pulumi.Input[pulumi.InputType['ProfileSignatureArgs']] signature: WAF signatures. The structure of `signature` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['ProfileUrlAccessArgs']]]] url_accesses: URL access list The structure of `url_access` block is documented below.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _ProfileState.__new__(_ProfileState)

        __props__.__dict__["address_list"] = address_list
        __props__.__dict__["comment"] = comment
        __props__.__dict__["constraint"] = constraint
        __props__.__dict__["dynamic_sort_subtable"] = dynamic_sort_subtable
        __props__.__dict__["extended_log"] = extended_log
        __props__.__dict__["external"] = external
        __props__.__dict__["get_all_tables"] = get_all_tables
        __props__.__dict__["method"] = method
        __props__.__dict__["name"] = name
        __props__.__dict__["signature"] = signature
        __props__.__dict__["url_accesses"] = url_accesses
        __props__.__dict__["vdomparam"] = vdomparam
        return Profile(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="addressList")
    def address_list(self) -> pulumi.Output['outputs.ProfileAddressList']:
        """
        Black address list and white address list. The structure of `address_list` block is documented below.
        """
        return pulumi.get(self, "address_list")

    @property
    @pulumi.getter
    def comment(self) -> pulumi.Output[Optional[str]]:
        """
        Comment.
        """
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter
    def constraint(self) -> pulumi.Output['outputs.ProfileConstraint']:
        """
        WAF HTTP protocol restrictions. The structure of `constraint` block is documented below.
        """
        return pulumi.get(self, "constraint")

    @property
    @pulumi.getter(name="dynamicSortSubtable")
    def dynamic_sort_subtable(self) -> pulumi.Output[Optional[str]]:
        """
        Sort sub-tables, please do not set this parameter when configuring static sub-tables. Options: [ false, true, natural, alphabetical ]. false: Default value, do not sort tables; true/natural: sort tables in natural order. For example: [ a10, a2 ] -> [ a2, a10 ]; alphabetical: sort tables in alphabetical order. For example: [ a10, a2 ] -> [ a10, a2 ].
        """
        return pulumi.get(self, "dynamic_sort_subtable")

    @property
    @pulumi.getter(name="extendedLog")
    def extended_log(self) -> pulumi.Output[str]:
        """
        Enable/disable extended logging. Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "extended_log")

    @property
    @pulumi.getter
    def external(self) -> pulumi.Output[str]:
        """
        Disable/Enable external HTTP Inspection. Valid values: `disable`, `enable`.
        """
        return pulumi.get(self, "external")

    @property
    @pulumi.getter(name="getAllTables")
    def get_all_tables(self) -> pulumi.Output[Optional[str]]:
        """
        Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        """
        return pulumi.get(self, "get_all_tables")

    @property
    @pulumi.getter
    def method(self) -> pulumi.Output['outputs.ProfileMethod']:
        """
        Method restriction. The structure of `method` block is documented below.
        """
        return pulumi.get(self, "method")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        WAF Profile name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def signature(self) -> pulumi.Output['outputs.ProfileSignature']:
        """
        WAF signatures. The structure of `signature` block is documented below.
        """
        return pulumi.get(self, "signature")

    @property
    @pulumi.getter(name="urlAccesses")
    def url_accesses(self) -> pulumi.Output[Optional[Sequence['outputs.ProfileUrlAccess']]]:
        """
        URL access list The structure of `url_access` block is documented below.
        """
        return pulumi.get(self, "url_accesses")

    @property
    @pulumi.getter
    def vdomparam(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

