# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['AccesscontrollistArgs', 'Accesscontrollist']

@pulumi.input_type
class AccesscontrollistArgs:
    def __init__(__self__, *,
                 comment: Optional[pulumi.Input[str]] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 get_all_tables: Optional[pulumi.Input[str]] = None,
                 layer3_ipv4_rules: Optional[pulumi.Input[Sequence[pulumi.Input['AccesscontrollistLayer3Ipv4RuleArgs']]]] = None,
                 layer3_ipv6_rules: Optional[pulumi.Input[Sequence[pulumi.Input['AccesscontrollistLayer3Ipv6RuleArgs']]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Accesscontrollist resource.
        :param pulumi.Input[str] comment: Description.
        :param pulumi.Input[str] dynamic_sort_subtable: Sort sub-tables, please do not set this parameter when configuring static sub-tables. Options: [ false, true, natural, alphabetical ]. false: Default value, do not sort tables; true/natural: sort tables in natural order. For example: [ a10, a2 ] -> [ a2, a10 ]; alphabetical: sort tables in alphabetical order. For example: [ a10, a2 ] -> [ a10, a2 ].
        :param pulumi.Input[str] get_all_tables: Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        :param pulumi.Input[Sequence[pulumi.Input['AccesscontrollistLayer3Ipv4RuleArgs']]] layer3_ipv4_rules: AP ACL layer3 ipv4 rule list. The structure of `layer3_ipv4_rules` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input['AccesscontrollistLayer3Ipv6RuleArgs']]] layer3_ipv6_rules: AP ACL layer3 ipv6 rule list. The structure of `layer3_ipv6_rules` block is documented below.
        :param pulumi.Input[str] name: AP access control list name.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
               
               The `layer3_ipv4_rules` block supports:
        """
        if comment is not None:
            pulumi.set(__self__, "comment", comment)
        if dynamic_sort_subtable is not None:
            pulumi.set(__self__, "dynamic_sort_subtable", dynamic_sort_subtable)
        if get_all_tables is not None:
            pulumi.set(__self__, "get_all_tables", get_all_tables)
        if layer3_ipv4_rules is not None:
            pulumi.set(__self__, "layer3_ipv4_rules", layer3_ipv4_rules)
        if layer3_ipv6_rules is not None:
            pulumi.set(__self__, "layer3_ipv6_rules", layer3_ipv6_rules)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter
    def comment(self) -> Optional[pulumi.Input[str]]:
        """
        Description.
        """
        return pulumi.get(self, "comment")

    @comment.setter
    def comment(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "comment", value)

    @property
    @pulumi.getter(name="dynamicSortSubtable")
    def dynamic_sort_subtable(self) -> Optional[pulumi.Input[str]]:
        """
        Sort sub-tables, please do not set this parameter when configuring static sub-tables. Options: [ false, true, natural, alphabetical ]. false: Default value, do not sort tables; true/natural: sort tables in natural order. For example: [ a10, a2 ] -> [ a2, a10 ]; alphabetical: sort tables in alphabetical order. For example: [ a10, a2 ] -> [ a10, a2 ].
        """
        return pulumi.get(self, "dynamic_sort_subtable")

    @dynamic_sort_subtable.setter
    def dynamic_sort_subtable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dynamic_sort_subtable", value)

    @property
    @pulumi.getter(name="getAllTables")
    def get_all_tables(self) -> Optional[pulumi.Input[str]]:
        """
        Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        """
        return pulumi.get(self, "get_all_tables")

    @get_all_tables.setter
    def get_all_tables(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "get_all_tables", value)

    @property
    @pulumi.getter(name="layer3Ipv4Rules")
    def layer3_ipv4_rules(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AccesscontrollistLayer3Ipv4RuleArgs']]]]:
        """
        AP ACL layer3 ipv4 rule list. The structure of `layer3_ipv4_rules` block is documented below.
        """
        return pulumi.get(self, "layer3_ipv4_rules")

    @layer3_ipv4_rules.setter
    def layer3_ipv4_rules(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AccesscontrollistLayer3Ipv4RuleArgs']]]]):
        pulumi.set(self, "layer3_ipv4_rules", value)

    @property
    @pulumi.getter(name="layer3Ipv6Rules")
    def layer3_ipv6_rules(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AccesscontrollistLayer3Ipv6RuleArgs']]]]:
        """
        AP ACL layer3 ipv6 rule list. The structure of `layer3_ipv6_rules` block is documented below.
        """
        return pulumi.get(self, "layer3_ipv6_rules")

    @layer3_ipv6_rules.setter
    def layer3_ipv6_rules(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AccesscontrollistLayer3Ipv6RuleArgs']]]]):
        pulumi.set(self, "layer3_ipv6_rules", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        AP access control list name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.

        The `layer3_ipv4_rules` block supports:
        """
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)


@pulumi.input_type
class _AccesscontrollistState:
    def __init__(__self__, *,
                 comment: Optional[pulumi.Input[str]] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 get_all_tables: Optional[pulumi.Input[str]] = None,
                 layer3_ipv4_rules: Optional[pulumi.Input[Sequence[pulumi.Input['AccesscontrollistLayer3Ipv4RuleArgs']]]] = None,
                 layer3_ipv6_rules: Optional[pulumi.Input[Sequence[pulumi.Input['AccesscontrollistLayer3Ipv6RuleArgs']]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Accesscontrollist resources.
        :param pulumi.Input[str] comment: Description.
        :param pulumi.Input[str] dynamic_sort_subtable: Sort sub-tables, please do not set this parameter when configuring static sub-tables. Options: [ false, true, natural, alphabetical ]. false: Default value, do not sort tables; true/natural: sort tables in natural order. For example: [ a10, a2 ] -> [ a2, a10 ]; alphabetical: sort tables in alphabetical order. For example: [ a10, a2 ] -> [ a10, a2 ].
        :param pulumi.Input[str] get_all_tables: Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        :param pulumi.Input[Sequence[pulumi.Input['AccesscontrollistLayer3Ipv4RuleArgs']]] layer3_ipv4_rules: AP ACL layer3 ipv4 rule list. The structure of `layer3_ipv4_rules` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input['AccesscontrollistLayer3Ipv6RuleArgs']]] layer3_ipv6_rules: AP ACL layer3 ipv6 rule list. The structure of `layer3_ipv6_rules` block is documented below.
        :param pulumi.Input[str] name: AP access control list name.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
               
               The `layer3_ipv4_rules` block supports:
        """
        if comment is not None:
            pulumi.set(__self__, "comment", comment)
        if dynamic_sort_subtable is not None:
            pulumi.set(__self__, "dynamic_sort_subtable", dynamic_sort_subtable)
        if get_all_tables is not None:
            pulumi.set(__self__, "get_all_tables", get_all_tables)
        if layer3_ipv4_rules is not None:
            pulumi.set(__self__, "layer3_ipv4_rules", layer3_ipv4_rules)
        if layer3_ipv6_rules is not None:
            pulumi.set(__self__, "layer3_ipv6_rules", layer3_ipv6_rules)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter
    def comment(self) -> Optional[pulumi.Input[str]]:
        """
        Description.
        """
        return pulumi.get(self, "comment")

    @comment.setter
    def comment(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "comment", value)

    @property
    @pulumi.getter(name="dynamicSortSubtable")
    def dynamic_sort_subtable(self) -> Optional[pulumi.Input[str]]:
        """
        Sort sub-tables, please do not set this parameter when configuring static sub-tables. Options: [ false, true, natural, alphabetical ]. false: Default value, do not sort tables; true/natural: sort tables in natural order. For example: [ a10, a2 ] -> [ a2, a10 ]; alphabetical: sort tables in alphabetical order. For example: [ a10, a2 ] -> [ a10, a2 ].
        """
        return pulumi.get(self, "dynamic_sort_subtable")

    @dynamic_sort_subtable.setter
    def dynamic_sort_subtable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dynamic_sort_subtable", value)

    @property
    @pulumi.getter(name="getAllTables")
    def get_all_tables(self) -> Optional[pulumi.Input[str]]:
        """
        Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        """
        return pulumi.get(self, "get_all_tables")

    @get_all_tables.setter
    def get_all_tables(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "get_all_tables", value)

    @property
    @pulumi.getter(name="layer3Ipv4Rules")
    def layer3_ipv4_rules(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AccesscontrollistLayer3Ipv4RuleArgs']]]]:
        """
        AP ACL layer3 ipv4 rule list. The structure of `layer3_ipv4_rules` block is documented below.
        """
        return pulumi.get(self, "layer3_ipv4_rules")

    @layer3_ipv4_rules.setter
    def layer3_ipv4_rules(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AccesscontrollistLayer3Ipv4RuleArgs']]]]):
        pulumi.set(self, "layer3_ipv4_rules", value)

    @property
    @pulumi.getter(name="layer3Ipv6Rules")
    def layer3_ipv6_rules(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['AccesscontrollistLayer3Ipv6RuleArgs']]]]:
        """
        AP ACL layer3 ipv6 rule list. The structure of `layer3_ipv6_rules` block is documented below.
        """
        return pulumi.get(self, "layer3_ipv6_rules")

    @layer3_ipv6_rules.setter
    def layer3_ipv6_rules(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['AccesscontrollistLayer3Ipv6RuleArgs']]]]):
        pulumi.set(self, "layer3_ipv6_rules", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        AP access control list name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.

        The `layer3_ipv4_rules` block supports:
        """
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)


class Accesscontrollist(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 get_all_tables: Optional[pulumi.Input[str]] = None,
                 layer3_ipv4_rules: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AccesscontrollistLayer3Ipv4RuleArgs']]]]] = None,
                 layer3_ipv6_rules: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AccesscontrollistLayer3Ipv6RuleArgs']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Configure WiFi bridge access control list. Applies to FortiOS Version `>= 6.4.0`.

        ## Import

        WirelessController AccessControlList can be imported using any of these accepted formats:

        ```sh
        $ pulumi import fortios:wirelesscontroller/accesscontrollist:Accesscontrollist labelname {{name}}
        ```

        If you do not want to import arguments of block:

        $ export "FORTIOS_IMPORT_TABLE"="false"

        ```sh
        $ pulumi import fortios:wirelesscontroller/accesscontrollist:Accesscontrollist labelname {{name}}
        ```

        $ unset "FORTIOS_IMPORT_TABLE"

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] comment: Description.
        :param pulumi.Input[str] dynamic_sort_subtable: Sort sub-tables, please do not set this parameter when configuring static sub-tables. Options: [ false, true, natural, alphabetical ]. false: Default value, do not sort tables; true/natural: sort tables in natural order. For example: [ a10, a2 ] -> [ a2, a10 ]; alphabetical: sort tables in alphabetical order. For example: [ a10, a2 ] -> [ a10, a2 ].
        :param pulumi.Input[str] get_all_tables: Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AccesscontrollistLayer3Ipv4RuleArgs']]]] layer3_ipv4_rules: AP ACL layer3 ipv4 rule list. The structure of `layer3_ipv4_rules` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AccesscontrollistLayer3Ipv6RuleArgs']]]] layer3_ipv6_rules: AP ACL layer3 ipv6 rule list. The structure of `layer3_ipv6_rules` block is documented below.
        :param pulumi.Input[str] name: AP access control list name.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
               
               The `layer3_ipv4_rules` block supports:
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[AccesscontrollistArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Configure WiFi bridge access control list. Applies to FortiOS Version `>= 6.4.0`.

        ## Import

        WirelessController AccessControlList can be imported using any of these accepted formats:

        ```sh
        $ pulumi import fortios:wirelesscontroller/accesscontrollist:Accesscontrollist labelname {{name}}
        ```

        If you do not want to import arguments of block:

        $ export "FORTIOS_IMPORT_TABLE"="false"

        ```sh
        $ pulumi import fortios:wirelesscontroller/accesscontrollist:Accesscontrollist labelname {{name}}
        ```

        $ unset "FORTIOS_IMPORT_TABLE"

        :param str resource_name: The name of the resource.
        :param AccesscontrollistArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(AccesscontrollistArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 comment: Optional[pulumi.Input[str]] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 get_all_tables: Optional[pulumi.Input[str]] = None,
                 layer3_ipv4_rules: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AccesscontrollistLayer3Ipv4RuleArgs']]]]] = None,
                 layer3_ipv6_rules: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AccesscontrollistLayer3Ipv6RuleArgs']]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = AccesscontrollistArgs.__new__(AccesscontrollistArgs)

            __props__.__dict__["comment"] = comment
            __props__.__dict__["dynamic_sort_subtable"] = dynamic_sort_subtable
            __props__.__dict__["get_all_tables"] = get_all_tables
            __props__.__dict__["layer3_ipv4_rules"] = layer3_ipv4_rules
            __props__.__dict__["layer3_ipv6_rules"] = layer3_ipv6_rules
            __props__.__dict__["name"] = name
            __props__.__dict__["vdomparam"] = vdomparam
        super(Accesscontrollist, __self__).__init__(
            'fortios:wirelesscontroller/accesscontrollist:Accesscontrollist',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            comment: Optional[pulumi.Input[str]] = None,
            dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
            get_all_tables: Optional[pulumi.Input[str]] = None,
            layer3_ipv4_rules: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AccesscontrollistLayer3Ipv4RuleArgs']]]]] = None,
            layer3_ipv6_rules: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AccesscontrollistLayer3Ipv6RuleArgs']]]]] = None,
            name: Optional[pulumi.Input[str]] = None,
            vdomparam: Optional[pulumi.Input[str]] = None) -> 'Accesscontrollist':
        """
        Get an existing Accesscontrollist resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] comment: Description.
        :param pulumi.Input[str] dynamic_sort_subtable: Sort sub-tables, please do not set this parameter when configuring static sub-tables. Options: [ false, true, natural, alphabetical ]. false: Default value, do not sort tables; true/natural: sort tables in natural order. For example: [ a10, a2 ] -> [ a2, a10 ]; alphabetical: sort tables in alphabetical order. For example: [ a10, a2 ] -> [ a10, a2 ].
        :param pulumi.Input[str] get_all_tables: Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AccesscontrollistLayer3Ipv4RuleArgs']]]] layer3_ipv4_rules: AP ACL layer3 ipv4 rule list. The structure of `layer3_ipv4_rules` block is documented below.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['AccesscontrollistLayer3Ipv6RuleArgs']]]] layer3_ipv6_rules: AP ACL layer3 ipv6 rule list. The structure of `layer3_ipv6_rules` block is documented below.
        :param pulumi.Input[str] name: AP access control list name.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
               
               The `layer3_ipv4_rules` block supports:
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _AccesscontrollistState.__new__(_AccesscontrollistState)

        __props__.__dict__["comment"] = comment
        __props__.__dict__["dynamic_sort_subtable"] = dynamic_sort_subtable
        __props__.__dict__["get_all_tables"] = get_all_tables
        __props__.__dict__["layer3_ipv4_rules"] = layer3_ipv4_rules
        __props__.__dict__["layer3_ipv6_rules"] = layer3_ipv6_rules
        __props__.__dict__["name"] = name
        __props__.__dict__["vdomparam"] = vdomparam
        return Accesscontrollist(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def comment(self) -> pulumi.Output[str]:
        """
        Description.
        """
        return pulumi.get(self, "comment")

    @property
    @pulumi.getter(name="dynamicSortSubtable")
    def dynamic_sort_subtable(self) -> pulumi.Output[Optional[str]]:
        """
        Sort sub-tables, please do not set this parameter when configuring static sub-tables. Options: [ false, true, natural, alphabetical ]. false: Default value, do not sort tables; true/natural: sort tables in natural order. For example: [ a10, a2 ] -> [ a2, a10 ]; alphabetical: sort tables in alphabetical order. For example: [ a10, a2 ] -> [ a10, a2 ].
        """
        return pulumi.get(self, "dynamic_sort_subtable")

    @property
    @pulumi.getter(name="getAllTables")
    def get_all_tables(self) -> pulumi.Output[Optional[str]]:
        """
        Get all sub-tables including unconfigured tables. Do not set this variable to true if you configure sub-table in another resource, otherwish conflicts and overwrite will occur. Options: [ false, true ]. false: Default value, do not get unconfigured tables; true: get all tables including unconfigured tables.
        """
        return pulumi.get(self, "get_all_tables")

    @property
    @pulumi.getter(name="layer3Ipv4Rules")
    def layer3_ipv4_rules(self) -> pulumi.Output[Optional[Sequence['outputs.AccesscontrollistLayer3Ipv4Rule']]]:
        """
        AP ACL layer3 ipv4 rule list. The structure of `layer3_ipv4_rules` block is documented below.
        """
        return pulumi.get(self, "layer3_ipv4_rules")

    @property
    @pulumi.getter(name="layer3Ipv6Rules")
    def layer3_ipv6_rules(self) -> pulumi.Output[Optional[Sequence['outputs.AccesscontrollistLayer3Ipv6Rule']]]:
        """
        AP ACL layer3 ipv6 rule list. The structure of `layer3_ipv6_rules` block is documented below.
        """
        return pulumi.get(self, "layer3_ipv6_rules")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        AP access control list name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def vdomparam(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.

        The `layer3_ipv4_rules` block supports:
        """
        return pulumi.get(self, "vdomparam")

